;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_Mesh_Create.pb
;// Erstellt am: 30.3.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info: 
;// Mesh Create Demo
;// Demo from @graphy
;//
;////////////////////////////////////////////////////////////////

Structure D3DXVector3
    x.f
    y.f
    z.f
EndStructure

Procedure MP_ChangeMeshcord(mesh) ; ndert die Coordinaten der Vertexe in Richt die das Mesh gedreht wurde

  Coord.D3DXVector3
  
  For n = 0 To MP_CountVertices(Mesh)-1 ; Anzahl der Vertices in dem Wrfel
    Coord\x = MP_VertexGetX(Mesh, n) ; X Wert auslesen
    Coord\y = MP_VertexGetY(Mesh, n) ; Y Wert auslesen
    Coord\z = MP_VertexGetZ(Mesh, n) ; Z Wert auslesen
    
    MP_TransformCoord(mesh, Coord) ; ndert eine Vector3d ber eine MeshMatrix
    
    MP_VertexSetX(Mesh, n, Coord\x) ; Wrfel X Achse um 0.5 verschoben ist daher 0 und andere Achse 1
    MP_VertexSetY(Mesh, n, Coord\y)      ;
    MP_VertexSetZ(Mesh, n, Coord\z) ; Wrfel Z Achse um 0.5 verschoben ist daher 0 und andere Achse 1
  Next

EndProcedure


MP_Graphics3D(800, 600, 32, 1)
MP_CreateLight(1)

cam0 = MP_CreateCamera()
MP_CameraSetRange(cam0, 4, 2048)
MP_PositionCamera(cam0, -16, 16, -32)
MP_CameraLookAt(cam0, 0, 0, 0)

cordx = MP_CreateMesh()
cordy = MP_CreateMesh()
cordz = MP_CreateMesh()

cyl0 = MP_CreateCylinder(10, 20)
MP_ScaleMesh(cyl0, 0.5, 0.5, 1)
MP_AddMesh(cyl0, cordz)
MP_FreeEntity(cyl0)

con0 = MP_CreateCone(10, 4)
MP_PositionMesh(con0, 0, 0, -12)
MP_AddMesh(con0, cordz)
MP_FreeEntity(con0)

con1 = MP_CreateCone(10, 4)
MP_RotateEntity(con1, 180, 0, 0)
MP_ChangeMeshcord(con1)
MP_PositionMesh(con1, 0, 0, 12)
MP_AddMesh(con1, cordz)
MP_FreeEntity(con1)

MP_AddMesh(cordz, cordx)
MP_RotateEntity(cordx, 90, 0, 0)
MP_AddMesh(cordz, cordy)
MP_RotateEntity(cordy, 90, 90, 0)

MP_EntitySetColor(cordx, MP_ARGB(255, 255, 0, 0))
MP_EntitySetColor(cordy, MP_ARGB(255, 0, 255, 0))
MP_EntitySetColor(cordz, MP_ARGB(255, 0,   0, 255))

xplus = MP_Create3DText("", "x+", 4)
MP_EntitySetColor(xplus, MP_ARGB(255, 255, 0, 0))
MP_PositionMesh(xplus, 5, 1, 0)

xminus = MP_Create3DText("", "x-", 4)
MP_EntitySetColor(xminus, MP_ARGB(255, 255, 0, 0))
MP_PositionMesh(xminus, -9, 1, 0)

yplus = MP_Create3DText("", "y+", 4)
MP_EntitySetColor(yplus, MP_ARGB(255, 0, 255, 0))
MP_PositionMesh(yplus, 1, 7, 0)

yminus = MP_Create3DText("", "y-", 4)
MP_EntitySetColor(yminus, MP_ARGB(255, 0, 255, 0))
MP_PositionMesh(yminus, 1, -8, 0)

zminus = MP_Create3DText("", "z-", 4)
MP_EntitySetColor(zminus, MP_ARGB(255, 0,   0, 255))
MP_PositionMesh(zminus, 5, 1, 0)
MP_RotateEntity(zminus, 90, 0, 0)

zplus = MP_Create3DText("", "z+", 4)
MP_EntitySetColor(zplus, MP_ARGB(255, 0,   0, 255))
MP_PositionMesh(zplus, -9, 1, 0)
MP_RotateEntity(zplus, 90, 0, 0)

;MP_SaveMesh("c:\text.x",cordz)

While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow
  
  MP_RenderWorld()
  MP_Flip()
  
Wend

;cyl0
;72 Vertices
;100 Triangles
;con0
;72 Vertices
;100 Triangles
;con1
;72 Vertices
;100 Triangles
;cordz
;217 Vertices
;301Triangles


; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 105
; FirstLine = 71
; Folding = -
; EnableXP
; Executable = \\Hh\Transfer\test.exe
; SubSystem = dx9