;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_PostProcess Noise.pb
;// Erstellt am: 26.2.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info:
;// XNA 12. PostProcess Noise Demo
;// http://digitalerr0r.wordpress.com/2009/04/22/xna-shader-programming-tutorial-12-post-process-noise/
;//
;//
;////////////////////////////////////////////////////////////////


Structure RGBAColor
  r.f; 0-1 are 0-255 For R color
  g.f; 0-1 are 0-255 for G color; 
  b.f; 0-1 are 0-255 for B color
  a.f; 0-1 are 0-255 for A color
EndStructure

Procedure ColorSet (*Pointer.RGBAColor,r,g,b,a) ; RGBA to Shadercolor
  *Pointer\r = r / 255
  *Pointer\g = g / 255
  *Pointer\b = b / 255
  *Pointer\a = a / 255
EndProcedure   
  
;- ProgrammStart

MP_Graphics3D (640,480,0,1) ; Creat ea PB Windows 
SetWindowTitle(0, "XNA 12. PostProcess Noise Demo, End with Esc, right mouse move mesh , mouse wheel distance") 

camera=MP_CreateCamera() ; Create a camera
MP_PositionCamera(Camera, 0, 0, -325) 

Light=MP_CreateLight(1) ; Light on 

Mesh=MP_LoadMesh("..\media\Object.X") ; Load a Mesh
ColorMap = MP_LoadTexture("..\media\ColorMap3.jpg") ;Load Texture for Mesh

;- Background
BgMap = MP_LoadTexture("..\media\Bg.jpg")
Surface = MP_TextureToSurface(BgMap) 
MP_SurfaceSetPosition(Surface,0,0,1)
;- End Background

Texture = MP_CreateBackBufferTexture() ; Texture for Postprocessing (fast texture)

;MP_UseCursor(0) ; Mauseoff

If ReadFile(0, "Shader.fx")   ; wenn die Datei geffnet werden konnte, setzen wir fort...
  While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
     Shader.s + ReadString(0) + Chr(10)      ; Zeile fr Zeile im Debugger-Fenster anzeigen
  Wend
  CloseFile(0)               
EndIf

If ReadFile(0, "PostProcess.fx")   ; wenn die Datei geffnet werden konnte, setzen wir fort...
  While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
     Shader2.s + ReadString(0) + Chr(10)      ; Zeile fr Zeile im Debugger-Fenster anzeigen
  Wend
  CloseFile(0)               
EndIf

; Shadertechnik
MyShader = MP_CreateMyShader (Shader)
MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
MP_ShaderSet_D3DMATRIX (MyShader,"matInverseWorld",MP_ShaderGetWorldI (Mesh))
MP_ShaderSet_Float3(MyShader,"vLightDirection",MP_ShaderGetLightDirection(Light) )


MP_ShaderSetTexture(MyShader,"ColorMap",ColorMap) 

MP_SetTechniqueMyShader (MyShader,"DiffuseShader")
MP_ShaderSetEntity  (MyShader,Mesh)


MyShader2 = MP_CreateMyShader( Shader2) ; Postprocessing


;MP_AmbientSetLight(RGB(72,61,139)) 


While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow; Esc abfrage oder Windows Schliessen

        ;- here comes the mousemesh control ; Hier kommt ein reine Mesh Maussteuerung
                
          RotX = 0 : RotY = 0
          MouseX = -MP_MouseDeltaX()/5
          MouseY = -MP_MouseDeltaY()/5   

          If MP_MouseButtonDown(1)

            RotX = MouseX
            RotY = MouseY
            MouseX = 0
            MouseY = 0
          EndIf
         
          If MP_MouseDeltaWheel() > 0
             KeyY.f = -4
          ElseIf  MP_MouseDeltaWheel() <0 
             KeyY.f =  4
          Else
             KeyY.f = 0
          EndIf
          
        ;- end of mousemesh control ; Ende der Maussteuerung

        MP_TurnEntity(Mesh, RotX, RotY, RollZ) ; Turn Entity
        MP_MoveCamera(Camera, 0, 0, KeyY) ; distance to camera
        
        MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
        MP_ShaderSet_D3DMATRIX (MyShader,"matInverseWorld",MP_ShaderGetWorldI (Mesh))
        
    MP_RenderWorld() ; Erstelle die Welt
    
    ;- Postprossesing
    fTimer.f  + 0.01;
    MP_ShaderSetVar_f(MyShader2,"fTimer",fTimer) 

    MP_ShaderSetVar_I(MyShader2,"iSeed",Random(1337)) 
    MP_ShaderSetVar_f(MyShader2,"fNoiseAmount",0.01) 
    
    MP_BackBufferToTexture (Texture)
    MP_ShaderSetTexture (MyShader2,"entSkin1",Texture)
    MP_SetTechniqueMyShader (MyShader2,"PostProcess")
    MP_UseBackbufferShader(Texture, MyShader2)
    MP_TextureToBackBuffer (Texture)
    ;- end Postprossesing
    
    MP_Flip () ; Stelle Sie dar

Wend
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 86
; FirstLine = 48
; Folding = -
; EnableXP
; SubSystem = dx9