;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_AlphaMap.pb
;// Erstellt am: 26.2.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info:
;// XNA 13. AlphaMap Demo
;// http://digitalerr0r.wordpress.com/2009/04/30/xna-shader-programming-tutorial-13-alpha-mapping/
;//
;//
;////////////////////////////////////////////////////////////////


Structure RGBAColor
  r.f; 0-1 are 0-255 For R color
  g.f; 0-1 are 0-255 for G color; 
  b.f; 0-1 are 0-255 for B color
  a.f; 0-1 are 0-255 for A color
EndStructure

Procedure ColorSet (*Pointer.RGBAColor,r,g,b,a) ; RGBA to Shadercolor
  *Pointer\r = r / 255
  *Pointer\g = g / 255
  *Pointer\b = b / 255
  *Pointer\a = a / 255
EndProcedure   
  
;- ProgrammStart

MP_Graphics3D (640,480,0,1) ; Creat ea PB Windows 
SetWindowTitle(0, "XNA 13. AlphaMap Demo, End with Esc, right mouse move mesh , mouse wheel distance") 

camera=MP_CreateCamera() ; Create a camera
MP_PositionCamera(Camera, 0, 0, -200) 

Light=MP_CreateLight(1) ; Light on 

Mesh = MP_CatchMeshX(?MyData1, ?MyData2 - ?MyData1) ; Load a Mesh
ColorMap = MP_CatchTexture(?MyData2, ?MyData3 - ?MyData2);Load Texture for Mesh
AlphaMap = MP_CatchTexture(?MyData3, ?MyData4 - ?MyData3) 


;- Background
BgMap = MP_CatchTexture(?MyData4, ?MyData5 - ?MyData4)
Surface = MP_TextureToSurface(BgMap) 
MP_SurfaceSetPosition(Surface,0,0,1)
;- End Background


;- Overlay
Overlay = MP_CatchTexture(?MyData5, ?MyData6 - ?MyData5) ; Textur with Alphacchannel 
sprite = MP_SpriteFromTexture(Overlay) 
;- End Overlay

Texture = MP_CreateBackBufferTexture() ; Texture for Postprocessing (fast texture)

;MP_UseCursor(0) ; Mauseoff

; Shadertechnik
MyShader = MP_CreateMyShader (PeekS(?MyData6, ?MyData7 - ?MyData6))
MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
MP_ShaderSet_D3DMATRIX (MyShader,"matInverseWorld",MP_ShaderGetWorldI (Mesh))
MP_ShaderSet_Float3(MyShader,"vLightDirection",MP_ShaderGetLightDirection(Light) )


MP_ShaderSetTexture(MyShader,"ColorMap",ColorMap) 
MP_ShaderSetTexture(MyShader,"AlphaMap",AlphaMap) 

MP_SetTechniqueMyShader (MyShader,"DiffuseShader")
MP_ShaderSetEntity  (MyShader,Mesh)

MyShader2 = MP_CreateMyShader (PeekS(?MyData7, ?MyData8 - ?MyData7)) ; Postprocessing

While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow; Esc abfrage oder Windows Schliessen

        ;- here comes the mousemesh control ; Hier kommt ein reine Mesh Maussteuerung
                
          RotX = 0 : RotY = 0
          MouseX = -MP_MouseDeltaX()/5
          MouseY = -MP_MouseDeltaY()/5   

          If MP_MouseButtonDown(1)

            RotX = MouseX
            RotY = MouseY
            MouseX = 0
            MouseY = 0
          EndIf
         
          If MP_MouseDeltaWheel() > 0
             KeyY.f = -4
          ElseIf  MP_MouseDeltaWheel() <0 
             KeyY.f =  4
          Else
             KeyY.f = 0
          EndIf
          
        ;- end of mousemesh control ; Ende der Maussteuerung

        MP_TurnEntity(Mesh, RotX, RotY, RollZ) ; Turn Entity
        MP_MoveCamera(Camera, 0, 0, KeyY) ; distance to camera
        
        MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
        MP_ShaderSet_D3DMATRIX (MyShader,"matInverseWorld",MP_ShaderGetWorldI (Mesh))
        
    MP_RenderWorld() ; Erstelle die Welt
    
    ;- Postprossesing
    MP_BackBufferToTexture (Texture)
    MP_ShaderSetTexture (MyShader2,"entSkin1",Texture)
    MP_SetTechniqueMyShader (MyShader2,"PostProcess")
    MP_UseBackbufferShader(Texture, MyShader2)
    
    ; Overlay with Sprite to Texturetechnik
    MP_DrawSprite(Sprite, 0, 0)  ; Now Overlay with Sprite
    MP_RenderToTexture( Texture ) ;
    ;- End Overlay
    
    MP_TextureToBackBuffer (Texture)
    ;- end Postprossesing
    
    MP_Flip () ; Stelle Sie dar

  Wend
  
  DataSection
    MyData1:
      IncludeBinary "..\media\Object2.X"
    MyData2:
      IncludeBinary "..\media\ColorMap4.jpg"
    MyData3:
      IncludeBinary "..\media\AlphaMap.jpg"
    MyData4:
      IncludeBinary "..\media\Bg2.jpg"
    MyData5:
      IncludeBinary "..\media\Overlay.png"
    MyData6:
      IncludeBinary "Shader.fx"
    MyData7:
      IncludeBinary "PostProcess.fx"
    MyData8:
      
  EndDataSection
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 76
; FirstLine = 60
; Folding = -
; EnableXP
; Executable = C:\MP_AlphaMapShader.exe
; SubSystem = dx9
; IncludeVersionInfo
; VersionField0 = 1,1,1,1