/*
 * Tutorial
 * XNA Shader programming
 * www.gamecamp.no
 * 
 * by: Petri T. Wilhelmsen
 * e-mail: petriw@gmail.com
 * 
 * Feel free to ask me a question, give feedback or correct mistakes!
 */


// Global variables
// This will use the texture bound to the object( like from the sprite batch ).
// sampler ColorMapSampler : register(s0);

texture entSkin1;

sampler ColorMapSampler = sampler_state
{
   texture = (entSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

// Pass trough
float4 MyPixelShader(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ColorMapSampler, Tex);
	Color.a = 1.0f;

    return Color;
}

technique PostProcess
{
	pass P0
	{
		// A post process shader only needs a pixel shader.
		PixelShader = compile ps_2_0 MyPixelShader();
	}
}