;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_Transmittance.pb
;// Erstellt am: 26.2.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info:
;// XNA 14. Transmittance Demo
;// http://digitalerr0r.wordpress.com/2009/05/01/xna-shader-programming-tutorial-14-transmittance/
;//
;//
;////////////////////////////////////////////////////////////////

#D3DRS_CULLMODE = 22 ;/* D3DCULL */
#D3DCULL_NONE = 1
#D3DCULL_CW = 2
#D3DCULL_CCW = 3



Structure RGBAColor
  r.f; 0-1 are 0-255 For R color
  g.f; 0-1 are 0-255 for G color; 
  b.f; 0-1 are 0-255 for B color
  a.f; 0-1 are 0-255 for A color
EndStructure

Procedure ColorSet (*Pointer.RGBAColor,r,g,b,a) ; RGBA to Shadercolor
  *Pointer\r = r / 255
  *Pointer\g = g / 255
  *Pointer\b = b / 255
  *Pointer\a = a / 255
EndProcedure   
  
;- ProgrammStart

MP_Graphics3D (800,600,0,1) ; Creat ea PB Windows 
SetWindowTitle(0, "XNA 14 Transmittance Demo, End with Esc, right mouse move mesh , mouse wheel distance") 

camera=MP_CreateCamera() ; Create a camera

Light=MP_CreateLight(1) ; Light on 

Mesh=MP_LoadMesh("..\media\Object.X") ; Load a Mesh

MP_ScaleEntity (Mesh, 0.4 , 0.4, 0.4)

MP_PositionCamera(Camera, 0, 0, -75) 
MP_CameraSetRange(camera, 20, 300)

ColorMap = MP_LoadTexture("..\media\ColorMap5.jpg") ;Load Texture for Mesh

;- Background
BgMap = MP_LoadTexture("..\media\BgScene.jpg")
Surface = MP_TextureToSurface(BgMap) 
MP_SurfaceSetPosition(Surface,0,0,1)
;- End Background

;- Overlay
Overlay = MP_LoadTexture("..\media\Overlay2.png",1) ; Textur with Alphacchannel 
sprite = MP_SpriteFromTexture(Overlay) 
;- End Overlay

Texture = MP_CreateBackBufferTexture() ; Texture for Postprocessing (fast texture)
D1M = MP_CreateBackBufferTexture(800,600,114) ; Texture for Postprocessing (fast texture)
D2M = MP_CreateBackBufferTexture(800,600,114) ; Texture for Postprocessing (fast texture)
Scene = MP_CreateBackBufferTexture() ; Texture for Postprocessing (fast texture)

;MP_UseCursor(0) ; Mauseoff

If ReadFile(0, "Shader.fx")   ; wenn die Datei geffnet werden konnte, setzen wir fort...
  While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
     Shader.s + ReadString(0) + Chr(10)      ; Zeile fr Zeile im Debugger-Fenster anzeigen
  Wend
  CloseFile(0)               
EndIf

If ReadFile(0, "PostProcess.fx")   ; wenn die Datei geffnet werden konnte, setzen wir fort...
  While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
     Shader2.s + ReadString(0) + Chr(10)      ; Zeile fr Zeile im Debugger-Fenster anzeigen
  Wend
  CloseFile(0)               
EndIf

; Shadertechnik
MyShader = MP_CreateMyShader (Shader)
MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
MP_ShaderSet_D3DMATRIX (MyShader,"matInverseWorld",MP_ShaderGetWorldI (Mesh))

MP_ShaderSet_Float3(MyShader,"vLightDirection",MP_ShaderGetLightDirection(Light) )
MP_ShaderSet_Float3(MyShader,"vecEye",MP_ShaderGetCamPos(Camera) )

ColorSet (vDiffuseColor.RGBAColor,255,255,255,255)
MP_ShaderSet_Float4(MyShader,"vDiffuseColor",vDiffuseColor)

ColorSet (vSpecularColor.RGBAColor,255,255,255,255)
MP_ShaderSet_Float4(MyShader,"vSpecularColor",vSpecularColor)

ColorSet (vAmbient.RGBAColor,127,127,127,255)
MP_ShaderSet_Float4(MyShader,"vAmbient",vAmbient )

MP_ShaderSetTexture(MyShader,"ColorMap",ColorMap) 

MP_ShaderSetEntity  (MyShader,Mesh)

MyShader2 = MP_CreateMyShader( Shader2) ; Postprocessing
MP_ShaderSetTexture(MyShader2,"D1M",D1M) 
MP_ShaderSetTexture(MyShader2,"D2M",D2M) 
MP_ShaderSetTexture(MyShader2,"BGScene",BgMap) 
MP_ShaderSetTexture(MyShader2,"Scene",Scene) 

MP_AmbientSetLight(RGB(72,61,139)) 

Du.f = 1
CC.f = 30

While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow; Esc abfrage oder Windows Schliessen

        ;- here comes the mousemesh control ; Hier kommt ein reine Mesh Maussteuerung
                
          RotX = 0 : RotY = 0
          MouseX = -MP_MouseDeltaX()/5
          MouseY = -MP_MouseDeltaY()/5   

          If MP_MouseButtonDown(1)

            RotX = MouseX
            RotY = MouseY
            MouseX = 0
            MouseY = 0
          EndIf
         
          If MP_MouseDeltaWheel() > 0
             KeyY.f = -4
          ElseIf  MP_MouseDeltaWheel() <0 
             KeyY.f =  4
          Else
             KeyY.f = 0
          EndIf
          
          If MP_KeyDown(#PB_Key_A) = 1
             Du + 0.1
             MP_ShaderSetVar_f(MyShader2,"Du",Du.f) 
          EndIf 
          If MP_KeyDown(#PB_Key_Z) = 1
             Du - 0.1
             MP_ShaderSetVar_f(MyShader2,"Du",Du.f) 
          EndIf 
          If MP_KeyDown(#PB_Key_S) = 1
             CC + 0.1
             MP_ShaderSetVar_f(MyShader2,"C",CC.f) 
          EndIf 
          If MP_KeyDown(#PB_Key_X) = 1
              CC - 0.1
              MP_ShaderSetVar_f(MyShader2,"C",CC.f) 
          EndIf 
          
        ;- end of mousemesh control ; Ende der Maussteuerung

        MP_TurnEntity(Mesh, RotX, RotY, RollZ) ; Turn Entity
        MP_MoveCamera(Camera, 0, 0, KeyY) ; distance to camera
        
        MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
        MP_ShaderSet_D3DMATRIX (MyShader,"matInverseWorld",MP_ShaderGetWorldI (Mesh))
        
        MP_SetTechniqueMyShader (MyShader,"EnvironmentShader");
        MP_SetRenderState(#D3DRS_CULLMODE, #D3DCULL_NONE) ; Anzeigen der Triangles Uhrzeigrrsinn
        
    MP_RenderWorld() ; Erstelle die Welt
 ;   MP_Flip()
    
    MP_BackBufferToTexture (texture)
    
    MP_PositionEntity (Mesh,0,0,15)
    
    MP_SetTechniqueMyShader (MyShader,"DepthMapShader")
    MP_SetRenderToTexture (D1M,1)
    MP_SetRenderState(#D3DRS_CULLMODE, #D3DCULL_CW) ; Anzeigen der Triangles Uhrzeigrrsinn
    MP_RenderToTexture( D1M, MP_ARGB(0,255,255,255))
    
    MP_PositionEntity (Mesh,0,0,7)
    
    MP_SetTechniqueMyShader (MyShader,"DepthMapShader");
    MP_SetRenderState(#D3DRS_CULLMODE, #D3DCULL_CCW); Anzeigen der Triangles gegen Uhrzeigersinn
    MP_SetRenderToTexture (D2M,1)
    MP_RenderToTexture( D2M, MP_ARGB(255,255,255,255))
    
    MP_PositionEntity (Mesh,0,0,0)
        
        
    MP_SetTechniqueMyShader (MyShader,"EnvironmentShader")
    MP_SetRenderState(#D3DRS_CULLMODE, #D3DCULL_CCW); Anzeigen der Triangles gegen Uhrzeigersinn
    MP_SetRenderToTexture (Scene,1)
    MP_RenderToTexture( Scene,MP_ARGB(255,255,255,255))    
    
;    MP_SetRenderState(#D3DRS_CULLMODE, #D3DCULL_NONE); Anzeigen der Triangles in beide Richtungen
    
    ;- Postprossesing
    MP_BackBufferToTexture (texture)
    MP_ShaderSetTexture (MyShader2,"entSkin1",Texture)
    MP_SetTechniqueMyShader (MyShader2,"PostProcess")
    MP_UseBackbufferShader(texture, MyShader2)
        
 ;       MP_RenderWorld() ; Erstelle die Welt

    ; Overlay with Sprite to Texturetechnik
    MP_DrawSprite(Sprite, 0, 0)  ; Now Overlay with Sprite
    MP_RenderToTexture( Texture ) ;
    ;- End Overlay
    
    MP_TextureToBackBuffer (Texture)    
    
    MP_Flip () ; Stelle Sie dar

Wend
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 118
; FirstLine = 116
; Folding = -
; EnableXP
; SubSystem = dx9