;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_Normal_mapping.pb
;// Erstellt am: 25.2.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info:
;// XNA 4.Normal Mapping Demo
;// http://digitalerr0r.wordpress.com/2009/03/23/xna-shader-programming-tutorial-4-normal-mapping/
;//
;//
;////////////////////////////////////////////////////////////////


Structure RGBAColor
  r.f; 0-1 are 0-255 For normal R color
  g.f; 0-1 are 0-255 for normal B color; 
  b.f; 0-1 are 0-255 for normal G color
  a.f; 0-1 are 0-255 for normal A color
EndStructure

Procedure ColorSet (*Pointer.RGBAColor,r,g,b,a) ; RGBA to Shadercolor
  *Pointer\r = r / 255
  *Pointer\g = g / 255
  *Pointer\b = b / 255
  *Pointer\a = a / 255
EndProcedure   
 

;- ProgrammStart

MP_Graphics3D (640,480,0,1) ; Creat ea PB Windows 
SetWindowTitle(0, "XNA 4.Normal Mapping Demo, End with Esc, right mouse move mesh , mouse wheel distance") 

camera=MP_CreateCamera() ; Create a camera
MP_PositionCamera(Camera, 0, 0, -95) 

Light=MP_CreateLight(0) ; Light on 
;MP_MoveEntity(light,1,-1,6)
;MP_RotateEntity(light, 0,0, 0) 

Mesh = MP_LoadMesh("..\media\Sphere.X") ; Load a Mesh
ColorTexture = MP_LoadTexture("..\media\Stone.jpg")
NormalTexture = MP_LoadTexture("..\media\normal.jpg")


;MP_UseCursor(0) ; Mauseoff

ReadFile(0, "Shader.fx")   ; wenn die Datei geffnet werden konnte, setzen wir fort...

While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
     Shader.s + ReadString(0) + Chr(10)      ; Zeile fr Zeile im Debugger-Fenster anzeigen
Wend
CloseFile(0)               

; Shadertechnik
MyShader = MP_CreateMyShader (Shader)
MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
MP_ShaderSet_D3DMATRIX (MyShader,"matWorld",MP_ShaderGetWorld(Mesh) )
MP_ShaderSet_Float4(MyShader,"vecLightDir",MP_ShaderGetLightDirection(Light) )
MP_ShaderSet_Float4(MyShader,"vecEye",MP_ShaderGetCamPos(Camera) )
MP_ShaderSetTexture(MyShader,"ColorMap",ColorTexture) 
MP_ShaderSetTexture(MyShader,"NormalMap",NormalTexture) 



MP_SetTechniqueMyShader (MyShader,"NormalMapping")
MP_ShaderSetEntity  (MyShader,Mesh)

While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow; Esc abfrage oder Windows Schliessen

        ;- here comes the mousemesh control ; Hier kommt ein reine Mesh Maussteuerung
                
          RotX = 0 : RotY = 0
          MouseX = -MP_MouseDeltaX()/5
          MouseY = -MP_MouseDeltaY()/5   

          If MP_MouseButtonDown(1)

            RotX = MouseX
            RotY = MouseY
            MouseX = 0
            MouseY = 0
          EndIf
         
          If MP_MouseDeltaWheel() > 0
             KeyY.f = -4
          ElseIf  MP_MouseDeltaWheel() <0 
             KeyY.f =  4
          Else
             KeyY.f = 0
          EndIf
         
        ;- end of mousemesh control ; Ende der Maussteuerung
xx.f + 0.1
 ;       MP_RotateEntity(Mesh, xx,0, 0) ; Turn Entity
        MP_TurnEntity(Mesh, RotX, RotY, RollZ) ; Turn Entity
        MP_MoveCamera(Camera, 0, 0, KeyY) ; distance to camera
        
        ;MP_ShaderSet_Float4(MyShader,"vLightDirection",MP_ShaderGetLightDirection(Light) ) 
        MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
        MP_ShaderSet_D3DMATRIX (MyShader,"matWorld",MP_ShaderGetWorld(Mesh))
        
    MP_RenderWorld() ; Erstelle die Welt
    MP_Flip () ; Stelle Sie dar

Wend
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 71
; FirstLine = 54
; Folding = -
; EnableXP
; SubSystem = dx9