;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_Deform.pb
;// Erstellt am: 24.2.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info:
;// XNA 5.Deform Demo
;// http://digitalerr0r.wordpress.com/2009/03/23/xna-shader-programming-tutorial-5-deform-shader/
;//
;//
;////////////////////////////////////////////////////////////////


Structure RGBAColor
  r.f; 0-1 are 0-255 For normal R color
  g.f; 0-1 are 0-255 for normal B color; 
  b.f; 0-1 are 0-255 for normal G color
  a.f; 0-1 are 0-255 for normal A color
EndStructure

Procedure ColorSet (*Pointer.RGBAColor,r,g,b,a) ; RGBA to Shadercolor
  *Pointer\r = r / 255
  *Pointer\g = g / 255
  *Pointer\b = b / 255
  *Pointer\a = a / 255
EndProcedure   
  

;- ProgrammStart

MP_Graphics3D (640,480,0,1) ; Creat ea PB Windows 
SetWindowTitle(0, "XNA 5.Deform Demo, End with Esc, right mouse move mesh , mouse wheel distance") 

camera=MP_CreateCamera() ; Create a camera
MP_PositionCamera(Camera, 0, 0, -220) 

Light=MP_CreateLight(1) ; Light on 

Mesh=MP_LoadMesh("..\media\Sphere.X") ; Load a Mesh

;MP_UseCursor(0) ; Mauseoff

ReadFile(0, "Shader.fx")   ; wenn die Datei geffnet werden konnte, setzen wir fort...

While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
     Shader.s + ReadString(0) + Chr(10)      ; Zeile fr Zeile im Debugger-Fenster anzeigen
Wend
CloseFile(0)               

; Shadertechnik
MyShader = MP_CreateMyShader (Shader)
MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
MP_ShaderSet_D3DMATRIX (MyShader,"matWorld",MP_ShaderGetWorld (Mesh))
MP_ShaderSet_Float4(MyShader,"vecLightDir",MP_ShaderGetLightDirection(Light) )
MP_ShaderSet_Float4(MyShader,"vecEye",MP_ShaderGetCamPos(Camera) )

ColorSet (vDiffuseColor.RGBAColor,77,77,179,255)
MP_ShaderSet_Float4(MyShader,"vDiffuseColor",vDiffuseColor)

ColorSet (vSpecularColor.RGBAColor,255,255,255,255)
MP_ShaderSet_Float4(MyShader,"vSpecularColor",vSpecularColor)

ColorSet (vAmbient.RGBAColor,25,25,25,255)
MP_ShaderSet_Float4(MyShader,"vAmbient",vAmbient )

MP_SetTechniqueMyShader (MyShader,"SpecularLight")
MP_ShaderSetEntity  (MyShader,Mesh)

While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow; Esc abfrage oder Windows Schliessen

        ;- here comes the mousemesh control ; Hier kommt ein reine Mesh Maussteuerung
        
          If MP_MouseDeltaWheel() > 0
             KeyY.f = -4
          ElseIf  MP_MouseDeltaWheel() <0 
             KeyY.f =  4
          Else
             KeyY.f = 0
          EndIf
          
          MP_MoveCamera(Camera, 0, 0, KeyY) ; distance to camera
          MP_ShaderSet_D3DMATRIX (MyShader,"matWorldViewProj",MP_ShaderGetWorldView (Mesh))
         
        ;- end of mousemesh control ; Ende der Maussteuerung
        
        time.f + 0.01
        MP_ShaderSetVar_f(MyShader,"g_fTime",time) 
        
    MP_RenderWorld() ; Erstelle die Welt
    MP_Flip () ; Stelle Sie dar

Wend
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 71
; FirstLine = 39
; Folding = -
; EnableXP
; SubSystem = dx9