;////////////////////////////////////////////////////////////////
;//
;// Project Title: MP 3D Engine Beispielprogramme
;// Dateiname: MP_ChessShadow.pb
;// Erstellt am: 15.5.2011
;// Update am  : 
;// Author: Michael Paulwitz
;// 
;// Info: 
;// Procedural Chess With Schadow
;// Procedurales Schachbrett mit Schatten
;//
;//
;////////////////////////////////////////////////////////////////



Global xres=800, yres=600, stp.f=0.001, sen.f=4, maxr.f=30
Global Dim fg(5),Dim a.f(1),Dim b.f(1),Dim c.f(1),Dim d.f(1),Dim oc.f(1)
txp=8 : txres=1 << txp : txcp=txp-6 : txcell=1 << txcp-1

Global advert , adtri, *MemoryID, *MemoryID2

Procedure vertexes(s)

  vx.f=1*(400-oc(0))/300
  vy.f=1*(600-oc(1))/300
  r1=Abs(400-oc(0))

  If sen.f>=r1*2 
    r1=1

    ;MP_AddVertex (s, 0, vy.f, 0,0,0)
    PokeF (*MemoryID + advert*36 + 4, vy)  ; Setze y, x und z = 0
    PokeL (*MemoryID + advert*36 + 24, $FFFFFFFF) ; Color Weiss      
    Color.l = $FFFFFF
    advert + 1

  Else
    
    r1=Round (6.2831/ACos(1.0-sen.f/r1), #PB_Round_Up)
    ang.f=0
    dang.f=360.0/r1
    Repeat

      ;MP_AddVertex ( s, Cos(ang* 0.017453)*vx, vy, Sin(ang* 0.017453)*vx,0,0)
      PokeF (*MemoryID + advert*36 , Cos(ang* 0.017453)*vx)    ; Setze x
      PokeF (*MemoryID + advert*36 + 4, vy)                    ; Setze y
      PokeF (*MemoryID + advert*36 + 8, Sin(ang* 0.017453)*vx) ; Setze z
      
      PokeL (*MemoryID + advert*36 + 24, $FFFFFFFF) ; Color Weiss
      advert + 1
      
      ang  + dang
      
      If ang>359.9
        Break 
      EndIf
    ForEver
  EndIf

  ProcedureReturn r1

EndProcedure


MP_Graphics3D (xres,yres,0,3) ; Erstelle ein WindowsFenster #Window = 0
SetWindowTitle(0, "Prozedurales Schachbrett") 

camera=MP_CreateCamera() ; Kamera erstellen

light=MP_CreateLight(0) ; Es werde Licht

MP_InitShadow() 

;- 

Width=256
Height=256 

If CreateImage(0, Width, Height)
  MP_CreateImageColored(0, 0, RGB(0,255,255), RGB(0,255,255), RGB(0,0,255), RGB(0,0,255))     
EndIf

If CreateImage(1, Width, Height)

  StartDrawing(ImageOutput(1))
 
  For x=0 To 63
    ux=x << txcp
    For y=0 To 63
      uy=y << txcp
      col=1
      ; Definition of color of section
      If x>=4 And x <60 And y>=4 And y <60

        hups = Round(((x-4)/7), #PB_Round_Down) + Round(((y-4)/7), #PB_Round_Down)
        If hups & 1
          col=0
        EndIf
 
      ElseIf x>=3 And x <61 And y>=3 And y <61 
        col=0
      EndIf
 
      ;  A shading of section with addition of color noise
      For xx=ux To ux+txcell
        For yy=uy To uy+txcell
          FrontColor (RGB( MP_RandomInt(-8,8) +192*col+16, MP_RandomInt(-8,8) +128*col+16, MP_RandomInt(-8,8) +16))
          Plot (xx, yy)
        Next
      Next  
    Next
  Next
 
  StopDrawing() 

EndIf

Surface = MP_ImageToSurface(0,0) ; Image = 0, 
FreeImage(0)

; Creation of a board
brd=MP_CreateCube()

; Updating textural coordinates of a board;
For n=0 To 23
 If MP_VertexGetY(brd, n) < 0
    MP_VertexSetV(brd, n,3.0/64)
 EndIf 
Next

MP_ScaleEntity (brd, 9, 0.25,9)

Muster=MP_ImageToTexture (1)
FreeImage(1)

MP_EntitySetTexture (brd, Muster)
MP_PositionEntity (brd,0,-0.1,0) 

;- 

MP_SurfaceSetPosition(Surface,0,0,1)
MP_SurfaceDestRect(Surface,0, 0, xres, yres)

Restore NumericalData

StartTime.f = ElapsedMilliseconds()             ; ermittelt den aktuellen Wert
  
For n1=0 To 5
 Read.i advert1 : Read.i adtri1
 Read.i q : Read.i x2 : Read.i y2 : Read.i dx21 : Read.i dy21 : Read.i dx22 : Read.i  dy22
 
 *MemoryID = AllocateMemory(advert1 * 36)
 *MemoryID2 = AllocateMemory(adtri1 * 6)
 
 advert = 0
 adtri = 0
 
 rbeg=0
 
 fg(n1) = MP_CreateMesh()
 
 For n2=2 To q
    x1=x2:y1=y2:dx11=dx21:dy11=dy21:dx12=dx22:dy12=dy22
    Read.i x2 : Read.i y2: Read.i dx21: Read.i dy21: Read.i dx22: Read.i dy22

    r.f =0.05 * Sqr((x1-x2)*(x1-x2) +(y1-y2)*(y1-y2))
    For n3=0 To 1
      If n3 
        ux1=y1
        ux2=y2
        c(n3) =r*dy12
        dy2.f=r*dy21
      Else
        ux1=x1
        ux2=x2
        c(n3) =r*dx12
        dy2=r*dx21
      EndIf
      d(n3) = ux1
      b(n3) =3.0*ux2-dy2.f-2.0*c(n3)-3.0*d(n3)
      a(n3) =(dy2-2*b(n3)-c(n3))/3.0
    Next

    t.f=0
    tt.f=0
    oc(0) =d(0)
    oc(1) =d(1)
    If n2=2 
       r1=vertexes(fg(n1))
    EndIf   

    Repeat
      x=oc(0)
      y=oc(1)
      la.f=-3.0*a(1)*tt-2.0*b(1)*t-c(1)
      lb.f=3.0*a(0)*tt+2.0*b(0)*t+c(0)
      If la=0 And lb=0
        la=y1-y2
        lb=x2-x1
      EndIf
      lc.f=-la*x-lb*y
      sen2=Sqr(la*la+lb*lb)*sen
      Repeat

        t=t+stp
        If t>1 
          t=1
        EndIf
        tt.f=t*t
        For n3=0 To 1
          oc(n3) =a(n3)*tt*t+b(n3)*tt+c(n3)*t+d(n3)
        Next
        If Sqr((x-oc(0))*(x-oc(0)) +(y-oc(1))*(y-oc(1))) > maxr
           Break
        EndIf
      Until t=1 Or Abs(la*oc(0) +lb*oc(1) +lc) >= sen2
      
      r2=vertexes(fg(n1))

      rbeg2=rbeg+r1
      r10=0
      r20=0
      Repeat
      
      If(r10+1)*r2 <(r20+1)*r1 
        r10=r10+1
        r11=r12
        r12=r10 % r1
        
        PokeW (*MemoryID2 + adtri*6, rbeg2+r22) 
        PokeW (*MemoryID2 + adtri*6+2, rbeg+r11) 
        PokeW (*MemoryID2 + adtri*6+4, rbeg+r12) 
        
        adtri + 1

      Else
        r20=r20+1
        r21=r22
        r22=r20 % r2

        PokeW (*MemoryID2 + adtri*6, rbeg+r12) 
        PokeW (*MemoryID2 + adtri*6+2, rbeg2+r22) 
        PokeW (*MemoryID2 + adtri*6+4, rbeg2+r21) 
        
        adtri + 1

      EndIf
            
      Until r12=0 And r22=0

    rbeg=rbeg2
    r1=r2
    If t=1 : Break : EndIf
 ForEver

 Next

 MP_MeshSetData(fg(n1), #PB_Mesh_Vertex | #PB_Mesh_Normal | #PB_Mesh_Color  | #PB_Mesh_UVCoordinate,  *MemoryID, advert1)
 MP_MeshSetData(fg(n1), #PB_Mesh_Face,  *MemoryID2, adtri1)
 
 MP_PositionEntity (fg(n1),n1-2.5,0,3) ; Position des Meshs
 
Next

 FreeMemory(*MemoryID) 
 FreeMemory(*MemoryID2)
 
 
; Loading and installation of a head of a horse
;m=MP_LoadMesh("knight.3ds")


Restore NumericalData2
Read.l Vert
Read.l Tria
Read.l Max
m=MP_CreateMesh ()


MP_MeshSetData(m, #PB_Mesh_Vertex | #PB_Mesh_Normal | #PB_Mesh_Color  | #PB_Mesh_UVCoordinate, ?Vertice, Vert);3)
MP_MeshSetData(m, #PB_Mesh_Face, ?Triangle, Tria); 1)

MP_ScaleMesh (m, 0.5,1,0.5)
MP_PositionMesh  (m, 0,1,-0.05)

MP_AddMesh (m,fg(3))

MP_FreeEntity(m)



; Erzeuge die Figuren und arrangiere sie: Creation and arrangement of figures
For x=0 To 7
 For y=0 To 7
 e =-1
 ; Definiere den Typ der Figur : Definition of type of a figure
 If y=0 Or y=7 
    e = Val(Mid("43210234", x+1,1))
 EndIf   
 If y=1 Or y=6 
    e=5
 EndIf   
 If e>=0

   e=MP_CopyEntity(fg(e))
   MP_EntitySetNormals (e)
   ;
;   For n = 0 To MP_CountVertices(e)-1

;        xxx.f = MP_VertexGetX (e,n)
;        yyy.f = MP_VertexGetY (e,n)
;        zzz.f = MP_VertexGetZ (e,n)
 
;        MP_VertexSetNx (e,n, xxx) 
;        MP_VertexSetNy (e,n, yyy)
;        MP_VertexSetNz (e,n, zzz)
        
;   Next
   
   
   
   
   
  MP_PositionEntity (e, x-3.5,0, y-3.5)

  If y <4 
     MP_RotateEntity (e, 180,0,0)
     MP_EntitySetColor (e,RGB(32,32,32))
     MP_MaterialDiffuseColor (e,255,25,25,25)
  Else
     MP_EntitySetColor (e,RGB(200,200,200))  
     MP_MaterialDiffuseColor (e,255,255,255,255)
     MP_MaterialAmbientColor (e, 255, 33 , 33, 33) ; 
     MP_MaterialEmissiveColor (e,255,25,25,25) ; 
  
  EndIf

 EndIf
 Next
Next

For n1=0 To 5

   MP_FreeEntity(fg(n1)) ; Lsche alle Ausgangsfiguren

Next

Debug StrF((ElapsedMilliseconds()-StartTime)/1000)
  

MP_PositionEntity(light, 0, 20, 20)
MP_EntityLookAt(light,0,0,0)

While Not MP_KeyDown(#PB_Key_Escape) And Not WindowEvent() = #PB_Event_CloseWindow; Esc abfrage oder Windows Schliessen
   
    count.f + 0.01
    
    MP_PositionEntity(light, Sin(count+#PI/2) * 10 , 20, Cos(count+#PI/2) * 10)
    MP_EntityLookAt(light,MP_EntityGetX(brd),MP_EntityGetY(brd),MP_EntityGetZ(brd))
    
    
    MP_PositionCamera (Camera, Sin(count) * 10, 5, Cos(count) * 10)
    MP_CameraLookAt(Camera,MP_EntityGetX(brd),MP_EntityGetY(brd),MP_EntityGetZ(brd))
    
    MP_RenderWorld() ; Erstelle die Welt
    
    MP_Flip () ; Stelle Sie dar

Wend



; Data for plotting:
DataSection
    NumericalData:

; 0-King
Data.i 868 , 1733
Data.i 24
Data.i 400,0,0,0,0,0
Data.i 391,0,0,0,0,0
Data.i 391,26,0,0,0,0
Data.i 377,26,0,0,0,0
Data.i 377,36,0,0,0,0
Data.i 391,36,0,0,0,0
Data.i 391,62,0,0,0,0
Data.i 352,79,-5,31,0,1
Data.i 331,74,0,0,0,0
Data.i 355,162,0,0,-53,0
Data.i 355,177,53,0,0,0
Data.i 355,190,0,0,-53,0
Data.i 355,205,53,0,0,0
Data.i 326,205,0,0,-69,0
Data.i 326,219,69,0,0,0
Data.i 373,219,0,0,0,0
Data.i 341,462,-10,28,0,0
Data.i 351,473,0,0,-33,14
Data.i 295,573,0,28,0,0
Data.i 305,573,0,0,0,0
Data.i 305,584,0,0,0,0
Data.i 295,584,0,0,0,0
Data.i 295,599,0,0,0,0
Data.i 400,599,0,0,0,0

; 1-Queen
Data.i 831 , 1659
Data.i 20
Data.i 400,45,0,0,0,0
Data.i 380,53,0,0,0,0
Data.i 391,62,0,0,0,0
Data.i 352,79,-5,31,0,1
Data.i 331,74,0,0,30,39
Data.i 355,162,0,0,-53,0
Data.i 355,177,53,0,0,0
Data.i 355,190,0,0,-53,0
Data.i 355,205,53,0,0,0
Data.i 326,205,0,0,-69,0
Data.i 326,219,69,0,0,0
Data.i 373,219,0,0,0,0
Data.i 341,462,-10,28,0,0
Data.i 351,473,0,0,-33,14
Data.i 295,573,0,28,0,0
Data.i 305,573,0,0,0,0
Data.i 305,584,0,0,0,0
Data.i 295,584,0,0,0,0
Data.i 295,599,0,0,0,0
Data.i 400,599,0,0,0,0

; 2-bishop
Data.i 641 , 1278
Data.i 18
Data.i 400,84,0,0,-46,1
Data.i 392,107,24,8,6,13
Data.i 369,162,-29,33,-29,33
Data.i 366,253,0,0,-53,0
Data.i 366,266,53,0,0,0
Data.i 366,292,0,0,-53,0
Data.i 366,304,53,0,0,0
Data.i 346,304,0,0,-69,0
Data.i 346,317,69,0,0,0
Data.i 380,317,0,0,0,0
Data.i 352,497,-10,28,0,0
Data.i 359,505,0,0,-19,15
Data.i 309,577,-5,20,0,0
Data.i 321,577,0,0,0,0
Data.i 321,586,0,0,0,0
Data.i 309,586,0,0,0,0
Data.i 309,599,0,0,0,0
Data.i 400,599,0,0,0,0

; 3-Horse
Data.i 285 , 567
Data.i 9
Data.i 400,475,0,0,0,0
Data.i 333,475,0,0,0,0
Data.i 345,493,0,0,0,0
Data.i 297,578,-2,20,0,0
Data.i 310,578,0,0,0,0
Data.i 310,586,0,0,0,0
Data.i 297,586,0,0,0,0
Data.i 297,599,0,0,0,0
Data.i 400,599,0,0,0,0

; 4-Tower
Data.i 582 , 1160
Data.i 20
Data.i 400,181,0,0,0,0
Data.i 332,181,0,0,0,0
Data.i 332,161,0,0,0,0
Data.i 316,161,0,0,0,0
Data.i 316,193,0,0,0,0
Data.i 332,193,0,0,0,0
Data.i 332,215,0,0,0,0
Data.i 344,215,0,0,0,0
Data.i 344,238,0,0,0,0
Data.i 359,238,0,0,0,0
Data.i 359,268,0,0,0,0
Data.i 346,454,0,0,0,0
Data.i 333,460,0,0,0,0
Data.i 342,473,0,0,0,0
Data.i 309,577,-2,20,0,0
Data.i 321,577,0,0,0,0
Data.i 321,586,0,0,0,0
Data.i 309,586,0,0,0,0
Data.i 309,599,0,0,0,0
Data.i 400,599,0,0,0,0

; 5-Pawn
Data.i 456 , 908
Data.i 13
Data.i 400,209,0,0,-37,0
Data.i 375,283,31,11,0,0
Data.i 339,334,0,0,0,0
Data.i 382,334,0,0,-1,46
Data.i 355,501,0,0,0,0
Data.i 339,498,0,0,0,0
Data.i 346,512,0,0,0,0
Data.i 309,577,-2,20,0,0
Data.i 321,577,0,0,0,0
Data.i 321,586,0,0,0,0
Data.i 309,586,0,0,0,0
Data.i 309,599,0,0,0,0
Data.i 400,599,0,0,0,0

   NumericalData2:
   Data.l 828,1652,1

   Vertice:  ;x,y,z,nx,ny,nz,col,u,v = Vertex + Normal + Col + UV Koordinaten
   Data.f -0.127242,-0.08381,-0.490283,-0.127242,-0.08381,-0.490283
   Data.l -1
   Data.f 0.802421,7.267577
   Data.f -0.121783,-0.123479,-0.577425,-0.121783,-0.123479,-0.577425
   Data.l -1
   Data.f 0.791192,7.215351
   Data.f -0.120649,-0.110738,-0.58031,-0.120649,-0.110738,-0.58031
   Data.l -1
   Data.f 0.79669,7.214209
   Data.f -0.117979,-0.078607,-0.585916,-0.117979,-0.078607,-0.585916
   Data.l -1
   Data.f 0.810454,7.212279
   Data.f -0.253165,-0.581102,0.375682,-0.253165,-0.581102,0.375682
   Data.l -1
   Data.f 0.541,7.742408
   Data.f -0.250161,-0.587034,0.375675,-0.250161,-0.587034,0.375675
   Data.l -1
   Data.f 0.53872,7.744254
   Data.f -0.210829,-0.614232,0.131953,-0.210829,-0.614232,0.131953
   Data.l -1
   Data.f 0.543357,7.613011
   Data.f -0.114833,-0.036206,-0.589687,-0.114833,-0.036206,-0.589687
   Data.l -1
   Data.f 0.828388,7.211812
   Data.f -0.261543,-0.564317,0.375706,-0.261543,-0.564317,0.375706
   Data.l -1
   Data.f 0.547459,7.737259
   Data.f -0.258505,-0.538194,0.376231,-0.258505,-0.538194,0.376231
   Data.l -1
   Data.f 0.558414,7.739468
   Data.f -0.25288,-0.298734,0.590049,-0.25288,-0.298734,0.590049
   Data.l -1
   Data.f 0.645871,7.879327
   Data.f -0.253822,-0.304818,0.592143,-0.253822,-0.304818,0.592143
   Data.l -1
   Data.f 0.643181,7.880082
   Data.f -0.248403,-0.422693,0.40748,-0.248403,-0.422693,0.40748
   Data.l -1
   Data.f 0.605042,7.765625
   Data.f -0.249779,-0.278794,0.582861,-0.249779,-0.278794,0.582861
   Data.l -1
   Data.f 0.654702,7.876649
   Data.f -0.254579,-0.504247,0.376911,-0.254579,-0.504247,0.376911
   Data.l -1
   Data.f 0.572648,7.742318
   Data.f -0.244141,-0.242482,0.569192,-0.244141,-0.242482,0.569192
   Data.l -1
   Data.f 0.670815,7.871405
   Data.f -0.11224,0.007323,-0.587046,-0.11224,0.007323,-0.587046
   Data.l -1
   Data.f 0.846401,7.215094
   Data.f -0.111163,0.042857,-0.573424,-0.111163,0.042857,-0.573424
   Data.l -1
   Data.f 0.860405,7.224446
   Data.f -0.112538,0.061263,-0.544259,-0.112538,0.061263,-0.544259
   Data.l -1
   Data.f 0.866311,7.242202
   Data.f -0.115094,0.075095,-0.50473,-0.115094,0.075095,-0.50473
   Data.l -1
   Data.f 0.869678,7.265843
   Data.f -0.249978,-0.463998,0.377718,-0.249978,-0.463998,0.377718
   Data.l -1
   Data.f 0.589523,7.745668
   Data.f -0.116927,0.099379,-0.464934,-0.116927,0.099379,-0.464934
   Data.l -1
   Data.f 0.877396,7.2901
   Data.f -0.235665,-0.187284,0.547678,-0.235665,-0.187284,0.547678
   Data.l -1
   Data.f 0.695347,7.862902
   Data.f -0.248277,-0.422563,0.406479,-0.248277,-0.422563,0.406479
   Data.l -1
   Data.f 0.605158,7.765062
   Data.f -0.247932,-0.422197,0.403633,-0.247932,-0.422197,0.403633
   Data.l -1
   Data.f 0.60549,7.76346
   Data.f -0.24739,-0.421617,0.399188,-0.24739,-0.421617,0.399188
   Data.l -1
   Data.f 0.606008,7.760957
   Data.f -0.246679,-0.420865,0.393372,-0.246679,-0.420865,0.393372
   Data.l -1
   Data.f 0.606685,7.757686
   Data.f -0.245834,-0.419969,0.386439,-0.245834,-0.419969,0.386439
   Data.l -1
   Data.f 0.607493,7.753783
   Data.f -0.244884,-0.418954,0.378617,-0.244884,-0.418954,0.378617
   Data.l -1
   Data.f 0.608404,7.749381
   Data.f -0.134625,-0.176244,-0.482108,-0.134625,-0.176244,-0.482108
   Data.l -1
   Data.f 0.763292,7.268245
   Data.f -0.134118,-0.174482,-0.485959,-0.134118,-0.174482,-0.485959
   Data.l -1
   Data.f 0.764266,7.266099
   Data.f -0.135928,-0.180227,-0.471636,-0.135928,-0.180227,-0.471636
   Data.l -1
   Data.f 0.760984,7.274119
   Data.f -0.137744,-0.184461,-0.456144,-0.137744,-0.184461,-0.456144
   Data.l -1
   Data.f 0.758262,7.282884
   Data.f -0.139769,-0.186982,-0.437227,-0.139769,-0.186982,-0.437227
   Data.l -1
   Data.f 0.756045,7.293704
   Data.f -0.141703,-0.185823,-0.416486,-0.141703,-0.185823,-0.416486
   Data.l -1
   Data.f 0.755254,7.305746
   Data.f -0.143222,-0.179013,-0.39552,-0.143222,-0.179013,-0.39552
   Data.l -1
   Data.f 0.756811,7.318181
   Data.f -0.144569,-0.164621,-0.370267,-0.144569,-0.164621,-0.370267
   Data.l -1
   Data.f 0.761278,7.333462
   Data.f -0.145121,-0.152658,-0.354932,-0.145121,-0.152658,-0.354932
   Data.l -1
   Data.f 0.765338,7.342905
   Data.f -0.145309,-0.142003,-0.344373,-0.145309,-0.142003,-0.344373
   Data.l -1
   Data.f 0.769147,7.349522
   Data.f -0.145539,-0.131532,-0.333469,-0.145539,-0.131532,-0.333469
   Data.l -1
   Data.f 0.772856,7.356336
   Data.f -0.146208,-0.12013,-0.317084,-0.146208,-0.12013,-0.317084
   Data.l -1
   Data.f 0.77662,7.366375
   Data.f -0.118148,0.128699,-0.427636,-0.118148,0.128699,-0.427636
   Data.l -1
   Data.f 0.887373,7.313139
   Data.f -0.147706,-0.106668,-0.290085,-0.147706,-0.106668,-0.290085
   Data.l -1
   Data.f 0.780595,7.382676
   Data.f -0.150396,-0.088826,-0.246381,-0.150396,-0.088826,-0.246381
   Data.l -1
   Data.f 0.785379,7.408901
   Data.f -0.118892,0.157641,-0.395619,-0.118892,0.157641,-0.395619
   Data.l -1
   Data.f 0.897517,7.333108
   Data.f -0.119316,0.180793,-0.371646,-0.119316,0.180793,-0.371646
   Data.l -1
   Data.f 0.905732,7.348136
   Data.f -0.152498,-0.078374,-0.214793,-0.152498,-0.078374,-0.214793
   Data.l -1
   Data.f 0.787818,7.427752
   Data.f -0.119587,0.192733,-0.358514,-0.119587,0.192733,-0.358514
   Data.l -1
   Data.f 0.909924,7.356349
   Data.f -0.15437,-0.071939,-0.18906,-0.15437,-0.071939,-0.18906
   Data.l -1
   Data.f 0.788935,7.443017
   Data.f -0.119654,0.198737,-0.352697,-0.119654,0.198737,-0.352697
   Data.l -1
   Data.f 0.912078,7.360015
   Data.f -0.156321,-0.066144,-0.162901,-0.156321,-0.066144,-0.162901
   Data.l -1
   Data.f 0.789758,7.458499
   Data.f -0.158653,-0.057626,-0.13006,-0.158653,-0.057626,-0.13006
   Data.l -1
   Data.f 0.791313,7.478015
   Data.f -0.119413,0.207511,-0.348261,-0.119413,0.207511,-0.348261
   Data.l -1
   Data.f 0.915474,7.362993
   Data.f -0.161636,-0.043008,-0.084255,-0.161636,-0.043008,-0.084255
   Data.l -1
   Data.f 0.79463,7.505396
   Data.f -0.162845,-0.032247,-0.061017,-0.162845,-0.032247,-0.061017
   Data.l -1
   Data.f 0.797713,7.519476
   Data.f -0.163438,-0.018796,-0.041838,-0.163438,-0.018796,-0.041838
   Data.l -1
   Data.f 0.802173,7.531344
   Data.f -0.163588,-0.004728,-0.026793,-0.163588,-0.004728,-0.026793
   Data.l -1
   Data.f 0.807144,7.540846
   Data.f -0.163483,0.007884,-0.015954,-0.163483,0.007884,-0.015954
   Data.l -1
   Data.f 0.811763,7.547826
   Data.f -0.163291,0.016974,-0.009399,-0.163291,0.016974,-0.009399
   Data.l -1
   Data.f 0.815168,7.552128
   Data.f -0.163186,0.020461,-0.007195,-0.163186,0.020461,-0.007195
   Data.l -1
   Data.f 0.816495,7.553596
   Data.f -0.118964,0.218802,-0.344317,-0.118964,0.218802,-0.344317
   Data.l -1
   Data.f 0.919952,7.365786
   Data.f -0.118384,0.232364,-0.340002,-0.118384,0.232364,-0.340002
   Data.l -1
   Data.f 0.925354,7.368899
   Data.f -0.11777,0.247935,-0.334414,-0.11777,0.247935,-0.334414
   Data.l -1
   Data.f 0.931521,7.372838
   Data.f -0.117209,0.265273,-0.32669,-0.117209,0.265273,-0.32669
   Data.l -1
   Data.f 0.938295,7.378112
   Data.f -0.117144,0.286261,-0.309636,-0.117144,0.286261,-0.309636
   Data.l -1
   Data.f 0.946031,7.389032
   Data.f -0.117732,0.310775,-0.281013,-0.117732,0.310775,-0.281013
   Data.l -1
   Data.f 0.954541,7.406928
   Data.f -0.118664,0.335543,-0.247361,-0.118664,0.335543,-0.247361
   Data.l -1
   Data.f 0.962854,7.427821
   Data.f -0.119649,0.357287,-0.215221,-0.119649,0.357287,-0.215221
   Data.l -1
   Data.f 0.969998,7.447715
   Data.f -0.120423,0.372733,-0.191139,-0.120423,0.372733,-0.191139
   Data.l -1
   Data.f 0.974999,7.462601
   Data.f -0.120741,0.378611,-0.181653,-0.120741,0.378611,-0.181653
   Data.l -1
   Data.f 0.976883,7.468455
   Data.f -0.124154,0.406947,-0.110328,-0.124154,0.406947,-0.110328
   Data.l -1
   Data.f 0.984423,7.511853
   Data.f -0.110827,0.646189,-0.063759,-0.110827,0.646189,-0.063759
   Data.l -1
   Data.f 1.081581,7.549767
   Data.f -0.10964,0.668235,-0.05953,-0.10964,0.668235,-0.05953
   Data.l -1
   Data.f 1.090534,7.553198
   Data.f -0.110336,0.673487,-0.044032,-0.110336,0.673487,-0.044032
   Data.l -1
   Data.f 1.091803,7.562654
   Data.f -0.112342,0.665721,-0.022057,-0.112342,0.665721,-0.022057
   Data.l -1
   Data.f 1.087244,7.575435
   Data.f -0.112871,0.618312,-0.061498,-0.112871,0.618312,-0.061498
   Data.l -1
   Data.f 1.069801,7.549952
   Data.f -0.115121,0.648688,0.001617,-0.115121,0.648688,0.001617
   Data.l -1
   Data.f 1.078714,7.588826
   Data.f -0.118104,0.626155,0.022206,-0.118104,0.626155,0.022206
   Data.l -1
   Data.f 1.068069,7.600121
   Data.f -0.114461,0.595679,-0.060888,-0.114461,0.595679,-0.060888
   Data.l -1
   Data.f 1.060312,7.54936
   Data.f -0.120703,0.601889,0.034923,-0.120703,0.601889,0.034923
   Data.l -1
   Data.f 1.057166,7.606632
   Data.f -0.115811,0.574752,-0.062209,-0.115811,0.574752,-0.062209
   Data.l -1
   Data.f 1.051649,7.547688
   Data.f -0.12539,0.550513,0.048655,-0.12539,0.550513,0.048655
   Data.l -1
   Data.f 1.034872,7.612508
   Data.f -0.117142,0.551982,-0.065722,-0.117142,0.551982,-0.065722
   Data.l -1
   Data.f 1.042346,7.544625
   Data.f -0.118691,0.523818,-0.071702,-0.118691,0.523818,-0.071702
   Data.l -1
   Data.f 1.030939,7.53986
   Data.f -0.129988,0.499518,0.059982,-0.129988,0.499518,0.059982
   Data.l -1
   Data.f 1.012875,7.6169
   Data.f -0.120678,0.486716,-0.080419,-0.120678,0.486716,-0.080419
   Data.l -1
   Data.f 1.015959,7.533072
   Data.f -0.134221,0.452929,0.069442,-0.134221,0.452929,0.069442
   Data.l -1
   Data.f 0.992824,7.620328
   Data.f -0.121903,0.462726,-0.086942,-0.121903,0.462726,-0.086942
   Data.l -1
   Data.f 1.006327,7.528156
   Data.f -0.122825,0.442893,-0.093682,-0.122825,0.442893,-0.093682
   Data.l -1
   Data.f 0.998444,7.523289
   Data.f -0.137782,0.414756,0.077585,-0.137782,0.414756,0.077585
   Data.l -1
   Data.f 0.976369,7.623327
   Data.f -0.123468,0.427306,-0.100022,-0.123468,0.427306,-0.100022
   Data.l -1
   Data.f 0.992311,7.518849
   Data.f -0.140364,0.389022,0.084961,-0.140364,0.389022,0.084961
   Data.l -1
   Data.f 0.96516,7.626441
   Data.f -0.123876,0.416056,-0.105329,-0.123876,0.416056,-0.105329
   Data.l -1
   Data.f 0.98793,7.515213
   Data.f -0.124093,0.409236,-0.108971,-0.124093,0.409236,-0.108971
   Data.l -1
   Data.f 0.9853,7.512754
   Data.f -0.141645,0.379744,0.092113,-0.141645,0.379744,0.092113
   Data.l -1
   Data.f 0.960847,7.630214
   Data.f -0.147276,0.368178,0.153254,-0.147276,0.368178,0.153254
   Data.l -1
   Data.f 0.95232,7.665748
   Data.f -0.155633,0.33105,0.220867,-0.155633,0.33105,0.220867
   Data.l -1
   Data.f 0.932698,7.703731
   Data.f -0.166385,0.271506,0.290923,-0.166385,0.271506,0.290923
   Data.l -1
   Data.f 0.903525,7.741796
   Data.f -0.179219,0.192691,0.359408,-0.179219,0.192691,0.359408
   Data.l -1
   Data.f 0.866347,7.777576
   Data.f -0.19375,0.097762,0.422296,-0.19375,0.097762,0.422296
   Data.l -1
   Data.f 0.822715,7.808741
   Data.f -0.209505,-0.010141,0.475568,-0.209505,-0.010141,0.475568
   Data.l -1
   Data.f 0.774183,7.833019
   Data.f -0.166097,-0.061143,-0.052646,-0.166097,-0.061143,-0.052646
   Data.l -1
   Data.f 0.785102,7.522812
   Data.f -0.224138,-0.110677,0.516931,-0.224138,-0.110677,0.516931
   Data.l -1
   Data.f 0.729429,7.850387
   Data.f -0.166025,-0.066453,-0.058394,-0.166025,-0.066453,-0.058394
   Data.l -1
   Data.f 0.78323,7.519189
   Data.f -0.165914,-0.081838,-0.07389,-0.165914,-0.081838,-0.07389
   Data.l -1
   Data.f 0.777736,7.509372
   Data.f -0.165921,-0.106481,-0.096508,-0.165921,-0.106481,-0.096508
   Data.l -1
   Data.f 0.768804,7.49494
   Data.f -0.166187,-0.139558,-0.123624,-0.166187,-0.139558,-0.123624
   Data.l -1
   Data.f 0.756617,7.477476
   Data.f -0.166896,-0.180253,-0.152608,-0.166896,-0.180253,-0.152608
   Data.l -1
   Data.f 0.741358,7.458553
   Data.f -0.168201,-0.22775,-0.180841,-0.168201,-0.22775,-0.180841
   Data.l -1
   Data.f 0.723208,7.439739
   Data.f -0.169743,-0.28058,-0.210835,-0.169743,-0.28058,-0.210835
   Data.l -1
   Data.f 0.702935,7.419656
   Data.f -0.180688,-0.608568,-0.181223,-0.180688,-0.608568,-0.181223
   Data.l -1
   Data.f 0.564942,7.431804
   Data.f -0.170614,-0.318402,-0.234166,-0.170614,-0.318402,-0.234166
   Data.l -1
   Data.f 0.68854,7.404236
   Data.f -0.171457,-0.348863,-0.251382,-0.171457,-0.348863,-0.251382
   Data.l -1
   Data.f 0.67685,7.392735
   Data.f -0.172885,-0.379609,-0.263043,-0.172885,-0.379609,-0.263043
   Data.l -1
   Data.f 0.664697,7.384418
   Data.f -0.175523,-0.418295,-0.269702,-0.175523,-0.418295,-0.269702
   Data.l -1
   Data.f 0.648911,7.378541
   Data.f -0.180037,-0.472563,-0.271912,-0.180037,-0.472563,-0.271912
   Data.l -1
   Data.f 0.62632,7.374353
   Data.f -0.18181,-0.604113,-0.187974,-0.18181,-0.604113,-0.187974
   Data.l -1
   Data.f 0.567098,7.426804
   Data.f -0.1852,-0.591288,-0.204875,-0.1852,-0.591288,-0.204875
   Data.l -1
   Data.f 0.573153,7.413936
   Data.f -0.190783,-0.570905,-0.226888,-0.190783,-0.570905,-0.226888
   Data.l -1
   Data.f 0.582492,7.396452
   Data.f -0.188984,-0.543782,-0.248669,-0.188984,-0.543782,-0.248669
   Data.l -1
   Data.f 0.595036,7.383668
   Data.f -0.184151,-0.510729,-0.265317,-0.184151,-0.510729,-0.265317
   Data.l -1
   Data.f 0.609922,7.376026
   Data.f -0.179091,-0.422563,0.40859,-0.179091,-0.422563,0.40859
   Data.l -1
   Data.f 0.609043,7.809029
   Data.f -0.179185,-0.422693,0.409595,-0.179185,-0.422693,0.409595
   Data.l -1
   Data.f 0.608928,7.80961
   Data.f -0.178833,-0.422197,0.405743,-0.178833,-0.422197,0.405743
   Data.l -1
   Data.f 0.609369,7.807373
   Data.f -0.178429,-0.421617,0.401293,-0.178429,-0.421617,0.401293
   Data.l -1
   Data.f 0.60988,7.804783
   Data.f -0.177894,-0.42087,0.395474,-0.177894,-0.42087,0.395474
   Data.l -1
   Data.f 0.610547,7.8014
   Data.f -0.177264,-0.419969,0.388537,-0.177264,-0.419969,0.388537
   Data.l -1
   Data.f 0.611343,7.797362
   Data.f -0.176543,-0.418958,0.380704,-0.176543,-0.418958,0.380704
   Data.l -1
   Data.f 0.612241,7.792809
   Data.f -0.179935,-0.463999,0.379855,-0.179935,-0.463999,0.379855
   Data.l -1
   Data.f 0.593456,7.79018
   Data.f -0.182997,-0.504248,0.379098,-0.182997,-0.504248,0.379098
   Data.l -1
   Data.f 0.576667,7.787809
   Data.f -0.185606,-0.538195,0.378455,-0.185606,-0.538195,0.378455
   Data.l -1
   Data.f 0.562507,7.785794
   Data.f -0.187628,-0.564318,0.377963,-0.187628,-0.564318,0.377963
   Data.l -1
   Data.f 0.551609,7.784233
   Data.f -0.182039,-0.581103,0.377853,-0.182039,-0.581103,0.377853
   Data.l -1
   Data.f 0.544994,7.787608
   Data.f -0.180035,-0.587034,0.37782,-0.180035,-0.587034,0.37782
   Data.l -1
   Data.f 0.542657,7.788817
   Data.f -0.151322,-0.614233,0.133769,-0.151322,-0.614233,0.133769
   Data.l -1
   Data.f 0.546698,7.650827
   Data.f -0.128032,-0.608568,-0.179612,-0.128032,-0.608568,-0.179612
   Data.l -1
   Data.f 0.567899,7.465267
   Data.f -0.128714,-0.604112,-0.186354,-0.128714,-0.604112,-0.186354
   Data.l -1
   Data.f 0.570079,7.460548
   Data.f -0.130804,-0.591287,-0.203214,-0.130804,-0.591287,-0.203214
   Data.l -1
   Data.f 0.576207,7.448506
   Data.f -0.134306,-0.570905,-0.22516,-0.134306,-0.570905,-0.22516
   Data.l -1
   Data.f 0.585663,7.432348
   Data.f -0.132881,-0.543783,-0.246953,-0.132881,-0.543783,-0.246953
   Data.l -1
   Data.f 0.598186,7.419322
   Data.f -0.129481,-0.510728,-0.263651,-0.129481,-0.510728,-0.263651
   Data.l -1
   Data.f 0.612991,7.410764
   Data.f -0.126676,-0.472562,-0.270285,-0.126676,-0.472562,-0.270285
   Data.l -1
   Data.f 0.629316,7.408264
   Data.f -0.123687,-0.418295,-0.26812,-0.123687,-0.418295,-0.26812
   Data.l -1
   Data.f 0.651821,7.411483
   Data.f -0.121995,-0.379609,-0.26149,-0.121995,-0.379609,-0.26149
   Data.l -1
   Data.f 0.667554,7.416757
   Data.f -0.121158,-0.348863,-0.249847,-0.121158,-0.348863,-0.249847
   Data.l -1
   Data.f 0.679674,7.424697
   Data.f -0.120776,-0.318402,-0.232643,-0.120776,-0.318402,-0.232643
   Data.l -1
   Data.f 0.691338,7.435909
   Data.f -0.120428,-0.280584,-0.20933,-0.120428,-0.280584,-0.20933
   Data.l -1
   Data.f 0.705704,7.450993
   Data.f -0.11971,-0.22775,-0.179357,-0.11971,-0.22775,-0.179357
   Data.l -1
   Data.f 0.72593,7.470556
   Data.f -0.119126,-0.180257,-0.151148,-0.119126,-0.180257,-0.151148
   Data.l -1
   Data.f 0.744039,7.48891
   Data.f -0.11895,-0.139558,-0.122183,-0.11895,-0.139558,-0.122183
   Data.l -1
   Data.f 0.759269,7.507497
   Data.f -0.119047,-0.106481,-0.095076,-0.119047,-0.106481,-0.095076
   Data.l -1
   Data.f 0.771436,7.524729
   Data.f -0.119274,-0.081838,-0.072462,-0.119274,-0.081838,-0.072462
   Data.l -1
   Data.f 0.780355,7.539014
   Data.f -0.119504,-0.066453,-0.05697,-0.119504,-0.066453,-0.05697
   Data.l -1
   Data.f 0.785842,7.548755
   Data.f -0.119614,-0.061143,-0.051223,-0.119614,-0.061143,-0.051223
   Data.l -1
   Data.f 0.787712,7.552356
   Data.f -0.118128,0.020461,-0.005823,-0.118128,0.020461,-0.005823
   Data.l -1
   Data.f 0.819025,7.582229
   Data.f -0.118179,0.016974,-0.00802,-0.118179,0.016974,-0.00802
   Data.l -1
   Data.f 0.817701,7.580797
   Data.f -0.118241,0.007884,-0.014569,-0.118241,0.007884,-0.014569
   Data.l -1
   Data.f 0.814303,7.576579
   Data.f -0.1182,-0.004728,-0.025405,-0.1182,-0.004728,-0.025405
   Data.l -1
   Data.f 0.809692,7.569693
   Data.f -0.117944,-0.018796,-0.040449,-0.117944,-0.018796,-0.040449
   Data.l -1
   Data.f 0.804727,7.560254
   Data.f -0.117351,-0.032247,-0.059628,-0.117351,-0.032247,-0.059628
   Data.l -1
   Data.f 0.800267,7.548384
   Data.f -0.116309,-0.043008,-0.082872,-0.116309,-0.043008,-0.082872
   Data.l -1
   Data.f 0.797174,7.534198
   Data.f -0.113855,-0.057626,-0.128689,-0.113855,-0.057626,-0.128689
   Data.l -1
   Data.f 0.793828,7.506483
   Data.f -0.111967,-0.066144,-0.161546,-0.111967,-0.066144,-0.161546
   Data.l -1
   Data.f 0.792248,7.486687
   Data.f -0.110399,-0.071939,-0.187714,-0.110399,-0.071939,-0.187714
   Data.l -1
   Data.f 0.791404,7.470961
   Data.f -0.108892,-0.078374,-0.21346,-0.108892,-0.078374,-0.21346
   Data.l -1
   Data.f 0.790266,7.455466
   Data.f -0.107165,-0.088826,-0.245059,-0.107165,-0.088826,-0.245059
   Data.l -1
   Data.f 0.787806,7.436373
   Data.f -0.104929,-0.106668,-0.288779,-0.104929,-0.106668,-0.288779
   Data.l -1
   Data.f 0.782997,7.409862
   Data.f -0.103651,-0.12013,-0.315788,-0.103651,-0.12013,-0.315788
   Data.l -1
   Data.f 0.779009,7.393419
   Data.f -0.103039,-0.131532,-0.332173,-0.103039,-0.131532,-0.332173
   Data.l -1
   Data.f 0.775242,7.383344
   Data.f -0.102777,-0.142003,-0.343073,-0.102777,-0.142003,-0.343073
   Data.l -1
   Data.f 0.771534,7.376552
   Data.f -0.10254,-0.152658,-0.35363,-0.10254,-0.152658,-0.35363
   Data.l -1
   Data.f 0.767729,7.369963
   Data.f -0.102018,-0.164621,-0.368966,-0.102018,-0.164621,-0.368966
   Data.l -1
   Data.f 0.763667,7.360503
   Data.f -0.100866,-0.179013,-0.394223,-0.100866,-0.179013,-0.394223
   Data.l -1
   Data.f 0.75919,7.345101
   Data.f -0.099634,-0.185823,-0.4152,-0.099634,-0.185823,-0.4152
   Data.l -1
   Data.f 0.757616,7.332478
   Data.f -0.098134,-0.186982,-0.435955,-0.098134,-0.186982,-0.435955
   Data.l -1
   Data.f 0.758382,7.320162
   Data.f -0.096593,-0.184461,-0.454889,-0.096593,-0.184461,-0.454889
   Data.l -1
   Data.f 0.760572,7.309036
   Data.f -0.095221,-0.180227,-0.470396,-0.095221,-0.180227,-0.470396
   Data.l -1
   Data.f 0.763269,7.299987
   Data.f -0.09425,-0.176244,-0.480873,-0.09425,-0.176244,-0.480873
   Data.l -1
   Data.f 0.765559,7.293904
   Data.f -0.093876,-0.174482,-0.484723,-0.093876,-0.174482,-0.484723
   Data.l -1
   Data.f 0.766526,7.291678
   Data.f -0.089241,-0.08381,-0.489121,-0.089241,-0.08381,-0.489121
   Data.l -1
   Data.f 0.804555,7.291728
   Data.f -0.084716,-0.123479,-0.576292,-0.084716,-0.123479,-0.576292
   Data.l -1
   Data.f 0.793274,7.238909
   Data.f -0.083929,-0.110738,-0.579189,-0.083929,-0.110738,-0.579189
   Data.l -1
   Data.f 0.798752,7.237546
   Data.f -0.082088,-0.078607,-0.584823,-0.082088,-0.078607,-0.584823
   Data.l -1
   Data.f 0.812469,7.235086
   Data.f -0.079953,-0.036206,-0.588621,-0.079953,-0.036206,-0.588621
   Data.l -1
   Data.f 0.830347,7.233978
   Data.f -0.078254,0.007323,-0.586005,-0.078254,0.007323,-0.586005
   Data.l -1
   Data.f 0.848309,7.236693
   Data.f -0.077673,0.042857,-0.572402,-0.077673,0.042857,-0.572402
   Data.l -1
   Data.f 0.862285,7.245729
   Data.f -0.078888,0.061263,-0.54323,-0.078888,0.061263,-0.54323
   Data.l -1
   Data.f 0.868201,7.263589
   Data.f -0.080988,0.075095,-0.503695,-0.080988,0.075095,-0.503695
   Data.l -1
   Data.f 0.871593,7.287515
   Data.f -0.082619,0.099379,-0.463886,-0.082619,0.099379,-0.463886
   Data.l -1
   Data.f 0.879323,7.311903
   Data.f -0.08381,0.128699,-0.426587,-0.08381,0.128699,-0.426587
   Data.l -1
   Data.f 0.889301,7.33496
   Data.f -0.084632,0.157641,-0.394572,-0.084632,0.157641,-0.394572
   Data.l -1
   Data.f 0.89944,7.354879
   Data.f -0.085159,0.180793,-0.370607,-0.085159,0.180793,-0.370607
   Data.l -1
   Data.f 0.90765,7.369842
   Data.f -0.085474,0.192733,-0.35747,-0.085474,0.192733,-0.35747
   Data.l -1
   Data.f 0.911839,7.378026
   Data.f -0.085581,0.198737,-0.351656,-0.085581,0.198737,-0.351656
   Data.l -1
   Data.f 0.913992,7.38167
   Data.f -0.085468,0.207511,-0.347223,-0.085468,0.207511,-0.347223
   Data.l -1
   Data.f 0.91738,7.384569
   Data.f -0.085206,0.218802,-0.343284,-0.085206,0.218802,-0.343284
   Data.l -1
   Data.f 0.921848,7.38724
   Data.f -0.084862,0.232364,-0.338975,-0.084862,0.232364,-0.338975
   Data.l -1
   Data.f 0.927236,7.390203
   Data.f -0.084513,0.247935,-0.333396,-0.084513,0.247935,-0.333396
   Data.l -1
   Data.f 0.933389,7.393977
   Data.f -0.084218,0.265273,-0.325679,-0.084218,0.265273,-0.325679
   Data.l -1
   Data.f 0.940148,7.399081
   Data.f -0.084343,0.286261,-0.308634,-0.084343,0.286261,-0.308634
   Data.l -1
   Data.f 0.947872,7.409876
   Data.f -0.085028,0.310775,-0.280013,-0.085028,0.310775,-0.280013
   Data.l -1
   Data.f 0.956377,7.427711
   Data.f -0.085989,0.335543,-0.246363,-0.085989,0.335543,-0.246363
   Data.l -1
   Data.f 0.964688,7.448584
   Data.f -0.086975,0.357287,-0.214222,-0.086975,0.357287,-0.214222
   Data.l -1
   Data.f 0.971833,7.46848
   Data.f -0.087738,0.372733,-0.190139,-0.087738,0.372733,-0.190139
   Data.l -1
   Data.f 0.976835,7.483373
   Data.f -0.088042,0.378611,-0.180659,-0.088042,0.378611,-0.180659
   Data.l -1
   Data.f 0.978719,7.489233
   Data.f -0.091046,0.406947,-0.109316,-0.091046,0.406947,-0.109316
   Data.l -1
   Data.f 0.986282,7.532893
   Data.f -0.091024,0.409236,-0.107958,-0.091024,0.409236,-0.107958
   Data.l -1
   Data.f 0.987157,7.533773
   Data.f -0.090915,0.416056,-0.10432,-0.090915,0.416056,-0.10432
   Data.l -1
   Data.f 0.98978,7.536161
   Data.f -0.090696,0.427306,-0.099021,-0.090696,0.427306,-0.099021
   Data.l -1
   Data.f 0.994151,7.539676
   Data.f -0.090329,0.442893,-0.092691,-0.090329,0.442893,-0.092691
   Data.l -1
   Data.f 1.000268,7.543939
   Data.f -0.089781,0.462726,-0.085961,-0.089781,0.462726,-0.085961
   Data.l -1
   Data.f 1.00813,7.548569
   Data.f -0.08903,0.486716,-0.079455,-0.08903,0.486716,-0.079455
   Data.l -1
   Data.f 1.017736,7.553183
   Data.f -0.087791,0.523818,-0.07076,-0.087791,0.523818,-0.07076
   Data.l -1
   Data.f 1.032673,7.559492
   Data.f -0.086828,0.551982,-0.064792,-0.086828,0.551982,-0.064792
   Data.l -1
   Data.f 1.044049,7.563893
   Data.f -0.085971,0.574752,-0.061295,-0.085971,0.574752,-0.061295
   Data.l -1
   Data.f 1.053324,7.566651
   Data.f -0.085087,0.595679,-0.059992,-0.085087,0.595679,-0.059992
   Data.l -1
   Data.f 1.061961,7.568028
   Data.f -0.084018,0.618312,-0.060616,-0.084018,0.618312,-0.060616
   Data.l -1
   Data.f 1.071421,7.568288
   Data.f -0.082632,0.646189,-0.062896,-0.082632,0.646189,-0.062896
   Data.l -1
   Data.f 1.083165,7.567687
   Data.f -0.081887,0.668235,-0.058678,-0.081887,0.668235,-0.058678
   Data.l -1
   Data.f 1.092093,7.570838
   Data.f -0.0825,0.673487,-0.043186,-0.0825,0.673487,-0.043186
   Data.l -1
   Data.f 1.093365,7.580341
   Data.f -0.084068,0.665721,-0.021192,-0.084068,0.665721,-0.021192
   Data.l -1
   Data.f 1.088832,7.593404
   Data.f -0.086162,0.648688,0.002499,-0.086162,0.648688,0.002499
   Data.l -1
   Data.f 1.08034,7.60723
   Data.f -0.088358,0.626155,0.02311,-0.088358,0.626155,0.02311
   Data.l -1
   Data.f 1.069739,7.619024
   Data.f -0.090224,0.601889,0.035856,-0.090224,0.601889,0.035856
   Data.l -1
   Data.f 1.058878,7.626003
   Data.f -0.093491,0.550513,0.049633,-0.093491,0.550513,0.049633
   Data.l -1
   Data.f 1.036663,7.632782
   Data.f -0.096674,0.499518,0.061,-0.096674,0.499518,0.061
   Data.l -1
   Data.f 1.014745,7.638073
   Data.f -0.099589,0.452929,0.070498,-0.099589,0.452929,0.070498
   Data.l -1
   Data.f 0.994768,7.642335
   Data.f -0.102048,0.414756,0.078673,-0.102048,0.414756,0.078673
   Data.l -1
   Data.f 0.978375,7.646036
   Data.f -0.103849,0.389022,0.086076,-0.103849,0.389022,0.086076
   Data.l -1
   Data.f 0.96721,7.649649
   Data.f -0.104776,0.379744,0.09324,-0.104776,0.379744,0.09324
   Data.l -1
   Data.f 0.962917,7.653646
   Data.f -0.109147,0.368178,0.154418,-0.109147,0.368178,0.154418
   Data.l -1
   Data.f 0.954461,7.689976
   Data.f -0.115415,0.33105,0.222097,-0.115415,0.33105,0.222097
   Data.l -1
   Data.f 0.934956,7.729291
   Data.f -0.123294,0.271506,0.292238,-0.123294,0.271506,0.292238
   Data.l -1
   Data.f 0.905944,7.769178
   Data.f -0.132553,0.192691,0.360831,-0.132553,0.192691,0.360831
   Data.l -1
   Data.f 0.868967,7.807232
   Data.f -0.142888,0.097762,0.42385,-0.142888,0.097762,0.42385
   Data.l -1
   Data.f 0.825571,7.841065
   Data.f -0.153936,-0.010141,0.477266,-0.153936,-0.010141,0.477266
   Data.l -1
   Data.f 0.777303,7.868334
   Data.f -0.164117,-0.110677,0.518766,-0.164117,-0.110677,0.518766
   Data.l -1
   Data.f 0.732798,7.888532
   Data.f -0.172119,-0.187284,0.54962,-0.172119,-0.187284,0.54962
   Data.l -1
   Data.f 0.698915,7.903286
   Data.f -0.177993,-0.242482,0.571216,-0.177993,-0.242482,0.571216
   Data.l -1
   Data.f 0.674529,7.913444
   Data.f -0.181891,-0.278794,0.584935,-0.181891,-0.278794,0.584935
   Data.l -1
   Data.f 0.658514,7.919794
   Data.f -0.184027,-0.298734,0.592152,-0.184027,-0.298734,0.592152
   Data.l -1
   Data.f 0.649737,7.923081
   Data.f -0.184682,-0.304818,0.594256,-0.184682,-0.304818,0.594256
   Data.l -1
   Data.f 0.647063,7.924021
   Data.f -0.10991,-0.422563,0.410706,-0.10991,-0.422563,0.410706
   Data.l -1
   Data.f 0.612927,7.852995
   Data.f -0.109969,-0.422693,0.411708,-0.109969,-0.422693,0.411708
   Data.l -1
   Data.f 0.612814,7.853598
   Data.f -0.109739,-0.422197,0.407858,-0.109739,-0.422197,0.407858
   Data.l -1
   Data.f 0.613249,7.851285
   Data.f -0.109466,-0.421617,0.403402,-0.109466,-0.421617,0.403402
   Data.l -1
   Data.f 0.613752,7.848609
   Data.f -0.109107,-0.42087,0.397578,-0.109107,-0.42087,0.397578
   Data.l -1
   Data.f 0.614409,7.845114
   Data.f -0.108688,-0.419969,0.39063,-0.108688,-0.419969,0.39063
   Data.l -1
   Data.f 0.615193,7.840942
   Data.f -0.108208,-0.418958,0.382795,-0.108208,-0.418958,0.382795
   Data.l -1
   Data.f 0.616077,7.836237
   Data.f -0.109888,-0.463999,0.381998,-0.109888,-0.463999,0.381998
   Data.l -1
   Data.f 0.597388,7.834693
   Data.f -0.111414,-0.504247,0.381288,-0.111414,-0.504247,0.381288
   Data.l -1
   Data.f 0.580686,7.833302
   Data.f -0.112705,-0.538194,0.380683,-0.112705,-0.538194,0.380683
   Data.l -1
   Data.f 0.5666,7.83212
   Data.f -0.113713,-0.564317,0.380221,-0.113713,-0.564317,0.380221
   Data.l -1
   Data.f 0.555759,7.831206
   Data.f -0.110916,-0.581102,0.380031,-0.110916,-0.581102,0.380031
   Data.l -1
   Data.f 0.548987,7.832808
   Data.f -0.109911,-0.587034,0.379962,-0.109911,-0.587034,0.379962
   Data.l -1
   Data.f 0.546595,7.833382
   Data.f -0.091819,-0.614232,0.135593,-0.091819,-0.614232,0.135593
   Data.l -1
   Data.f 0.550039,7.688644
   Data.f -0.075378,-0.608567,-0.178005,-0.075378,-0.608567,-0.178005
   Data.l -1
   Data.f 0.570855,7.498729
   Data.f -0.075616,-0.604112,-0.184731,-0.075616,-0.604112,-0.184731
   Data.l -1
   Data.f 0.573061,7.494291
   Data.f -0.076406,-0.591287,-0.201551,-0.076406,-0.591287,-0.201551
   Data.l -1
   Data.f 0.579262,7.483076
   Data.f -0.07782,-0.570905,-0.223435,-0.07782,-0.570905,-0.223435
   Data.l -1
   Data.f 0.588835,7.468244
   Data.f -0.076772,-0.543782,-0.245242,-0.076772,-0.543782,-0.245242
   Data.l -1
   Data.f 0.601336,7.454977
   Data.f -0.074825,-0.510728,-0.261979,-0.074825,-0.510728,-0.261979
   Data.l -1
   Data.f 0.61606,7.445503
   Data.f -0.073312,-0.472562,-0.268655,-0.073312,-0.472562,-0.268655
   Data.l -1
   Data.f 0.632312,7.442174
   Data.f -0.071852,-0.418295,-0.266539,-0.071852,-0.418295,-0.266539
   Data.l -1
   Data.f 0.654732,7.444426
   Data.f -0.071105,-0.379609,-0.259938,-0.071105,-0.379609,-0.259938
   Data.l -1
   Data.f 0.670412,7.449096
   Data.f -0.070867,-0.348863,-0.248311,-0.070867,-0.348863,-0.248311
   Data.l -1
   Data.f 0.682498,7.45666
   Data.f -0.070937,-0.318402,-0.23112,-0.070937,-0.318402,-0.23112
   Data.l -1
   Data.f 0.694136,7.467582
   Data.f -0.071121,-0.280584,-0.207823,-0.071121,-0.280584,-0.207823
   Data.l -1
   Data.f 0.708473,7.48233
   Data.f -0.071213,-0.22775,-0.177878,-0.071213,-0.22775,-0.177878
   Data.l -1
   Data.f 0.728653,7.501373
   Data.f -0.071349,-0.180257,-0.149693,-0.071349,-0.180257,-0.149693
   Data.l -1
   Data.f 0.746722,7.519269
   Data.f -0.071709,-0.139558,-0.120735,-0.071709,-0.139558,-0.120735
   Data.l -1
   Data.f 0.761922,7.53752
   Data.f -0.072171,-0.106481,-0.093641,-0.072171,-0.106481,-0.093641
   Data.l -1
   Data.f 0.774068,7.554519
   Data.f -0.072628,-0.081838,-0.071038,-0.072628,-0.081838,-0.071038
   Data.l -1
   Data.f 0.782974,7.568655
   Data.f -0.072983,-0.066453,-0.055547,-0.072983,-0.066453,-0.055547
   Data.l -1
   Data.f 0.788454,7.57832
   Data.f -0.073122,-0.061143,-0.0498,-0.073122,-0.061143,-0.0498
   Data.l -1
   Data.f 0.790322,7.581899
   Data.f -0.073073,0.020461,-0.004443,-0.073073,0.020461,-0.004443
   Data.l -1
   Data.f 0.821554,7.610862
   Data.f -0.07306,0.016974,-0.006645,-0.07306,0.016974,-0.006645
   Data.l -1
   Data.f 0.820234,7.609467
   Data.f -0.072993,0.007884,-0.013188,-0.072993,0.007884,-0.013188
   Data.l -1
   Data.f 0.816844,7.605332
   Data.f -0.072811,-0.004728,-0.024016,-0.072811,-0.004728,-0.024016
   Data.l -1
   Data.f 0.812241,7.598538
   Data.f -0.072455,-0.018796,-0.039056,-0.072455,-0.018796,-0.039056
   Data.l -1
   Data.f 0.807281,7.589166
   Data.f -0.071862,-0.032247,-0.058234,-0.071862,-0.032247,-0.058234
   Data.l -1
   Data.f 0.802822,7.577294
   Data.f -0.070989,-0.043008,-0.081485,-0.070989,-0.043008,-0.081485
   Data.l -1
   Data.f 0.799719,7.563002
   Data.f -0.06906,-0.057626,-0.127322,-0.06906,-0.057626,-0.127322
   Data.l -1
   Data.f 0.796343,7.534951
   Data.f -0.067614,-0.066144,-0.16019,-0.067614,-0.066144,-0.16019
   Data.l -1
   Data.f 0.794738,7.514874
   Data.f -0.06643,-0.071939,-0.186371,-0.06643,-0.071939,-0.186371
   Data.l -1
   Data.f 0.793873,7.498904
   Data.f -0.065287,-0.078374,-0.212126,-0.065287,-0.078374,-0.212126
   Data.l -1
   Data.f 0.792715,7.483181
   Data.f -0.063933,-0.088826,-0.243737,-0.063933,-0.088826,-0.243737
   Data.l -1
   Data.f 0.790233,7.463846
   Data.f -0.06215,-0.106668,-0.287471,-0.06215,-0.106668,-0.287471
   Data.l -1
   Data.f 0.785398,7.437048
   Data.f -0.061099,-0.12013,-0.314487,-0.061099,-0.12013,-0.314487
   Data.l -1
   Data.f 0.781398,7.420464
   Data.f -0.060545,-0.131532,-0.330872,-0.060545,-0.131532,-0.330872
   Data.l -1
   Data.f 0.777628,7.410352
   Data.f -0.06024,-0.142003,-0.341779,-0.06024,-0.142003,-0.341779
   Data.l -1
   Data.f 0.773923,7.403581
   Data.f -0.059967,-0.152658,-0.352327,-0.059967,-0.152658,-0.352327
   Data.l -1
   Data.f 0.77012,7.397021
   Data.f -0.059468,-0.164621,-0.367668,-0.059468,-0.164621,-0.367668
   Data.l -1
   Data.f 0.766056,7.387543
   Data.f -0.058504,-0.179013,-0.392931,-0.058504,-0.179013,-0.392931
   Data.l -1
   Data.f 0.761568,7.37202
   Data.f -0.057567,-0.185823,-0.413917,-0.057567,-0.185823,-0.413917
   Data.l -1
   Data.f 0.759978,7.35921
   Data.f -0.0565,-0.186982,-0.434685,-0.0565,-0.186982,-0.434685
   Data.l -1
   Data.f 0.76072,7.34662
   Data.f -0.05544,-0.184461,-0.453631,-0.05544,-0.184461,-0.453631
   Data.l -1
   Data.f 0.762882,7.335188
   Data.f -0.05452,-0.180227,-0.469151,-0.05452,-0.180227,-0.469151
   Data.l -1
   Data.f 0.765555,7.325854
   Data.f -0.053874,-0.176244,-0.479639,-0.053874,-0.176244,-0.479639
   Data.l -1
   Data.f 0.767826,7.319562
   Data.f -0.053622,-0.174482,-0.483496,-0.053622,-0.174482,-0.483496
   Data.l -1
   Data.f 0.768786,7.317255
   Data.f -0.051239,-0.08381,-0.48796,-0.051239,-0.08381,-0.48796
   Data.l -1
   Data.f 0.806688,7.315877
   Data.f -0.047643,-0.123479,-0.575163,-0.047643,-0.123479,-0.575163
   Data.l -1
   Data.f 0.795355,7.262467
   Data.f -0.047206,-0.110738,-0.578066,-0.047206,-0.110738,-0.578066
   Data.l -1
   Data.f 0.800814,7.260883
   Data.f -0.0462,-0.078607,-0.583723,-0.0462,-0.078607,-0.583723
   Data.l -1
   Data.f 0.814484,7.257893
   Data.f -0.045073,-0.036206,-0.587555,-0.045073,-0.036206,-0.587555
   Data.l -1
   Data.f 0.832305,7.256145
   Data.f -0.044262,0.007323,-0.584969,-0.044262,0.007323,-0.584969
   Data.l -1
   Data.f 0.850218,7.258295
   Data.f -0.04418,0.042857,-0.571377,-0.04418,0.042857,-0.571377
   Data.l -1
   Data.f 0.864166,7.267014
   Data.f -0.045229,0.061263,-0.542202,-0.045229,0.061263,-0.542202
   Data.l -1
   Data.f 0.870091,7.284977
   Data.f -0.046892,0.075095,-0.502648,-0.046892,0.075095,-0.502648
   Data.l -1
   Data.f 0.873508,7.309186
   Data.f -0.04831,0.099379,-0.462838,-0.04831,0.099379,-0.462838
   Data.l -1
   Data.f 0.881249,7.333706
   Data.f -0.04948,0.128699,-0.425537,-0.04948,0.128699,-0.425537
   Data.l -1
   Data.f 0.891229,7.356781
   Data.f -0.050379,0.157641,-0.393521,-0.050379,0.157641,-0.393521
   Data.l -1
   Data.f 0.901364,7.37665
   Data.f -0.051006,0.180793,-0.369561,-0.051006,0.180793,-0.369561
   Data.l -1
   Data.f 0.909567,7.391547
   Data.f -0.051363,0.192733,-0.356429,-0.051363,0.192733,-0.356429
   Data.l -1
   Data.f 0.913754,7.399704
   Data.f -0.051508,0.198737,-0.350615,-0.051508,0.198737,-0.350615
   Data.l -1
   Data.f 0.915905,7.403325
   Data.f -0.051515,0.207511,-0.346186,-0.051515,0.207511,-0.346186
   Data.l -1
   Data.f 0.919287,7.406145
   Data.f -0.05145,0.218802,-0.342255,-0.05145,0.218802,-0.342255
   Data.l -1
   Data.f 0.923743,7.408694
   Data.f -0.051339,0.232364,-0.33795,-0.051339,0.232364,-0.33795
   Data.l -1
   Data.f 0.929119,7.411507
   Data.f -0.051251,0.247935,-0.332382,-0.051251,0.247935,-0.332382
   Data.l -1
   Data.f 0.935257,7.415114
   Data.f -0.051221,0.265273,-0.324673,-0.051221,0.265273,-0.324673
   Data.l -1
   Data.f 0.942001,7.42005
   Data.f -0.051543,0.286261,-0.307635,-0.051543,0.286261,-0.307635
   Data.l -1
   Data.f 0.949714,7.43072
   Data.f -0.052324,0.310775,-0.279013,-0.052324,0.310775,-0.279013
   Data.l -1
   Data.f 0.958213,7.448495
   Data.f -0.053317,0.335543,-0.245367,-0.053317,0.335543,-0.245367
   Data.l -1
   Data.f 0.966523,7.469348
   Data.f -0.054301,0.357287,-0.213224,-0.054301,0.357287,-0.213224
   Data.l -1
   Data.f 0.973667,7.489244
   Data.f -0.055053,0.372733,-0.189139,-0.055053,0.372733,-0.189139
   Data.l -1
   Data.f 0.97867,7.504146
   Data.f -0.055348,0.378611,-0.179661,-0.055348,0.378611,-0.179661
   Data.l -1
   Data.f 0.980554,7.510011
   Data.f -0.067327,0.389022,0.087189,-0.067327,0.389022,0.087189
   Data.l -1
   Data.f 0.969261,7.672856
   Data.f -0.067899,0.379744,0.094365,-0.067899,0.379744,0.094365
   Data.l -1
   Data.f 0.964988,7.677079
   Data.f -0.071026,0.368178,0.155584,-0.071026,0.368178,0.155584
   Data.l -1
   Data.f 0.956602,7.714206
   Data.f -0.075191,0.33105,0.223322,-0.075191,0.33105,0.223322
   Data.l -1
   Data.f 0.937214,7.754851
   Data.f -0.080209,0.271506,0.293557,-0.080209,0.271506,0.293557
   Data.l -1
   Data.f 0.908363,7.796562
   Data.f -0.085892,0.192691,0.362262,-0.085892,0.192691,0.362262
   Data.l -1
   Data.f 0.871587,7.836888
   Data.f -0.092025,0.097762,0.425404,-0.092025,0.097762,0.425404
   Data.l -1
   Data.f 0.828427,7.87339
   Data.f -0.098366,-0.010141,0.478964,-0.098366,-0.010141,0.478964
   Data.l -1
   Data.f 0.780423,7.903648
   Data.f -0.104096,-0.110677,0.5206,-0.104096,-0.110677,0.5206
   Data.l -1
   Data.f 0.736169,7.926677
   Data.f -0.108566,-0.187284,0.551558,-0.108566,-0.187284,0.551558
   Data.l -1
   Data.f 0.702483,7.943671
   Data.f -0.111839,-0.242482,0.573235,-0.111839,-0.242482,0.573235
   Data.l -1
   Data.f 0.678244,7.955484
   Data.f -0.114003,-0.278794,0.587008,-0.114003,-0.278794,0.587008
   Data.l -1
   Data.f 0.662326,7.962938
   Data.f -0.11518,-0.298734,0.594259,-0.11518,-0.298734,0.594259
   Data.l -1
   Data.f 0.653602,7.966835
   Data.f -0.115534,-0.304818,0.596367,-0.115534,-0.304818,0.596367
   Data.l -1
   Data.f 0.650945,7.967961
   Data.f -0.040722,-0.422567,0.41282,-0.040722,-0.422567,0.41282
   Data.l -1
   Data.f 0.616811,7.896963
   Data.f -0.04075,-0.422693,0.413823,-0.04075,-0.422693,0.413823
   Data.l -1
   Data.f 0.6167,7.897584
   Data.f -0.040634,-0.422197,0.409964,-0.040634,-0.422197,0.409964
   Data.l -1
   Data.f 0.617128,7.895197
   Data.f -0.040499,-0.421617,0.405503,-0.040499,-0.421617,0.405503
   Data.l -1
   Data.f 0.617623,7.892436
   Data.f -0.040322,-0.42087,0.39968,-0.040322,-0.42087,0.39968
   Data.l -1
   Data.f 0.61827,7.888828
   Data.f -0.040111,-0.419969,0.392724,-0.040111,-0.419969,0.392724
   Data.l -1
   Data.f 0.619043,7.884521
   Data.f -0.039868,-0.418958,0.384882,-0.039868,-0.418958,0.384882
   Data.l -1
   Data.f 0.619914,7.879666
   Data.f -0.039851,-0.463999,0.384139,-0.039851,-0.463999,0.384139
   Data.l -1
   Data.f 0.60132,7.879205
   Data.f -0.039826,-0.504251,0.38347,-0.039826,-0.504251,0.38347
   Data.l -1
   Data.f 0.584705,7.878794
   Data.f -0.03981,-0.538194,0.382914,-0.03981,-0.538194,0.382914
   Data.l -1
   Data.f 0.570692,7.878447
   Data.f -0.039796,-0.564317,0.382481,-0.039796,-0.564317,0.382481
   Data.l -1
   Data.f 0.559909,7.878179
   Data.f -0.03979,-0.581102,0.382202,-0.03979,-0.581102,0.382202
   Data.l -1
   Data.f 0.55298,7.878007
   Data.f -0.039785,-0.587034,0.382107,-0.039785,-0.587034,0.382107
   Data.l -1
   Data.f 0.550531,7.877947
   Data.f -0.032306,-0.614236,0.137404,-0.032306,-0.614236,0.137404
   Data.l -1
   Data.f 0.55338,7.72646
   Data.f -0.022722,-0.608567,-0.176394,-0.022722,-0.608567,-0.176394
   Data.l -1
   Data.f 0.573811,7.532192
   Data.f -0.022518,-0.604116,-0.183109,-0.022518,-0.604116,-0.183109
   Data.l -1
   Data.f 0.576041,7.528036
   Data.f -0.022007,-0.591287,-0.199888,-0.022007,-0.591287,-0.199888
   Data.l -1
   Data.f 0.582315,7.517646
   Data.f -0.021338,-0.570905,-0.221712,-0.021338,-0.570905,-0.221712
   Data.l -1
   Data.f 0.592005,7.504138
   Data.f -0.020669,-0.543782,-0.243526,-0.020669,-0.543782,-0.243526
   Data.l -1
   Data.f 0.604486,7.490632
   Data.f -0.020161,-0.510728,-0.260308,-0.020161,-0.510728,-0.260308
   Data.l -1
   Data.f 0.619128,7.480241
   Data.f -0.019954,-0.472562,-0.26702,-0.019954,-0.472562,-0.26702
   Data.l -1
   Data.f 0.635307,7.476086
   Data.f -0.02002,-0.418295,-0.26495,-0.02002,-0.418295,-0.26495
   Data.l -1
   Data.f 0.657642,7.477368
   Data.f -0.020219,-0.379613,-0.258378,-0.020219,-0.379613,-0.258378
   Data.l -1
   Data.f 0.673268,7.481437
   Data.f -0.020574,-0.348863,-0.246772,-0.020574,-0.348863,-0.246772
   Data.l -1
   Data.f 0.685321,7.488622
   Data.f -0.021099,-0.318402,-0.229598,-0.021099,-0.318402,-0.229598
   Data.l -1
   Data.f 0.696934,7.499255
   Data.f -0.021805,-0.280584,-0.206317,-0.021805,-0.280584,-0.206317
   Data.l -1
   Data.f 0.711241,7.513668
   Data.f -0.022722,-0.22775,-0.176394,-0.022722,-0.22775,-0.176394
   Data.l -1
   Data.f 0.731376,7.532192
   Data.f -0.023584,-0.180257,-0.148229,-0.023584,-0.180257,-0.148229
   Data.l -1
   Data.f 0.749404,7.549628
   Data.f -0.024463,-0.139558,-0.119296,-0.024463,-0.139558,-0.119296
   Data.l -1
   Data.f 0.764574,7.567542
   Data.f -0.025298,-0.106481,-0.09221,-0.025298,-0.106481,-0.09221
   Data.l -1
   Data.f 0.7767,7.584307
   Data.f -0.025982,-0.081838,-0.069615,-0.025982,-0.081838,-0.069615
   Data.l -1
   Data.f 0.785593,7.598298
   Data.f -0.026456,-0.066453,-0.054129,-0.026456,-0.066453,-0.054129
   Data.l -1
   Data.f 0.791066,7.607885
   Data.f -0.026633,-0.061143,-0.048381,-0.026633,-0.061143,-0.048381
   Data.l -1
   Data.f 0.792932,7.611442
   Data.f -0.02802,0.020461,-0.003066,-0.02802,0.020461,-0.003066
   Data.l -1
   Data.f 0.824084,7.639495
   Data.f -0.027948,0.016974,-0.005266,-0.027948,0.016974,-0.005266
   Data.l -1
   Data.f 0.822767,7.638135
   Data.f -0.027748,0.007884,-0.01181,-0.027748,0.007884,-0.01181
   Data.l -1
   Data.f 0.819384,7.634084
   Data.f -0.027417,-0.004728,-0.022633,-0.027417,-0.004728,-0.022633
   Data.l -1
   Data.f 0.814789,7.627383
   Data.f -0.026961,-0.018796,-0.037667,-0.026961,-0.018796,-0.037667
   Data.l -1
   Data.f 0.809835,7.618076
   Data.f -0.026376,-0.032247,-0.056844,-0.026376,-0.032247,-0.056844
   Data.l -1
   Data.f 0.805376,7.606203
   Data.f -0.025664,-0.043008,-0.080105,-0.025664,-0.043008,-0.080105
   Data.l -1
   Data.f 0.802264,7.591805
   Data.f -0.024264,-0.057626,-0.125954,-0.024264,-0.057626,-0.125954
   Data.l -1
   Data.f 0.798858,7.563419
   Data.f -0.02326,-0.066144,-0.158835,-0.02326,-0.066144,-0.158835
   Data.l -1
   Data.f 0.797228,7.543061
   Data.f -0.022459,-0.071939,-0.185025,-0.022459,-0.071939,-0.185025
   Data.l -1
   Data.f 0.796341,7.526848
   Data.f -0.021673,-0.078374,-0.210795,-0.021673,-0.078374,-0.210795
   Data.l -1
   Data.f 0.795163,7.510895
   Data.f -0.020704,-0.088826,-0.242417,-0.020704,-0.088826,-0.242417
   Data.l -1
   Data.f 0.792661,7.491319
   Data.f -0.019371,-0.106668,-0.286162,-0.019371,-0.106668,-0.286162
   Data.l -1
   Data.f 0.7878,7.464235
   Data.f -0.018545,-0.12013,-0.313184,-0.018545,-0.12013,-0.313184
   Data.l -1
   Data.f 0.783788,7.447508
   Data.f -0.018044,-0.131532,-0.329575,-0.018044,-0.131532,-0.329575
   Data.l -1
   Data.f 0.780014,7.43736
   Data.f -0.017708,-0.142003,-0.340479,-0.017708,-0.142003,-0.340479
   Data.l -1
   Data.f 0.776311,7.430612
   Data.f -0.017388,-0.152658,-0.351028,-0.017388,-0.152658,-0.351028
   Data.l -1
   Data.f 0.77251,7.42408
   Data.f -0.016917,-0.164621,-0.366368,-0.016917,-0.164621,-0.366368
   Data.l -1
   Data.f 0.768445,7.414583
   Data.f -0.016142,-0.179013,-0.391639,-0.016142,-0.179013,-0.391639
   Data.l -1
   Data.f 0.763946,7.39894
   Data.f -0.015506,-0.185823,-0.412629,-0.015506,-0.185823,-0.412629
   Data.l -1
   Data.f 0.76234,7.385943
   Data.f -0.014871,-0.186982,-0.433408,-0.014871,-0.186982,-0.433408
   Data.l -1
   Data.f 0.763057,7.373078
   Data.f -0.014293,-0.184461,-0.452368,-0.014293,-0.184461,-0.452368
   Data.l -1
   Data.f 0.765193,7.361339
   Data.f -0.013814,-0.180227,-0.467911,-0.013814,-0.180227,-0.467911
   Data.l -1
   Data.f 0.76784,7.351722
   Data.f -0.013493,-0.176244,-0.478409,-0.013493,-0.176244,-0.478409
   Data.l -1
   Data.f 0.770093,7.345221
   Data.f -0.013376,-0.174482,-0.482268,-0.013376,-0.174482,-0.482268
   Data.l -1
   Data.f 0.771045,7.342833
   Data.f -0.013237,-0.08381,-0.486798,-0.013237,-0.08381,-0.486798
   Data.l -1
   Data.f 0.808822,7.340028
   Data.f -0.010574,-0.123479,-0.574026,-0.010574,-0.123479,-0.574026
   Data.l -1
   Data.f 0.797437,7.286026
   Data.f -0.010484,-0.110738,-0.576942,-0.010484,-0.110738,-0.576942
   Data.l -1
   Data.f 0.802876,7.28422
   Data.f -0.010309,-0.078607,-0.58263,-0.010309,-0.078607,-0.58263
   Data.l -1
   Data.f 0.816499,7.2807
   Data.f -0.010193,-0.036206,-0.586488,-0.010193,-0.036206,-0.586488
   Data.l -1
   Data.f 0.834263,7.278311
   Data.f -0.010268,0.007323,-0.58393,-0.010268,0.007323,-0.58393
   Data.l -1
   Data.f 0.852126,7.279895
   Data.f -0.010681,0.042857,-0.570356,-0.010681,0.042857,-0.570356
   Data.l -1
   Data.f 0.866046,7.288299
   Data.f -0.01158,0.061263,-0.541173,-0.01158,0.061263,-0.541173
   Data.l -1
   Data.f 0.87198,7.306364
   Data.f -0.012783,0.075095,-0.50161,-0.012783,0.075095,-0.50161
   Data.l -1
   Data.f 0.875422,7.330859
   Data.f -0.014002,0.099379,-0.46179,-0.014002,0.099379,-0.46179
   Data.l -1
   Data.f 0.883175,7.355508
   Data.f -0.015144,0.128699,-0.42449,-0.015144,0.128699,-0.42449
   Data.l -1
   Data.f 0.893157,7.378601
   Data.f -0.016121,0.157641,-0.392477,-0.016121,0.157641,-0.392477
   Data.l -1
   Data.f 0.903287,7.39842
   Data.f -0.016854,0.180793,-0.368517,-0.016854,0.180793,-0.368517
   Data.l -1
   Data.f 0.911485,7.413252
   Data.f -0.017252,0.192733,-0.355388,-0.017252,0.192733,-0.355388
   Data.l -1
   Data.f 0.915669,7.421382
   Data.f -0.017427,0.198737,-0.349575,-0.017427,0.198737,-0.349575
   Data.l -1
   Data.f 0.917818,7.424979
   Data.f -0.017569,0.207511,-0.345148,-0.017569,0.207511,-0.345148
   Data.l -1
   Data.f 0.921193,7.42772
   Data.f -0.017686,0.218802,-0.341227,-0.017686,0.218802,-0.341227
   Data.l -1
   Data.f 0.925639,7.430149
   Data.f -0.017817,0.232364,-0.336923,-0.017817,0.232364,-0.336923
   Data.l -1
   Data.f 0.931001,7.432811
   Data.f -0.017985,0.247935,-0.331366,-0.017985,0.247935,-0.331366
   Data.l -1
   Data.f 0.937124,7.436253
   Data.f -0.018221,0.265273,-0.323664,-0.018221,0.265273,-0.323664
   Data.l -1
   Data.f 0.943853,7.441019
   Data.f -0.018741,0.286261,-0.306633,-0.018741,0.286261,-0.306633
   Data.l -1
   Data.f 0.951556,7.451565
   Data.f -0.01962,0.310775,-0.278013,-0.01962,0.310775,-0.278013
   Data.l -1
   Data.f 0.960049,7.46928
   Data.f -0.020649,0.335543,-0.244364,-0.020649,0.335543,-0.244364
   Data.l -1
   Data.f 0.968357,7.490112
   Data.f -0.021629,0.357287,-0.212228,-0.021629,0.357287,-0.212228
   Data.l -1
   Data.f 0.975502,7.510009
   Data.f -0.022362,0.372733,-0.188143,-0.022362,0.372733,-0.188143
   Data.l -1
   Data.f 0.980505,7.524919
   Data.f -0.022653,0.378611,-0.178659,-0.022653,0.378611,-0.178659
   Data.l -1
   Data.f 0.98239,7.530789
   Data.f -0.032899,0.368178,0.156746,-0.032899,0.368178,0.156746
   Data.l -1
   Data.f 0.958742,7.738434
   Data.f -0.031029,0.379744,0.095491,-0.031029,0.379744,0.095491
   Data.l -1
   Data.f 0.967058,7.700511
   Data.f -0.034972,0.33105,0.224552,-0.034972,0.33105,0.224552
   Data.l -1
   Data.f 0.939472,7.78041
   Data.f -0.037124,0.271506,0.294876,-0.037124,0.271506,0.294876
   Data.l -1
   Data.f 0.910782,7.823945
   Data.f -0.03922,0.192691,0.363681,-0.03922,0.192691,0.363681
   Data.l -1
   Data.f 0.874208,7.866544
   Data.f -0.041154,0.097762,0.426957,-0.041154,0.097762,0.426957
   Data.l -1
   Data.f 0.831283,7.905715
   Data.f -0.042797,-0.010141,0.480662,-0.042797,-0.010141,0.480662
   Data.l -1
   Data.f 0.783543,7.938963
   Data.f -0.044074,-0.110677,0.522435,-0.044074,-0.110677,0.522435
   Data.l -1
   Data.f 0.739539,7.96482
   Data.f -0.045025,-0.187284,0.553505,-0.045025,-0.187284,0.553505
   Data.l -1
   Data.f 0.706051,7.984056
   Data.f -0.045685,-0.242483,0.575254,-0.045685,-0.242483,0.575254
   Data.l -1
   Data.f 0.681958,7.997524
   Data.f -0.046112,-0.278795,0.589085,-0.046112,-0.278795,0.589085
   Data.l -1
   Data.f 0.666137,8.006083
   Data.f -0.046336,-0.298735,0.596363,-0.046336,-0.298735,0.596363
   Data.l -1
   Data.f 0.657468,8.01059
   Data.f -0.046394,-0.304819,0.59848,-0.046394,-0.304819,0.59848
   Data.l -1
   Data.f 0.654827,8.011901
   Data.f 0.028459,-0.422567,0.414935,0.028459,-0.422567,0.414935
   Data.l -1
   Data.f 0.620696,7.94093
   Data.f 0.02846,-0.422693,0.41594,0.02846,-0.422693,0.41594
   Data.l -1
   Data.f 0.620586,7.941571
   Data.f 0.028459,-0.422197,0.412079,0.028459,-0.422197,0.412079
   Data.l -1
   Data.f 0.621008,7.939109
   Data.f 0.028459,-0.421617,0.407617,0.028459,-0.421617,0.407617
   Data.l -1
   Data.f 0.621495,7.936262
   Data.f 0.028463,-0.420869,0.401781,0.028463,-0.420869,0.401781
   Data.l -1
   Data.f 0.622132,7.932541
   Data.f 0.028468,-0.419969,0.39482,0.028468,-0.419969,0.39482
   Data.l -1
   Data.f 0.622893,7.928101
   Data.f 0.028465,-0.418958,0.38697,0.028465,-0.418958,0.38697
   Data.l -1
   Data.f 0.623751,7.923095
   Data.f 0.030194,-0.463998,0.386278,0.030194,-0.463998,0.386278
   Data.l -1
   Data.f 0.605253,7.923717
   Data.f 0.031758,-0.504251,0.38566,0.031758,-0.504251,0.38566
   Data.l -1
   Data.f 0.588724,7.924285
   Data.f 0.033089,-0.538194,0.385139,0.033089,-0.538194,0.385139
   Data.l -1
   Data.f 0.574785,7.924773
   Data.f 0.034118,-0.564317,0.384738,0.034118,-0.564317,0.384738
   Data.l -1
   Data.f 0.564059,7.925152
   Data.f 0.031339,-0.581102,0.384375,0.031339,-0.581102,0.384375
   Data.l -1
   Data.f 0.556974,7.923207
   Data.f 0.030338,-0.587034,0.384249,0.030338,-0.587034,0.384249
   Data.l -1
   Data.f 0.554469,7.922511
   Data.f 0.027195,-0.614232,0.139225,0.027195,-0.614232,0.139225
   Data.l -1
   Data.f 0.556721,7.764276
   Data.f 0.029932,-0.608567,-0.174786,0.029932,-0.608567,-0.174786
   Data.l -1
   Data.f 0.576768,7.565654
   Data.f 0.03058,-0.604112,-0.181486,0.03058,-0.604112,-0.181486
   Data.l -1
   Data.f 0.579023,7.561779
   Data.f 0.032389,-0.591287,-0.198228,0.032389,-0.591287,-0.198228
   Data.l -1
   Data.f 0.58537,7.552216
   Data.f 0.035142,-0.570905,-0.219982,0.035142,-0.570905,-0.219982
   Data.l -1
   Data.f 0.595177,7.540033
   Data.f 0.035431,-0.543782,-0.241812,0.035431,-0.543782,-0.241812
   Data.l -1
   Data.f 0.607636,7.526285
   Data.f 0.034504,-0.510728,-0.258637,0.034504,-0.510728,-0.258637
   Data.l -1
   Data.f 0.622198,7.514979
   Data.f 0.033407,-0.472562,-0.265392,0.033407,-0.472562,-0.265392
   Data.l -1
   Data.f 0.638304,7.509996
   Data.f 0.031818,-0.418295,-0.263365,0.031818,-0.418295,-0.263365
   Data.l -1
   Data.f 0.660552,7.51031
   Data.f 0.030671,-0.379614,-0.256826,0.030671,-0.379614,-0.256826
   Data.l -1
   Data.f 0.676126,7.513776
   Data.f 0.029725,-0.348864,-0.245238,0.029725,-0.348864,-0.245238
   Data.l -1
   Data.f 0.688145,7.520583
   Data.f 0.028739,-0.318403,-0.228075,0.028739,-0.318403,-0.228075
   Data.l -1
   Data.f 0.699732,7.530928
   Data.f 0.027504,-0.280585,-0.204807,0.027504,-0.280585,-0.204807
   Data.l -1
   Data.f 0.71401,7.545005
   Data.f 0.025775,-0.227751,-0.174914,0.025775,-0.227751,-0.174914
   Data.l -1
   Data.f 0.734098,7.56301
   Data.f 0.024192,-0.180257,-0.146773,0.024192,-0.180257,-0.146773
   Data.l -1
   Data.f 0.752086,7.579986
   Data.f 0.022776,-0.139558,-0.117851,0.022776,-0.139558,-0.117851
   Data.l -1
   Data.f 0.767227,7.597564
   Data.f 0.021582,-0.106481,-0.090783,0.021582,-0.106481,-0.090783
   Data.l -1
   Data.f 0.779332,7.614097
   Data.f 0.020659,-0.081838,-0.068187,0.020659,-0.081838,-0.068187
   Data.l -1
   Data.f 0.788212,7.62794
   Data.f 0.020065,-0.066453,-0.052705,0.020065,-0.066453,-0.052705
   Data.l -1
   Data.f 0.793678,7.63745
   Data.f 0.019856,-0.061143,-0.046962,0.019856,-0.061143,-0.046962
   Data.l -1
   Data.f 0.795542,7.640985
   Data.f 0.017039,0.020461,-0.001694,0.017039,0.020461,-0.001694
   Data.l -1
   Data.f 0.826614,7.668128
   Data.f 0.017164,0.016974,-0.003886,0.017164,0.016974,-0.003886
   Data.l -1
   Data.f 0.8253,7.666804
   Data.f 0.017494,0.007884,-0.010424,0.017494,0.007884,-0.010424
   Data.l -1
   Data.f 0.821924,7.662837
   Data.f 0.017972,-0.004728,-0.021244,0.017972,-0.004728,-0.021244
   Data.l -1
   Data.f 0.817338,7.65623
   Data.f 0.018534,-0.018796,-0.036278,0.018534,-0.018796,-0.036278
   Data.l -1
   Data.f 0.812389,7.646986
   Data.f 0.019116,-0.032247,-0.055458,0.019116,-0.032247,-0.055458
   Data.l -1
   Data.f 0.80793,7.635111
   Data.f 0.019659,-0.043008,-0.078714,0.019659,-0.043008,-0.078714
   Data.l -1
   Data.f 0.804808,7.620608
   Data.f 0.020534,-0.057626,-0.124584,0.020534,-0.057626,-0.124584
   Data.l -1
   Data.f 0.801373,7.591887
   Data.f 0.021093,-0.066144,-0.157479,0.021093,-0.066144,-0.157479
   Data.l -1
   Data.f 0.799719,7.571248
   Data.f 0.02151,-0.071939,-0.183682,0.02151,-0.071939,-0.183682
   Data.l -1
   Data.f 0.79881,7.554791
   Data.f 0.021941,-0.078374,-0.209463,0.021941,-0.078374,-0.209463
   Data.l -1
   Data.f 0.797612,7.538609
   Data.f 0.022525,-0.088826,-0.241098,0.022525,-0.088826,-0.241098
   Data.l -1
   Data.f 0.795088,7.518792
   Data.f 0.023411,-0.106668,-0.284861,0.023411,-0.106668,-0.284861
   Data.l -1
   Data.f 0.790202,7.491422
   Data.f 0.024014,-0.12013,-0.311884,0.024014,-0.12013,-0.311884
   Data.l -1
   Data.f 0.786177,7.474552
   Data.f 0.024456,-0.131532,-0.328278,0.024456,-0.131532,-0.328278
   Data.l -1
   Data.f 0.7824,7.464368
   Data.f 0.024824,-0.142003,-0.339178,0.024824,-0.142003,-0.339178
   Data.l -1
   Data.f 0.778699,7.457641
   Data.f 0.025193,-0.152658,-0.349726,0.025193,-0.152658,-0.349726
   Data.l -1
   Data.f 0.774901,7.451138
   Data.f 0.025632,-0.164621,-0.36507,0.025632,-0.164621,-0.36507
   Data.l -1
   Data.f 0.770833,7.441623
   Data.f 0.026214,-0.179017,-0.390342,0.026214,-0.179017,-0.390342
   Data.l -1
   Data.f 0.766324,7.425858
   Data.f 0.026563,-0.185823,-0.411343,0.026563,-0.185823,-0.411343
   Data.l -1
   Data.f 0.764701,7.412676
   Data.f 0.026762,-0.186982,-0.432139,0.026762,-0.186982,-0.432139
   Data.l -1
   Data.f 0.765395,7.399536
   Data.f 0.026864,-0.184461,-0.451118,0.026864,-0.184461,-0.451118
   Data.l -1
   Data.f 0.767503,7.387491
   Data.f 0.026889,-0.180227,-0.466663,0.026889,-0.180227,-0.466663
   Data.l -1
   Data.f 0.770125,7.377589
   Data.f 0.026883,-0.176248,-0.477174,0.026883,-0.176248,-0.477174
   Data.l -1
   Data.f 0.77236,7.37088
   Data.f 0.026872,-0.174482,-0.481036,0.026872,-0.174482,-0.481036
   Data.l -1
   Data.f 0.773305,7.368411
   Data.f 0.024765,-0.08381,-0.485637,0.024765,-0.08381,-0.485637
   Data.l -1
   Data.f 0.810956,7.364177
   Data.f 0.026493,-0.123479,-0.572893,0.026493,-0.123479,-0.572893
   Data.l -1
   Data.f 0.799518,7.309583
   Data.f 0.026237,-0.110738,-0.575821,0.026237,-0.110738,-0.575821
   Data.l -1
   Data.f 0.804938,7.307557
   Data.f 0.025576,-0.078607,-0.581532,0.025576,-0.078607,-0.581532
   Data.l -1
   Data.f 0.818514,7.303508
   Data.f 0.024687,-0.036206,-0.585422,0.024687,-0.036206,-0.585422
   Data.l -1
   Data.f 0.836222,7.300477
   Data.f 0.023717,0.007323,-0.582889,0.023717,0.007323,-0.582889
   Data.l -1
   Data.f 0.854035,7.301496
   Data.f 0.022803,0.042857,-0.56933,0.022803,0.042857,-0.56933
   Data.l -1
   Data.f 0.867927,7.309583
   Data.f 0.022079,0.061263,-0.540146,0.022079,0.061263,-0.540146
   Data.l -1
   Data.f 0.87387,7.327751
   Data.f 0.021313,0.075095,-0.500563,0.021313,0.075095,-0.500563
   Data.l -1
   Data.f 0.877337,7.35253
   Data.f 0.020307,0.099379,-0.460742,0.020307,0.099379,-0.460742
   Data.l -1
   Data.f 0.885101,7.377312
   Data.f 0.019194,0.128699,-0.423441,0.019194,0.128699,-0.423441
   Data.l -1
   Data.f 0.895085,7.400421
   Data.f 0.018138,0.157641,-0.39143,0.018138,0.157641,-0.39143
   Data.l -1
   Data.f 0.905211,7.42019
   Data.f 0.017305,0.180793,-0.367475,0.017305,0.180793,-0.367475
   Data.l -1
   Data.f 0.913403,7.434957
   Data.f 0.016861,0.192733,-0.354344,0.016861,0.192733,-0.354344
   Data.l -1
   Data.f 0.917585,7.443059
   Data.f 0.016645,0.198737,-0.348534,0.016645,0.198737,-0.348534
   Data.l -1
   Data.f 0.919731,7.446634
   Data.f 0.016384,0.207511,-0.344111,0.016384,0.207511,-0.344111
   Data.l -1
   Data.f 0.923099,7.449296
   Data.f 0.016072,0.218802,-0.340194,0.016072,0.218802,-0.340194
   Data.l -1
   Data.f 0.927534,7.451602
   Data.f 0.015703,0.232364,-0.3359,0.015703,0.232364,-0.3359
   Data.l -1
   Data.f 0.932883,7.454115
   Data.f 0.015271,0.247935,-0.330347,0.015271,0.247935,-0.330347
   Data.l -1
   Data.f 0.938992,7.45739
   Data.f 0.01477,0.265273,-0.322654,0.01477,0.265273,-0.322654
   Data.l -1
   Data.f 0.945706,7.461988
   Data.f 0.014055,0.286261,-0.305627,0.014055,0.286261,-0.305627
   Data.l -1
   Data.f 0.953397,7.472409
   Data.f 0.01309,0.310775,-0.277018,0.01309,0.310775,-0.277018
   Data.l -1
   Data.f 0.961886,7.490064
   Data.f 0.012025,0.335543,-0.243365,0.012025,0.335543,-0.243365
   Data.l -1
   Data.f 0.970192,7.510876
   Data.f 0.011046,0.357287,-0.211229,0.011046,0.357287,-0.211229
   Data.l -1
   Data.f 0.977336,7.530774
   Data.f 0.010323,0.372733,-0.187143,0.010323,0.372733,-0.187143
   Data.l -1
   Data.f 0.98234,7.545691
   Data.f 0.010041,0.378611,-0.177661,0.010041,0.378611,-0.177661
   Data.l -1
   Data.f 0.984226,7.551567
   Data.f 0.005224,0.368178,0.157915,0.005224,0.368178,0.157915
   Data.l -1
   Data.f 0.960883,7.762663
   Data.f 0.005848,0.379744,0.096616,0.005848,0.379744,0.096616
   Data.l -1
   Data.f 0.969128,7.723943
   Data.f 0.005246,0.33105,0.225783,0.005246,0.33105,0.225783
   Data.l -1
   Data.f 0.94173,7.805969
   Data.f 0.005967,0.271506,0.296191,0.005967,0.271506,0.296191
   Data.l -1
   Data.f 0.913202,7.851327
   Data.f 0.007441,0.192691,0.365112,0.007441,0.192691,0.365112
   Data.l -1
   Data.f 0.876828,7.8962
   Data.f 0.009708,0.097762,0.428511,0.009708,0.097762,0.428511
   Data.l -1
   Data.f 0.834138,7.938039
   Data.f 0.012772,-0.010141,0.482359,0.012772,-0.010141,0.482359
   Data.l -1
   Data.f 0.786663,7.974277
   Data.f 0.015953,-0.110677,0.524265,0.015953,-0.110677,0.524265
   Data.l -1
   Data.f 0.742909,8.002966
   Data.f 0.018526,-0.187284,0.55544,0.018526,-0.187284,0.55544
   Data.l -1
   Data.f 0.709619,8.02444
   Data.f 0.020463,-0.242482,0.577278,0.020463,-0.242482,0.577278
   Data.l -1
   Data.f 0.685672,8.039563
   Data.f 0.021784,-0.278794,0.591156,0.021784,-0.278794,0.591156
   Data.l -1
   Data.f 0.669949,8.049226
   Data.f 0.022517,-0.298734,0.598465,0.022517,-0.298734,0.598465
   Data.l -1
   Data.f 0.661333,8.054343
   Data.f 0.022745,-0.304818,0.600593,0.022745,-0.304818,0.600593
   Data.l -1
   Data.f 0.658709,8.05584
   Data.f 0.097645,-0.422563,0.417046,0.097645,-0.422563,0.417046
   Data.l -1
   Data.f 0.62458,7.984897
   Data.f 0.097676,-0.422693,0.418052,0.097676,-0.422693,0.418052
   Data.l -1
   Data.f 0.624472,7.985558
   Data.f 0.097559,-0.422197,0.414189,0.097559,-0.422197,0.414189
   Data.l -1
   Data.f 0.624888,7.983021
   Data.f 0.097429,-0.421617,0.409721,0.097429,-0.421617,0.409721
   Data.l -1
   Data.f 0.625368,7.980088
   Data.f 0.097248,-0.420869,0.403883,0.097248,-0.420869,0.403883
   Data.l -1
   Data.f 0.625995,7.976254
   Data.f 0.097042,-0.419969,0.39691,0.097042,-0.419969,0.39691
   Data.l -1
   Data.f 0.626744,7.971681
   Data.f 0.096805,-0.418958,0.389057,0.096805,-0.418958,0.389057
   Data.l -1
   Data.f 0.627588,7.966524
   Data.f 0.100239,-0.463998,0.388418,0.100239,-0.463998,0.388418
   Data.l -1
   Data.f 0.609186,7.96823
   Data.f 0.103339,-0.504251,0.387847,0.103339,-0.504251,0.387847
   Data.l -1
   Data.f 0.592743,7.969778
   Data.f 0.105981,-0.538194,0.387368,0.105981,-0.538194,0.387368
   Data.l -1
   Data.f 0.578878,7.971098
   Data.f 0.108033,-0.564317,0.386996,0.108033,-0.564317,0.386996
   Data.l -1
   Data.f 0.568209,7.972126
   Data.f 0.10246,-0.581102,0.38655,0.10246,-0.581102,0.38655
   Data.l -1
   Data.f 0.560967,7.968408
   Data.f 0.100462,-0.587034,0.386391,0.100462,-0.587034,0.386391
   Data.l -1
   Data.f 0.558406,7.967076
   Data.f 0.086702,-0.614232,0.141041,0.086702,-0.614232,0.141041
   Data.l -1
   Data.f 0.560063,7.802093
   Data.f 0.082588,-0.608567,-0.173176,0.082588,-0.608567,-0.173176
   Data.l -1
   Data.f 0.579724,7.599117
   Data.f 0.083678,-0.604112,-0.179864,0.083678,-0.604112,-0.179864
   Data.l -1
   Data.f 0.582004,7.595524
   Data.f 0.086788,-0.591287,-0.196564,0.086788,-0.591287,-0.196564
   Data.l -1
   Data.f 0.588424,7.586785
   Data.f 0.091627,-0.570905,-0.218256,0.091627,-0.570905,-0.218256
   Data.l -1
   Data.f 0.598349,7.575929
   Data.f 0.09154,-0.543782,-0.240101,0.09154,-0.543782,-0.240101
   Data.l -1
   Data.f 0.610786,7.56194
   Data.f 0.089165,-0.510728,-0.256969,0.089165,-0.510728,-0.256969
   Data.l -1
   Data.f 0.625267,7.549718
   Data.f 0.086768,-0.472562,-0.263765,0.086768,-0.472562,-0.263765
   Data.l -1
   Data.f 0.6413,7.543907
   Data.f 0.083653,-0.418294,-0.261784,0.083653,-0.418294,-0.261784
   Data.l -1
   Data.f 0.663463,7.543252
   Data.f 0.081555,-0.379613,-0.255269,0.081555,-0.379613,-0.255269
   Data.l -1
   Data.f 0.678983,7.546115
   Data.f 0.080016,-0.348863,-0.243702,0.080016,-0.348863,-0.243702
   Data.l -1
   Data.f 0.690969,7.552546
   Data.f 0.078585,-0.318402,-0.226554,0.078585,-0.318402,-0.226554
   Data.l -1
   Data.f 0.702531,7.562601
   Data.f 0.076811,-0.280584,-0.2033,0.076811,-0.280584,-0.2033
   Data.l -1
   Data.f 0.716778,7.576342
   Data.f 0.074266,-0.22775,-0.173431,0.074266,-0.22775,-0.173431
   Data.l -1
   Data.f 0.736821,7.593826
   Data.f 0.071957,-0.180257,-0.145309,0.071957,-0.180257,-0.145309
   Data.l -1
   Data.f 0.754768,7.610343
   Data.f 0.070015,-0.139558,-0.116407,0.070015,-0.139558,-0.116407
   Data.l -1
   Data.f 0.769879,7.627586
   Data.f 0.068458,-0.106481,-0.089348,0.068458,-0.106481,-0.089348
   Data.l -1
   Data.f 0.781963,7.643886
   Data.f 0.067303,-0.081838,-0.066766,0.067303,-0.081838,-0.066766
   Data.l -1
   Data.f 0.790831,7.657581
   Data.f 0.066592,-0.066453,-0.051287,0.066592,-0.066453,-0.051287
   Data.l -1
   Data.f 0.79629,7.667016
   Data.f 0.066345,-0.061143,-0.045543,0.066345,-0.061143,-0.045543
   Data.l -1
   Data.f 0.798153,7.670529
   Data.f 0.062094,0.020461,-0.000314,0.062094,0.020461,-0.000314
   Data.l -1
   Data.f 0.829143,7.696761
   Data.f 0.062276,0.016974,-0.002507,0.062276,0.016974,-0.002507
   Data.l -1
   Data.f 0.827833,7.695474
   Data.f 0.062734,0.007884,-0.009042,0.062734,0.007884,-0.009042
   Data.l -1
   Data.f 0.824464,7.69159
   Data.f 0.063358,-0.004728,-0.019859,0.063358,-0.004728,-0.019859
   Data.l -1
   Data.f 0.819886,7.685076
   Data.f 0.064022,-0.018796,-0.034885,0.064022,-0.018796,-0.034885
   Data.l -1
   Data.f 0.814944,7.675897
   Data.f 0.064605,-0.032247,-0.054065,0.064605,-0.032247,-0.054065
   Data.l -1
   Data.f 0.810484,7.66402
   Data.f 0.064983,-0.043008,-0.077334,0.064983,-0.043008,-0.077334
   Data.l -1
   Data.f 0.807353,7.64941
   Data.f 0.065329,-0.057626,-0.123216,0.065329,-0.057626,-0.123216
   Data.l -1
   Data.f 0.803888,7.620354
   Data.f 0.065453,-0.066144,-0.156128,0.065453,-0.066144,-0.156128
   Data.l -1
   Data.f 0.802209,7.599435
   Data.f 0.065487,-0.071939,-0.18234,0.065487,-0.071939,-0.18234
   Data.l -1
   Data.f 0.801279,7.582735
   Data.f 0.065546,-0.078374,-0.20813,0.065546,-0.078374,-0.20813
   Data.l -1
   Data.f 0.80006,7.566324
   Data.f 0.065757,-0.088826,-0.239776,0.065757,-0.088826,-0.239776
   Data.l -1
   Data.f 0.797515,7.546265
   Data.f 0.06619,-0.106668,-0.283552,0.06619,-0.106668,-0.283552
   Data.l -1
   Data.f 0.792604,7.518608
   Data.f 0.066566,-0.12013,-0.310584,0.066566,-0.12013,-0.310584
   Data.l -1
   Data.f 0.788566,7.501596
   Data.f 0.066959,-0.131532,-0.326979,0.066959,-0.131532,-0.326979
   Data.l -1
   Data.f 0.784786,7.491377
   Data.f 0.067357,-0.142003,-0.337877,0.067357,-0.142003,-0.337877
   Data.l -1
   Data.f 0.781087,7.484673
   Data.f 0.067772,-0.152658,-0.348428,0.067772,-0.152658,-0.348428
   Data.l -1
   Data.f 0.777291,7.478196
   Data.f 0.068178,-0.164621,-0.363765,0.068178,-0.164621,-0.363765
   Data.l -1
   Data.f 0.773223,7.468663
   Data.f 0.068568,-0.179017,-0.389049,0.068568,-0.179017,-0.389049
   Data.l -1
   Data.f 0.768703,7.452778
   Data.f 0.068624,-0.185823,-0.410056,0.068624,-0.185823,-0.410056
   Data.l -1
   Data.f 0.767063,7.439409
   Data.f 0.068398,-0.186982,-0.430866,0.068398,-0.186982,-0.430866
   Data.l -1
   Data.f 0.767732,7.425994
   Data.f 0.068009,-0.184461,-0.449859,0.068009,-0.184461,-0.449859
   Data.l -1
   Data.f 0.769814,7.413641
   Data.f 0.06759,-0.180227,-0.465419,0.06759,-0.180227,-0.465419
   Data.l -1
   Data.f 0.772411,7.403456
   Data.f 0.067256,-0.176248,-0.475943,0.067256,-0.176248,-0.475943
   Data.l -1
   Data.f 0.774627,7.396538
   Data.f 0.06712,-0.174482,-0.479805,0.06712,-0.174482,-0.479805
   Data.l -1
   Data.f 0.775565,7.393988
   Data.f 0.062767,-0.08381,-0.484475,0.062767,-0.08381,-0.484475
   Data.l -1
   Data.f 0.813089,7.388329
   Data.f 0.063566,-0.123479,-0.571764,0.063566,-0.123479,-0.571764
   Data.l -1
   Data.f 0.801599,7.333141
   Data.f 0.062959,-0.110738,-0.574698,0.062959,-0.110738,-0.574698
   Data.l -1
   Data.f 0.807,7.330894
   Data.f 0.061462,-0.078607,-0.580434,0.061462,-0.078607,-0.580434
   Data.l -1
   Data.f 0.820529,7.326314
   Data.f 0.059568,-0.036206,-0.584356,0.059568,-0.036206,-0.584356
   Data.l -1
   Data.f 0.83818,7.322643
   Data.f 0.057709,0.007323,-0.581853,0.057709,0.007323,-0.581853
   Data.l -1
   Data.f 0.855943,7.323097
   Data.f 0.056302,0.042857,-0.56831,0.056302,0.042857,-0.56831
   Data.l -1
   Data.f 0.869807,7.330866
   Data.f 0.055734,0.061263,-0.539121,0.055734,0.061263,-0.539121
   Data.l -1
   Data.f 0.875759,7.349139
   Data.f 0.055421,0.075095,-0.499525,0.055421,0.075095,-0.499525
   Data.l -1
   Data.f 0.879252,7.374202
   Data.f 0.054615,0.099379,-0.459694,0.054615,0.099379,-0.459694
   Data.l -1
   Data.f 0.887028,7.399115
   Data.f 0.053526,0.128699,-0.422387,0.053526,0.128699,-0.422387
   Data.l -1
   Data.f 0.897012,7.422242
   Data.f 0.052389,0.157641,-0.390381,0.052389,0.157641,-0.390381
   Data.l -1
   Data.f 0.907134,7.44196
   Data.f 0.051457,0.180793,-0.366431,0.051457,0.180793,-0.366431
   Data.l -1
   Data.f 0.91532,7.456662
   Data.f 0.050971,0.192733,-0.353303,0.050971,0.192733,-0.353303
   Data.l -1
   Data.f 0.9195,7.464737
   Data.f 0.050718,0.198737,-0.347492,0.050718,0.198737,-0.347492
   Data.l -1
   Data.f 0.921644,7.468288
   Data.f 0.050338,0.207511,-0.343075,0.050338,0.207511,-0.343075
   Data.l -1
   Data.f 0.925005,7.470871
   Data.f 0.049831,0.218802,-0.339161,0.049831,0.218802,-0.339161
   Data.l -1
   Data.f 0.92943,7.473057
   Data.f 0.049226,0.232364,-0.334874,0.049226,0.232364,-0.334874
   Data.l -1
   Data.f 0.934765,7.475419
   Data.f 0.048534,0.247935,-0.329334,0.048534,0.247935,-0.329334
   Data.l -1
   Data.f 0.940859,7.478528
   Data.f 0.047767,0.265273,-0.321648,0.047767,0.265273,-0.321648
   Data.l -1
   Data.f 0.947559,7.482958
   Data.f 0.046854,0.286261,-0.304628,0.046854,0.286261,-0.304628
   Data.l -1
   Data.f 0.955239,7.493254
   Data.f 0.045795,0.310775,-0.276018,0.045795,0.310775,-0.276018
   Data.l -1
   Data.f 0.963722,7.510848
   Data.f 0.044697,0.335543,-0.242369,0.044697,0.335543,-0.242369
   Data.l -1
   Data.f 0.972026,7.53164
   Data.f 0.04372,0.357287,-0.21023,0.04372,0.357287,-0.21023
   Data.l -1
   Data.f 0.979171,7.551538
   Data.f 0.043009,0.372733,-0.186143,0.043009,0.372733,-0.186143
   Data.l -1
   Data.f 0.984176,7.566464
   Data.f 0.04274,0.378611,-0.176667,0.04274,0.378611,-0.176667
   Data.l -1
   Data.f 0.986062,7.572345
   Data.f 0.041383,0.406947,-0.10527,0.041383,0.406947,-0.10527
   Data.l -1
   Data.f 0.993718,7.617053
   Data.f 0.042717,0.379744,0.097743,0.042717,0.379744,0.097743
   Data.l -1
   Data.f 0.971198,7.747375
   Data.f 0.005712,0.389022,0.089421,0.005712,0.389022,0.089421
   Data.l -1
   Data.f 0.973361,7.71927
   Data.f 0.042227,0.389022,0.090537,0.042227,0.389022,0.090537
   Data.l -1
   Data.f 0.975412,7.742477
   Data.f 0.043351,0.368178,0.159077,0.043351,0.368178,0.159077
   Data.l -1
   Data.f 0.963023,7.786893
   Data.f 0.04547,0.33105,0.227008,0.04547,0.33105,0.227008
   Data.l -1
   Data.f 0.943989,7.83153
   Data.f 0.049058,0.271506,0.297505,0.049058,0.271506,0.297505
   Data.l -1
   Data.f 0.915621,7.87871
   Data.f 0.054109,0.192691,0.366538,0.054109,0.192691,0.366538
   Data.l -1
   Data.f 0.879448,7.925855
   Data.f 0.060573,0.097762,0.430068,0.060573,0.097762,0.430068
   Data.l -1
   Data.f 0.836994,7.970364
   Data.f 0.068342,-0.010141,0.484057,0.068342,-0.010141,0.484057
   Data.l -1
   Data.f 0.789783,8.009592
   Data.f 0.075972,-0.110677,0.526097,0.075972,-0.110677,0.526097
   Data.l -1
   Data.f 0.746279,8.04111
   Data.f 0.082072,-0.187284,0.557383,0.082072,-0.187284,0.557383
   Data.l -1
   Data.f 0.713187,8.064824
   Data.f 0.086617,-0.242482,0.579298,0.086617,-0.242482,0.579298
   Data.l -1
   Data.f 0.689386,8.081602
   Data.f 0.089672,-0.278794,0.59323,0.089672,-0.278794,0.59323
   Data.l -1
   Data.f 0.673761,8.092371
   Data.f 0.09137,-0.298734,0.600568,0.09137,-0.298734,0.600568
   Data.l -1
   Data.f 0.665199,8.098097
   Data.f 0.091885,-0.304818,0.602706,0.091885,-0.304818,0.602706
   Data.l -1
   Data.f 0.662591,8.099779
   Data.f 0.166834,-0.422563,0.41916,0.166834,-0.422563,0.41916
   Data.l -1
   Data.f 0.628465,8.028864
   Data.f 0.166894,-0.422693,0.420167,0.166894,-0.422693,0.420167
   Data.l -1
   Data.f 0.628359,8.029544
   Data.f 0.166658,-0.422197,0.4163,0.166658,-0.422197,0.4163
   Data.l -1
   Data.f 0.628767,8.026934
   Data.f 0.166384,-0.421617,0.411832,0.166384,-0.421617,0.411832
   Data.l -1
   Data.f 0.629239,8.023914
   Data.f 0.166033,-0.42087,0.405985,0.166033,-0.42087,0.405985
   Data.l -1
   Data.f 0.629857,8.019968
   Data.f 0.165615,-0.419969,0.399011,0.165615,-0.419969,0.399011
   Data.l -1
   Data.f 0.630594,8.015261
   Data.f 0.165144,-0.418958,0.391141,0.165144,-0.418958,0.391141
   Data.l -1
   Data.f 0.631425,8.009952
   Data.f 0.170281,-0.463999,0.390555,0.170281,-0.463999,0.390555
   Data.l -1
   Data.f 0.613119,8.012743
   Data.f 0.174927,-0.504252,0.390029,0.174927,-0.504252,0.390029
   Data.l -1
   Data.f 0.596763,8.01527
   Data.f 0.17888,-0.538195,0.389592,0.17888,-0.538195,0.389592
   Data.l -1
   Data.f 0.582972,8.017425
   Data.f 0.181948,-0.564317,0.389253,0.181948,-0.564317,0.389253
   Data.l -1
   Data.f 0.572359,8.019098
   Data.f 0.173586,-0.581102,0.388721,0.173586,-0.581102,0.388721
   Data.l -1
   Data.f 0.564961,8.013608
   Data.f 0.170586,-0.587034,0.388533,0.170586,-0.587034,0.388533
   Data.l -1
   Data.f 0.562344,8.011641
   Data.f 0.146209,-0.614233,0.142857,0.146209,-0.614233,0.142857
   Data.l -1
   Data.f 0.563404,7.839908
   Data.f 0.135241,-0.608567,-0.171568,0.135241,-0.608567,-0.171568
   Data.l -1
   Data.f 0.582681,7.632579
   Data.f 0.136776,-0.604112,-0.178241,0.136776,-0.604112,-0.178241
   Data.l -1
   Data.f 0.584986,7.629267
   Data.f 0.141186,-0.591287,-0.194901,0.141186,-0.591287,-0.194901
   Data.l -1
   Data.f 0.591478,7.621355
   Data.f 0.14811,-0.570905,-0.216533,0.14811,-0.570905,-0.216533
   Data.l -1
   Data.f 0.60152,7.611824
   Data.f 0.147643,-0.543782,-0.238385,0.147643,-0.543782,-0.238385
   Data.l -1
   Data.f 0.613936,7.597594
   Data.f 0.143827,-0.510728,-0.255301,0.143827,-0.510728,-0.255301
   Data.l -1
   Data.f 0.628336,7.584456
   Data.f 0.140126,-0.472562,-0.26213,0.140126,-0.472562,-0.26213
   Data.l -1
   Data.f 0.644296,7.577818
   Data.f 0.135491,-0.418294,-0.260199,0.135491,-0.418294,-0.260199
   Data.l -1
   Data.f 0.666373,7.576194
   Data.f 0.132447,-0.379609,-0.253714,0.132447,-0.379609,-0.253714
   Data.l -1
   Data.f 0.68184,7.578455
   Data.f 0.130309,-0.348863,-0.242163,0.130309,-0.348863,-0.242163
   Data.l -1
   Data.f 0.693793,7.584508
   Data.f 0.128418,-0.318402,-0.225027,0.128418,-0.318402,-0.225027
   Data.l -1
   Data.f 0.705329,7.594275
   Data.f 0.126124,-0.280584,-0.201798,0.126124,-0.280584,-0.201798
   Data.l -1
   Data.f 0.719547,7.60768
   Data.f 0.122755,-0.22775,-0.171949,0.122755,-0.22775,-0.171949
   Data.l -1
   Data.f 0.739544,7.624645
   Data.f 0.119725,-0.180257,-0.143852,0.119725,-0.180257,-0.143852
   Data.l -1
   Data.f 0.75745,7.640703
   Data.f 0.117261,-0.139558,-0.114967,0.117261,-0.139558,-0.114967
   Data.l -1
   Data.f 0.772531,7.657609
   Data.f 0.115332,-0.106481,-0.087916,0.115332,-0.106481,-0.087916
   Data.l -1
   Data.f 0.784595,7.673675
   Data.f 0.113949,-0.081842,-0.065343,0.113949,-0.081842,-0.065343
   Data.l -1
   Data.f 0.793449,7.687224
   Data.f 0.113113,-0.066453,-0.049863,0.113113,-0.066453,-0.049863
   Data.l -1
   Data.f 0.798902,7.696581
   Data.f 0.112828,-0.061143,-0.044119,0.112828,-0.061143,-0.044119
   Data.l -1
   Data.f 0.800763,7.700072
   Data.f 0.107146,0.020461,0.001063,0.107146,0.020461,0.001063
   Data.l -1
   Data.f 0.831673,7.725394
   Data.f 0.107388,0.016974,-0.001128,0.107388,0.016974,-0.001128
   Data.l -1
   Data.f 0.830365,7.724143
   Data.f 0.107982,0.007884,-0.007661,0.107982,0.007884,-0.007661
   Data.l -1
   Data.f 0.827005,7.720342
   Data.f 0.108755,-0.004728,-0.018472,0.108755,-0.004728,-0.018472
   Data.l -1
   Data.f 0.822435,7.713922
   Data.f 0.109517,-0.018796,-0.033496,0.109517,-0.018796,-0.033496
   Data.l -1
   Data.f 0.817498,7.704808
   Data.f 0.110091,-0.032247,-0.052675,0.110091,-0.032247,-0.052675
   Data.l -1
   Data.f 0.813038,7.692929
   Data.f 0.110303,-0.043008,-0.075946,0.110303,-0.043008,-0.075946
   Data.l -1
   Data.f 0.809898,7.678213
   Data.f 0.110124,-0.057626,-0.121849,0.110124,-0.057626,-0.121849
   Data.l -1
   Data.f 0.806403,7.648822
   Data.f 0.109807,-0.066144,-0.154773,0.109807,-0.066144,-0.154773
   Data.l -1
   Data.f 0.804699,7.627623
   Data.f 0.109456,-0.071939,-0.180997,0.109456,-0.071939,-0.180997
   Data.l -1
   Data.f 0.803747,7.610679
   Data.f 0.10916,-0.078374,-0.206798,0.10916,-0.078374,-0.206798
   Data.l -1
   Data.f 0.802509,7.594039
   Data.f 0.10898,-0.088826,-0.238452,0.10898,-0.088826,-0.238452
   Data.l -1
   Data.f 0.799942,7.573737
   Data.f 0.108969,-0.106668,-0.282243,0.108969,-0.106668,-0.282243
   Data.l -1
   Data.f 0.795006,7.545794
   Data.f 0.109126,-0.12013,-0.309285,0.109126,-0.12013,-0.309285
   Data.l -1
   Data.f 0.790956,7.52864
   Data.f 0.109453,-0.131536,-0.325677,0.109453,-0.131536,-0.325677
   Data.l -1
   Data.f 0.787172,7.518385
   Data.f 0.109889,-0.142003,-0.336576,0.109889,-0.142003,-0.336576
   Data.l -1
   Data.f 0.783475,7.511702
   Data.f 0.110345,-0.152658,-0.347124,0.110345,-0.152658,-0.347124
   Data.l -1
   Data.f 0.779682,7.505255
   Data.f 0.110727,-0.164621,-0.362467,0.110727,-0.164621,-0.362467
   Data.l -1
   Data.f 0.775612,7.495703
   Data.f 0.11093,-0.179013,-0.387756,0.11093,-0.179013,-0.387756
   Data.l -1
   Data.f 0.771081,7.479697
   Data.f 0.110691,-0.185823,-0.408773,0.110691,-0.185823,-0.408773
   Data.l -1
   Data.f 0.769425,7.466142
   Data.f 0.110031,-0.186982,-0.429597,0.110031,-0.186982,-0.429597
   Data.l -1
   Data.f 0.77007,7.452453
   Data.f 0.109162,-0.184461,-0.4486,0.109162,-0.184461,-0.4486
   Data.l -1
   Data.f 0.772124,7.439793
   Data.f 0.108297,-0.180227,-0.464179,0.108297,-0.180227,-0.464179
   Data.l -1
   Data.f 0.774696,7.429323
   Data.f 0.107632,-0.176248,-0.474708,0.107632,-0.176248,-0.474708
   Data.l -1
   Data.f 0.776894,7.422196
   Data.f 0.107365,-0.174482,-0.478577,0.107365,-0.174482,-0.478577
   Data.l -1
   Data.f 0.777825,7.419566
   Data.f 0.100769,-0.08381,-0.483314,0.100769,-0.08381,-0.483314
   Data.l -1
   Data.f 0.815223,7.412478
   Data.f 0.100635,-0.123479,-0.570627,0.100635,-0.123479,-0.570627
   Data.l -1
   Data.f 0.80368,7.356699
   Data.f 0.09968,-0.110738,-0.573577,0.09968,-0.110738,-0.573577
   Data.l -1
   Data.f 0.809061,7.354231
   Data.f 0.097353,-0.078607,-0.579341,0.097353,-0.078607,-0.579341
   Data.l -1
   Data.f 0.822544,7.349122
   Data.f 0.094446,-0.036206,-0.583293,0.094446,-0.036206,-0.583293
   Data.l -1
   Data.f 0.840138,7.34481
   Data.f 0.091695,0.007323,-0.580812,0.091695,0.007323,-0.580812
   Data.l -1
   Data.f 0.857851,7.344697
   Data.f 0.089792,0.042857,-0.567288,0.089792,0.042857,-0.567288
   Data.l -1
   Data.f 0.871687,7.35215
   Data.f 0.089387,0.061263,-0.538089,0.089387,0.061263,-0.538089
   Data.l -1
   Data.f 0.877649,7.370526
   Data.f 0.089516,0.075095,-0.49848,0.089516,0.075095,-0.49848
   Data.l -1
   Data.f 0.881167,7.395874
   Data.f 0.088924,0.099379,-0.458646,0.088924,0.099379,-0.458646
   Data.l -1
   Data.f 0.888954,7.420918
   Data.f 0.087862,0.128699,-0.421341,0.087862,0.128699,-0.421341
   Data.l -1
   Data.f 0.89894,7.444062
   Data.f 0.086649,0.157641,-0.389334,0.086649,0.157641,-0.389334
   Data.l -1
   Data.f 0.909057,7.463732
   Data.f 0.085608,0.180793,-0.365388,0.085608,0.180793,-0.365388
   Data.l -1
   Data.f 0.917238,7.478367
   Data.f 0.085082,0.192733,-0.352262,0.085082,0.192733,-0.352262
   Data.l -1
   Data.f 0.921415,7.486414
   Data.f 0.084791,0.198737,-0.346451,0.084791,0.198737,-0.346451
   Data.l -1
   Data.f 0.923557,7.489943
   Data.f 0.084283,0.207511,-0.342037,0.084283,0.207511,-0.342037
   Data.l -1
   Data.f 0.926911,7.492446
   Data.f 0.083595,0.218802,-0.338133,0.083595,0.218802,-0.338133
   Data.l -1
   Data.f 0.931325,7.494511
   Data.f 0.082746,0.232364,-0.333851,0.082746,0.232364,-0.333851
   Data.l -1
   Data.f 0.936647,7.496722
   Data.f 0.081799,0.247935,-0.328317,0.081799,0.247935,-0.328317
   Data.l -1
   Data.f 0.942727,7.499666
   Data.f 0.080764,0.265273,-0.320642,0.080764,0.265273,-0.320642
   Data.l -1
   Data.f 0.949411,7.503926
   Data.f 0.079656,0.286261,-0.303626,0.079656,0.286261,-0.303626
   Data.l -1
   Data.f 0.95708,7.514098
   Data.f 0.078499,0.310775,-0.275018,0.078499,0.310775,-0.275018
   Data.l -1
   Data.f 0.965558,7.531632
   Data.f 0.077372,0.335543,-0.24137,0.077372,0.335543,-0.24137
   Data.l -1
   Data.f 0.973861,7.552403
   Data.f 0.076395,0.357287,-0.209232,0.076395,0.357287,-0.209232
   Data.l -1
   Data.f 0.981005,7.572303
   Data.f 0.0757,0.372733,-0.185147,0.0757,0.372733,-0.185147
   Data.l -1
   Data.f 0.986011,7.587237
   Data.f 0.075436,0.378611,-0.175665,0.075436,0.378611,-0.175665
   Data.l -1
   Data.f 0.987897,7.593124
   Data.f 0.074491,0.406947,-0.104258,0.074491,0.406947,-0.104258
   Data.l -1
   Data.f 0.995577,7.638093
   Data.f 0.074344,0.409236,-0.102908,0.074344,0.409236,-0.102908
   Data.l -1
   Data.f 0.996442,7.638863
   Data.f 0.041268,0.409236,-0.103917,0.041268,0.409236,-0.103917
   Data.l -1
   Data.f 0.994585,7.617846
   Data.f 0.073904,0.416056,-0.099283,0.073904,0.416056,-0.099283
   Data.l -1
   Data.f 0.999034,7.640905
   Data.f 0.040943,0.416056,-0.100292,0.040943,0.416056,-0.100292
   Data.l -1
   Data.f 0.997184,7.619956
   Data.f 0.073176,0.427306,-0.094016,0.073176,0.427306,-0.094016
   Data.l -1
   Data.f 1.003352,7.643815
   Data.f 0.040403,0.427306,-0.095017,0.040403,0.427306,-0.095017
   Data.l -1
   Data.f 1.001512,7.622987
   Data.f 0.072144,0.442893,-0.087728,0.072144,0.442893,-0.087728
   Data.l -1
   Data.f 1.00939,7.647191
   Data.f 0.039648,0.442893,-0.08872,0.039648,0.442893,-0.08872
   Data.l -1
   Data.f 1.007566,7.62654
   Data.f 0.070813,0.462726,-0.081053,0.070813,0.462726,-0.081053
   Data.l -1
   Data.f 1.017147,7.65063
   Data.f 0.038691,0.462726,-0.082033,0.038691,0.462726,-0.082033
   Data.l -1
   Data.f 1.015344,7.630217
   Data.f 0.069191,0.486716,-0.07462,0.069191,0.486716,-0.07462
   Data.l -1
   Data.f 1.026619,7.653733
   Data.f 0.037543,0.486716,-0.075584,0.037543,0.486716,-0.075584
   Data.l -1
   Data.f 1.024843,7.633623
   Data.f 0.066677,0.523818,-0.066041,0.066677,0.523818,-0.066041
   Data.l -1
   Data.f 1.041346,7.657658
   Data.f 0.035779,0.523818,-0.06698,0.035779,0.523818,-0.06698
   Data.l -1
   Data.f 1.039611,7.638025
   Data.f 0.064765,0.551982,-0.06016,0.064765,0.551982,-0.06016
   Data.l -1
   Data.f 1.05256,7.660233
   Data.f 0.034451,0.551982,-0.06109,0.034451,0.551982,-0.06109
   Data.l -1
   Data.f 1.050858,7.640965
   Data.f 0.06322,0.574752,-0.056734,0.06322,0.574752,-0.056734
   Data.l -1
   Data.f 1.061701,7.661466
   Data.f 0.033383,0.574752,-0.057645,0.033383,0.574752,-0.057645
   Data.l -1
   Data.f 1.060026,7.642503
   Data.f 0.061799,0.595679,-0.055504,0.061799,0.595679,-0.055504
   Data.l -1
   Data.f 1.070208,7.661372
   Data.f 0.032422,0.595679,-0.056403,0.032422,0.595679,-0.056403
   Data.l -1
   Data.f 1.068558,7.642704
   Data.f 0.060248,0.618312,-0.056208,0.060248,0.618312,-0.056208
   Data.l -1
   Data.f 1.079521,7.659969
   Data.f 0.031395,0.618312,-0.05709,0.031395,0.618312,-0.05709
   Data.l -1
   Data.f 1.077901,7.641633
   Data.f 0.058347,0.646189,-0.058586,0.058347,0.646189,-0.058586
   Data.l -1
   Data.f 1.09108,7.657279
   Data.f 0.030149,0.646189,-0.059453,0.030149,0.646189,-0.059453
   Data.l -1
   Data.f 1.089497,7.639361
   Data.f 0.056903,0.668235,-0.05444,0.056903,0.668235,-0.05444
   Data.l -1
   Data.f 1.099885,7.659036
   Data.f 0.058635,0.648688,0.006922,0.058635,0.648688,0.006922
   Data.l -1
   Data.f 1.08847,7.699248
   Data.f 0.029676,0.648688,0.00604,0.029676,0.648688,0.00604
   Data.l -1
   Data.f 1.086844,7.680845
   Data.f 0.029038,0.665721,-0.017739,0.029038,0.665721,-0.017739
   Data.l -1
   Data.f 1.095182,7.665282
   Data.f 0.057312,0.665721,-0.016873,0.057312,0.665721,-0.016873
   Data.l -1
   Data.f 1.09677,7.683251
   Data.f 0.060357,0.626155,0.027652,0.060357,0.626155,0.027652
   Data.l -1
   Data.f 1.078088,7.713533
   Data.f 0.030611,0.626155,0.026747,0.030611,0.626155,0.026747
   Data.l -1
   Data.f 1.076418,7.694631
   Data.f 0.062174,0.601889,0.040509,0.062174,0.601889,0.040509
   Data.l -1
   Data.f 1.067435,7.722854
   Data.f 0.031695,0.601889,0.039577,0.031695,0.601889,0.039577
   Data.l -1
   Data.f 1.065723,7.703484
   Data.f 0.066012,0.550513,0.054509,0.066012,0.550513,0.054509
   Data.l -1
   Data.f 1.045618,7.734146
   Data.f 0.034113,0.550513,0.053531,0.034113,0.550513,0.053531
   Data.l -1
   Data.f 1.043827,7.713873
   Data.f 0.069915,0.499518,0.066088,0.069915,0.499518,0.066088
   Data.l -1
   Data.f 1.024098,7.743937
   Data.f 0.036593,0.499518,0.065072,0.036593,0.499518,0.065072
   Data.l -1
   Data.f 1.022228,7.722764
   Data.f 0.07356,0.452929,0.075788,0.07356,0.452929,0.075788
   Data.l -1
   Data.f 1.00449,7.752371
   Data.f 0.038928,0.452929,0.074733,0.038928,0.452929,0.074733
   Data.l -1
   Data.f 1.002546,7.730364
   Data.f 0.076618,0.414756,0.084135,0.076618,0.414756,0.084135
   Data.l -1
   Data.f 0.988407,7.759579
   Data.f 0.040881,0.414756,0.083044,0.040881,0.414756,0.083044
   Data.l -1
   Data.f 0.9864,7.73687
   Data.f 0.078743,0.389022,0.091655,0.078743,0.389022,0.091655
   Data.l -1
   Data.f 0.977462,7.765685
   Data.f 0.079586,0.379744,0.09887,0.079586,0.379744,0.09887
   Data.l -1
   Data.f 0.973269,7.770808
   Data.f 0.081481,0.368178,0.160242,0.081481,0.368178,0.160242
   Data.l -1
   Data.f 0.965164,7.811121
   Data.f 0.085689,0.33105,0.228238,0.085689,0.33105,0.228238
   Data.l -1
   Data.f 0.946247,7.857089
   Data.f 0.092143,0.271506,0.298824,0.092143,0.271506,0.298824
   Data.l -1
   Data.f 0.91804,7.906093
   Data.f 0.100774,0.192691,0.367961,0.100774,0.192691,0.367961
   Data.l -1
   Data.f 0.882068,7.955511
   Data.f 0.111441,0.097762,0.431617,0.111441,0.097762,0.431617
   Data.l -1
   Data.f 0.83985,8.002688
   Data.f 0.123913,-0.010141,0.485757,0.123913,-0.010141,0.485757
   Data.l -1
   Data.f 0.792903,8.044906
   Data.f 0.135996,-0.110677,0.527935,0.135996,-0.110677,0.527935
   Data.l -1
   Data.f 0.749649,8.079254
   Data.f 0.145619,-0.187284,0.559325,0.145619,-0.187284,0.559325
   Data.l -1
   Data.f 0.716755,8.105208
   Data.f 0.152765,-0.242482,0.581321,0.152765,-0.242482,0.581321
   Data.l -1
   Data.f 0.6931,8.123642
   Data.f 0.15756,-0.278794,0.595303,0.15756,-0.278794,0.595303
   Data.l -1
   Data.f 0.677573,8.135515
   Data.f 0.160214,-0.298734,0.602672,0.160214,-0.298734,0.602672
   Data.l -1
   Data.f 0.669065,8.141851
   Data.f 0.161025,-0.304818,0.604819,0.161025,-0.304818,0.604819
   Data.l -1
   Data.f 0.666473,8.143721
   Data.f 0.056646,0.673487,-0.038933,0.056646,0.673487,-0.038933
   Data.l -1
   Data.f 1.101178,7.668771
   Data.f -0.058055,0.406947,-0.108305,-0.058055,0.406947,-0.108305
   Data.l -1
   Data.f 0.988135,7.553859
   Data.f -0.057259,0.402922,-0.118422,-0.057259,0.402922,-0.118422
   Data.l -1
   Data.f 0.987082,7.547898
   Data.f -0.058313,0.409236,-0.106963,-0.058313,0.409236,-0.106963
   Data.l -1
   Data.f 0.988993,7.55456
   Data.f -0.059048,0.416056,-0.103346,-0.059048,0.416056,-0.103346
   Data.l -1
   Data.f 0.991569,7.556411
   Data.f -0.060229,0.427306,-0.098093,-0.060229,0.427306,-0.098093
   Data.l -1
   Data.f 0.995862,7.559037
   Data.f -0.061811,0.442893,-0.09182,-0.061811,0.442893,-0.09182
   Data.l -1
   Data.f 1.001869,7.562061
   Data.f -0.063752,0.462726,-0.085162,-0.063752,0.462726,-0.085162
   Data.l -1
   Data.f 1.009592,7.565113
   Data.f -0.065997,0.486716,-0.078752,-0.065997,0.486716,-0.078752
   Data.l -1
   Data.f 1.019029,7.567821
   Data.f -0.069354,0.523818,-0.070194,-0.069354,0.523818,-0.070194
   Data.l -1
   Data.f 1.033709,7.571213
   Data.f -0.071821,0.551982,-0.064334,-0.071821,0.551982,-0.064334
   Data.l -1
   Data.f 1.044891,7.573429
   Data.f -0.073721,0.574752,-0.06092,-0.073721,0.574752,-0.06092
   Data.l -1
   Data.f 1.054012,7.574438
   Data.f -0.075338,0.595679,-0.059693,-0.075338,0.595679,-0.059693
   Data.l -1
   Data.f 1.062508,7.574223
   Data.f -0.076954,0.618312,-0.060396,-0.076954,0.618312,-0.060396
   Data.l -1
   Data.f 1.071817,7.572778
   Data.f -0.078811,0.646189,-0.062779,-0.078811,0.646189,-0.062779
   Data.l -1
   Data.f 1.083379,7.570114
   Data.f -0.080575,0.668235,-0.058636,-0.080575,0.668235,-0.058636
   Data.l -1
   Data.f 1.092166,7.57167
   Data.f -0.081788,0.673487,-0.04316,-0.081788,0.673487,-0.04316
   Data.l -1
   Data.f 1.093406,7.580798
   Data.f -0.082447,0.665721,-0.021147,-0.082447,0.665721,-0.021147
   Data.l -1
   Data.f 1.088923,7.594435
   Data.f -0.08252,0.648688,0.002609,-0.08252,0.648688,0.002609
   Data.l -1
   Data.f 1.080544,7.609541
   Data.f -0.081985,0.626155,0.023307,-0.081985,0.626155,0.023307
   Data.l -1
   Data.f 1.070097,7.623075
   Data.f -0.080832,0.601889,0.03614,-0.080832,0.601889,0.03614
   Data.l -1
   Data.f 1.059405,7.631971
   Data.f -0.077527,0.550513,0.050121,-0.077527,0.550513,0.050121
   Data.l -1
   Data.f 1.037559,7.642925
   Data.f -0.078505,0.565356,0.046078,-0.078505,0.565356,0.046078
   Data.l -1
   Data.f 1.043869,7.639745
   Data.f -0.078505,0.56536,0.046078,-0.078505,0.56536,0.046078
   Data.l -1
   Data.f 1.043871,7.639744
   Data.f -0.073906,0.499518,0.061696,-0.073906,0.499518,0.061696
   Data.l -1
   Data.f 1.016023,7.652538
   Data.f -0.067352,0.414756,0.079737,-0.067352,0.414756,0.079737
   Data.l -1
   Data.f 0.980323,7.668085
   Data.f -0.065338,0.389022,0.08725,-0.065338,0.389022,0.08725
   Data.l -1
   Data.f 0.969372,7.674121
   Data.f 0.009616,0.402922,-0.116379,0.009616,0.402922,-0.116379
   Data.l -1
   Data.f 0.990836,7.590395
   Data.f -0.06496,0.382628,0.092216,-0.06496,0.382628,0.092216
   Data.l -1
   Data.f 0.966471,7.67752
   Data.f 0.00526,0.389022,0.089408,0.00526,0.389022,0.089408
   Data.l -1
   Data.f 0.973336,7.718984
   Data.f 0.004585,0.382628,0.094344,0.004585,0.382628,0.094344
   Data.l -1
   Data.f 0.970376,7.72172
   Data.f 0.009795,0.406947,-0.106232,0.009795,0.406947,-0.106232
   Data.l -1
   Data.f 0.991944,7.596981
   Data.f 0.00997,0.409236,-0.104876,0.00997,0.409236,-0.104876
   Data.l -1
   Data.f 0.992827,7.597952
   Data.f 0.010483,0.416056,-0.101225,0.010483,0.416056,-0.101225
   Data.l -1
   Data.f 0.995473,7.600599
   Data.f 0.011335,0.427306,-0.095902,0.011335,0.427306,-0.095902
   Data.l -1
   Data.f 0.99988,7.604519
   Data.f 0.012534,0.442893,-0.089552,0.012534,0.442893,-0.089552
   Data.l -1
   Data.f 1.006043,7.609308
   Data.f 0.014054,0.462726,-0.082785,0.014054,0.462726,-0.082785
   Data.l -1
   Data.f 1.01396,7.61456
   Data.f 0.015897,0.486716,-0.076246,0.015897,0.486716,-0.076246
   Data.l -1
   Data.f 1.023627,7.619866
   Data.f 0.018711,0.523818,-0.067504,0.018711,0.523818,-0.067504
   Data.l -1
   Data.f 1.038653,7.627178
   Data.f 0.020807,0.551982,-0.061502,0.020807,0.551982,-0.061502
   Data.l -1
   Data.f 1.050092,7.632296
   Data.f 0.02249,0.574752,-0.05798,0.02249,0.574752,-0.05798
   Data.l -1
   Data.f 1.059414,7.635577
   Data.f 0.024022,0.595679,-0.05666,0.024022,0.595679,-0.05666
   Data.l -1
   Data.f 1.068087,7.637366
   Data.f 0.025663,0.618312,-0.057265,0.025663,0.618312,-0.057265
   Data.l -1
   Data.f 1.077579,7.637992
   Data.f 0.027651,0.646189,-0.059526,0.027651,0.646189,-0.059526
   Data.l -1
   Data.f 1.089357,7.637773
   Data.f 0.02915,0.668235,-0.055291,0.02915,0.668235,-0.055291
   Data.l -1
   Data.f 1.098327,7.641399
   Data.f 0.028751,0.665721,-0.017749,0.028751,0.665721,-0.017749
   Data.l -1
   Data.f 1.095166,7.665102
   Data.f 0.0274,0.648688,0.005969,0.0274,0.648688,0.005969
   Data.l -1
   Data.f 1.086716,7.679398
   Data.f 0.025617,0.626155,0.026593,0.025617,0.626155,0.026593
   Data.l -1
   Data.f 1.076138,7.691457
   Data.f 0.023709,0.601889,0.039333,0.023709,0.601889,0.039333
   Data.l -1
   Data.f 1.065275,7.698406
   Data.f 0.019588,0.550513,0.053088,0.019588,0.550513,0.053088
   Data.l -1
   Data.f 1.043012,7.704643
   Data.f 0.015302,0.499518,0.064421,0.015302,0.499518,0.064421
   Data.l -1
   Data.f 1.021032,7.709233
   Data.f 0.007714,0.414756,0.082029,0.007714,0.414756,0.082029
   Data.l -1
   Data.f 0.984538,7.715791
   Data.f 0.029146,0.668235,-0.055283,0.029146,0.668235,-0.055283
   Data.l -1
   Data.f 1.098327,7.6414
   Data.f 0.029418,0.673487,-0.039764,0.029418,0.673487,-0.039764
   Data.l -1
   Data.f 1.099649,7.651468
   Triangle: ; Vertice x,y,z verbinden/Create Triangle
   Data.w 1,0,2
   Data.w 2,0,3
   Data.w 5,4,6
   Data.w 3,0,7
   Data.w 4,8,6
   Data.w 8,9,6
   Data.w 11,10,12
   Data.w 10,13,12
   Data.w 9,14,6
   Data.w 13,15,12
   Data.w 7,0,16
   Data.w 16,0,17
   Data.w 17,0,18
   Data.w 18,0,19
   Data.w 14,20,6
   Data.w 19,0,21
   Data.w 15,22,12
   Data.w 12,22,23
   Data.w 23,22,24
   Data.w 24,22,25
   Data.w 25,22,26
   Data.w 26,22,27
   Data.w 27,22,28
   Data.w 30,29,0
   Data.w 29,31,0
   Data.w 31,32,0
   Data.w 32,33,0
   Data.w 33,34,0
   Data.w 34,35,0
   Data.w 35,36,0
   Data.w 36,37,0
   Data.w 37,38,0
   Data.w 0,38,21
   Data.w 38,39,21
   Data.w 39,40,21
   Data.w 21,40,41
   Data.w 40,42,41
   Data.w 42,43,41
   Data.w 41,43,44
   Data.w 44,43,45
   Data.w 43,46,45
   Data.w 45,46,47
   Data.w 46,48,47
   Data.w 47,48,49
   Data.w 48,50,49
   Data.w 50,51,49
   Data.w 49,51,52
   Data.w 51,53,52
   Data.w 53,54,52
   Data.w 54,55,52
   Data.w 55,56,52
   Data.w 56,57,52
   Data.w 57,58,52
   Data.w 58,59,52
   Data.w 52,59,60
   Data.w 60,59,61
   Data.w 61,59,62
   Data.w 62,59,63
   Data.w 63,59,64
   Data.w 64,59,65
   Data.w 65,59,66
   Data.w 66,59,67
   Data.w 67,59,68
   Data.w 68,59,69
   Data.w 69,59,70
   Data.w 72,71,73
   Data.w 73,71,74
   Data.w 71,75,74
   Data.w 74,75,76
   Data.w 76,75,77
   Data.w 75,78,77
   Data.w 77,78,79
   Data.w 78,80,79
   Data.w 79,80,81
   Data.w 80,82,81
   Data.w 82,83,81
   Data.w 81,83,84
   Data.w 83,85,84
   Data.w 84,85,86
   Data.w 85,87,86
   Data.w 87,88,86
   Data.w 86,88,89
   Data.w 88,90,89
   Data.w 89,90,91
   Data.w 90,92,91
   Data.w 92,93,91
   Data.w 93,70,91
   Data.w 70,59,91
   Data.w 91,59,94
   Data.w 94,59,95
   Data.w 95,59,96
   Data.w 96,59,97
   Data.w 97,59,98
   Data.w 98,59,99
   Data.w 99,59,100
   Data.w 59,101,100
   Data.w 100,101,102
   Data.w 102,101,22
   Data.w 22,101,28
   Data.w 101,103,28
   Data.w 103,104,28
   Data.w 104,105,28
   Data.w 105,106,28
   Data.w 106,107,28
   Data.w 107,108,28
   Data.w 108,109,28
   Data.w 28,109,20
   Data.w 20,109,6
   Data.w 6,109,110
   Data.w 109,111,110
   Data.w 111,112,110
   Data.w 112,113,110
   Data.w 113,114,110
   Data.w 114,115,110
   Data.w 110,115,116
   Data.w 116,115,117
   Data.w 117,115,118
   Data.w 118,115,119
   Data.w 115,120,119
   Data.w 23,121,12
   Data.w 121,122,12
   Data.w 24,123,23
   Data.w 123,121,23
   Data.w 25,124,24
   Data.w 124,123,24
   Data.w 26,125,25
   Data.w 125,124,25
   Data.w 27,126,26
   Data.w 126,125,26
   Data.w 28,127,27
   Data.w 127,126,27
   Data.w 20,128,28
   Data.w 128,127,28
   Data.w 14,129,20
   Data.w 129,128,20
   Data.w 9,130,14
   Data.w 130,129,14
   Data.w 8,131,9
   Data.w 131,130,9
   Data.w 4,132,8
   Data.w 132,131,8
   Data.w 5,133,4
   Data.w 133,132,4
   Data.w 6,134,5
   Data.w 134,133,5
   Data.w 110,135,6
   Data.w 135,134,6
   Data.w 116,136,110
   Data.w 136,135,110
   Data.w 117,137,116
   Data.w 137,136,116
   Data.w 118,138,117
   Data.w 138,137,117
   Data.w 119,139,118
   Data.w 139,138,118
   Data.w 120,140,119
   Data.w 140,139,119
   Data.w 115,141,120
   Data.w 141,140,120
   Data.w 114,142,115
   Data.w 142,141,115
   Data.w 113,143,114
   Data.w 143,142,114
   Data.w 112,144,113
   Data.w 144,143,113
   Data.w 111,145,112
   Data.w 145,144,112
   Data.w 109,146,111
   Data.w 146,145,111
   Data.w 108,147,109
   Data.w 147,146,109
   Data.w 107,148,108
   Data.w 148,147,108
   Data.w 106,149,107
   Data.w 149,148,107
   Data.w 105,150,106
   Data.w 150,149,106
   Data.w 104,151,105
   Data.w 151,150,105
   Data.w 103,152,104
   Data.w 152,151,104
   Data.w 101,153,103
   Data.w 153,152,103
   Data.w 59,154,101
   Data.w 154,153,101
   Data.w 58,155,59
   Data.w 155,154,59
   Data.w 57,156,58
   Data.w 156,155,58
   Data.w 56,157,57
   Data.w 157,156,57
   Data.w 55,158,56
   Data.w 158,157,56
   Data.w 54,159,55
   Data.w 159,158,55
   Data.w 53,160,54
   Data.w 160,159,54
   Data.w 51,161,53
   Data.w 161,160,53
   Data.w 50,162,51
   Data.w 162,161,51
   Data.w 48,163,50
   Data.w 163,162,50
   Data.w 46,164,48
   Data.w 164,163,48
   Data.w 43,165,46
   Data.w 165,164,46
   Data.w 42,166,43
   Data.w 166,165,43
   Data.w 40,167,42
   Data.w 167,166,42
   Data.w 39,168,40
   Data.w 168,167,40
   Data.w 38,169,39
   Data.w 169,168,39
   Data.w 37,170,38
   Data.w 170,169,38
   Data.w 36,171,37
   Data.w 171,170,37
   Data.w 35,172,36
   Data.w 172,171,36
   Data.w 34,173,35
   Data.w 173,172,35
   Data.w 33,174,34
   Data.w 174,173,34
   Data.w 32,175,33
   Data.w 175,174,33
   Data.w 31,176,32
   Data.w 176,175,32
   Data.w 29,177,31
   Data.w 177,176,31
   Data.w 30,178,29
   Data.w 178,177,29
   Data.w 0,179,30
   Data.w 179,178,30
   Data.w 1,180,0
   Data.w 180,179,0
   Data.w 2,181,1
   Data.w 181,180,1
   Data.w 3,182,2
   Data.w 182,181,2
   Data.w 7,183,3
   Data.w 183,182,3
   Data.w 16,184,7
   Data.w 184,183,7
   Data.w 17,185,16
   Data.w 185,184,16
   Data.w 18,186,17
   Data.w 186,185,17
   Data.w 19,187,18
   Data.w 187,186,18
   Data.w 21,188,19
   Data.w 188,187,19
   Data.w 41,189,21
   Data.w 189,188,21
   Data.w 44,190,41
   Data.w 190,189,41
   Data.w 45,191,44
   Data.w 191,190,44
   Data.w 47,192,45
   Data.w 192,191,45
   Data.w 49,193,47
   Data.w 193,192,47
   Data.w 52,194,49
   Data.w 194,193,49
   Data.w 60,195,52
   Data.w 195,194,52
   Data.w 61,196,60
   Data.w 196,195,60
   Data.w 62,197,61
   Data.w 197,196,61
   Data.w 63,198,62
   Data.w 198,197,62
   Data.w 64,199,63
   Data.w 199,198,63
   Data.w 65,200,64
   Data.w 200,199,64
   Data.w 66,201,65
   Data.w 201,200,65
   Data.w 67,202,66
   Data.w 202,201,66
   Data.w 68,203,67
   Data.w 203,202,67
   Data.w 69,204,68
   Data.w 204,203,68
   Data.w 70,205,69
   Data.w 205,204,69
   Data.w 93,206,70
   Data.w 206,205,70
   Data.w 92,207,93
   Data.w 207,206,93
   Data.w 90,208,92
   Data.w 208,207,92
   Data.w 88,209,90
   Data.w 209,208,90
   Data.w 87,210,88
   Data.w 210,209,88
   Data.w 85,211,87
   Data.w 211,210,87
   Data.w 83,212,85
   Data.w 212,211,85
   Data.w 82,213,83
   Data.w 213,212,83
   Data.w 80,214,82
   Data.w 214,213,82
   Data.w 78,215,80
   Data.w 215,214,80
   Data.w 75,216,78
   Data.w 216,215,78
   Data.w 71,217,75
   Data.w 217,216,75
   Data.w 72,218,71
   Data.w 218,217,71
   Data.w 73,219,72
   Data.w 219,218,72
   Data.w 74,220,73
   Data.w 220,219,73
   Data.w 76,221,74
   Data.w 221,220,74
   Data.w 77,222,76
   Data.w 222,221,76
   Data.w 79,223,77
   Data.w 223,222,77
   Data.w 81,224,79
   Data.w 224,223,79
   Data.w 84,225,81
   Data.w 225,224,81
   Data.w 86,226,84
   Data.w 226,225,84
   Data.w 89,227,86
   Data.w 227,226,86
   Data.w 91,228,89
   Data.w 228,227,89
   Data.w 94,229,91
   Data.w 229,228,91
   Data.w 95,230,94
   Data.w 230,229,94
   Data.w 96,231,95
   Data.w 231,230,95
   Data.w 97,232,96
   Data.w 232,231,96
   Data.w 98,233,97
   Data.w 233,232,97
   Data.w 99,234,98
   Data.w 234,233,98
   Data.w 100,235,99
   Data.w 235,234,99
   Data.w 102,236,100
   Data.w 236,235,100
   Data.w 22,237,102
   Data.w 237,236,102
   Data.w 15,238,22
   Data.w 238,237,22
   Data.w 13,239,15
   Data.w 239,238,15
   Data.w 10,240,13
   Data.w 240,239,13
   Data.w 11,241,10
   Data.w 241,240,10
   Data.w 12,122,11
   Data.w 122,241,11
   Data.w 121,242,122
   Data.w 242,243,122
   Data.w 123,244,121
   Data.w 244,242,121
   Data.w 124,245,123
   Data.w 245,244,123
   Data.w 125,246,124
   Data.w 246,245,124
   Data.w 126,247,125
   Data.w 247,246,125
   Data.w 127,248,126
   Data.w 248,247,126
   Data.w 128,249,127
   Data.w 249,248,127
   Data.w 129,250,128
   Data.w 250,249,128
   Data.w 130,251,129
   Data.w 251,250,129
   Data.w 131,252,130
   Data.w 252,251,130
   Data.w 132,253,131
   Data.w 253,252,131
   Data.w 133,254,132
   Data.w 254,253,132
   Data.w 134,255,133
   Data.w 255,254,133
   Data.w 135,256,134
   Data.w 256,255,134
   Data.w 136,257,135
   Data.w 257,256,135
   Data.w 137,258,136
   Data.w 258,257,136
   Data.w 138,259,137
   Data.w 259,258,137
   Data.w 139,260,138
   Data.w 260,259,138
   Data.w 140,261,139
   Data.w 261,260,139
   Data.w 141,262,140
   Data.w 262,261,140
   Data.w 142,263,141
   Data.w 263,262,141
   Data.w 143,264,142
   Data.w 264,263,142
   Data.w 144,265,143
   Data.w 265,264,143
   Data.w 145,266,144
   Data.w 266,265,144
   Data.w 146,267,145
   Data.w 267,266,145
   Data.w 147,268,146
   Data.w 268,267,146
   Data.w 148,269,147
   Data.w 269,268,147
   Data.w 149,270,148
   Data.w 270,269,148
   Data.w 150,271,149
   Data.w 271,270,149
   Data.w 151,272,150
   Data.w 272,271,150
   Data.w 152,273,151
   Data.w 273,272,151
   Data.w 153,274,152
   Data.w 274,273,152
   Data.w 154,275,153
   Data.w 275,274,153
   Data.w 155,276,154
   Data.w 276,275,154
   Data.w 156,277,155
   Data.w 277,276,155
   Data.w 157,278,156
   Data.w 278,277,156
   Data.w 158,279,157
   Data.w 279,278,157
   Data.w 159,280,158
   Data.w 280,279,158
   Data.w 160,281,159
   Data.w 281,280,159
   Data.w 161,282,160
   Data.w 282,281,160
   Data.w 162,283,161
   Data.w 283,282,161
   Data.w 163,284,162
   Data.w 284,283,162
   Data.w 164,285,163
   Data.w 285,284,163
   Data.w 165,286,164
   Data.w 286,285,164
   Data.w 166,287,165
   Data.w 287,286,165
   Data.w 167,288,166
   Data.w 288,287,166
   Data.w 168,289,167
   Data.w 289,288,167
   Data.w 169,290,168
   Data.w 290,289,168
   Data.w 170,291,169
   Data.w 291,290,169
   Data.w 171,292,170
   Data.w 292,291,170
   Data.w 172,293,171
   Data.w 293,292,171
   Data.w 173,294,172
   Data.w 294,293,172
   Data.w 174,295,173
   Data.w 295,294,173
   Data.w 175,296,174
   Data.w 296,295,174
   Data.w 176,297,175
   Data.w 297,296,175
   Data.w 177,298,176
   Data.w 298,297,176
   Data.w 178,299,177
   Data.w 299,298,177
   Data.w 179,300,178
   Data.w 300,299,178
   Data.w 180,301,179
   Data.w 301,300,179
   Data.w 181,302,180
   Data.w 302,301,180
   Data.w 182,303,181
   Data.w 303,302,181
   Data.w 183,304,182
   Data.w 304,303,182
   Data.w 184,305,183
   Data.w 305,304,183
   Data.w 185,306,184
   Data.w 306,305,184
   Data.w 186,307,185
   Data.w 307,306,185
   Data.w 187,308,186
   Data.w 308,307,186
   Data.w 188,309,187
   Data.w 309,308,187
   Data.w 189,310,188
   Data.w 310,309,188
   Data.w 190,311,189
   Data.w 311,310,189
   Data.w 191,312,190
   Data.w 312,311,190
   Data.w 192,313,191
   Data.w 313,312,191
   Data.w 193,314,192
   Data.w 314,313,192
   Data.w 194,315,193
   Data.w 315,314,193
   Data.w 195,316,194
   Data.w 316,315,194
   Data.w 196,317,195
   Data.w 317,316,195
   Data.w 197,318,196
   Data.w 318,317,196
   Data.w 198,319,197
   Data.w 319,318,197
   Data.w 199,320,198
   Data.w 320,319,198
   Data.w 200,321,199
   Data.w 321,320,199
   Data.w 201,322,200
   Data.w 322,321,200
   Data.w 202,323,201
   Data.w 323,322,201
   Data.w 203,324,202
   Data.w 324,323,202
   Data.w 204,325,203
   Data.w 325,324,203
   Data.w 228,326,227
   Data.w 229,327,228
   Data.w 327,326,228
   Data.w 230,328,229
   Data.w 328,327,229
   Data.w 231,329,230
   Data.w 329,328,230
   Data.w 232,330,231
   Data.w 330,329,231
   Data.w 233,331,232
   Data.w 331,330,232
   Data.w 234,332,233
   Data.w 332,331,233
   Data.w 235,333,234
   Data.w 333,332,234
   Data.w 236,334,235
   Data.w 334,333,235
   Data.w 237,335,236
   Data.w 335,334,236
   Data.w 238,336,237
   Data.w 336,335,237
   Data.w 239,337,238
   Data.w 337,336,238
   Data.w 240,338,239
   Data.w 338,337,239
   Data.w 241,339,240
   Data.w 339,338,240
   Data.w 122,243,241
   Data.w 243,339,241
   Data.w 242,340,243
   Data.w 340,341,243
   Data.w 244,342,242
   Data.w 342,340,242
   Data.w 245,343,244
   Data.w 343,342,244
   Data.w 246,344,245
   Data.w 344,343,245
   Data.w 247,345,246
   Data.w 345,344,246
   Data.w 248,346,247
   Data.w 346,345,247
   Data.w 249,347,248
   Data.w 347,346,248
   Data.w 250,348,249
   Data.w 348,347,249
   Data.w 251,349,250
   Data.w 349,348,250
   Data.w 252,350,251
   Data.w 350,349,251
   Data.w 253,351,252
   Data.w 351,350,252
   Data.w 254,352,253
   Data.w 352,351,253
   Data.w 255,353,254
   Data.w 353,352,254
   Data.w 256,354,255
   Data.w 354,353,255
   Data.w 257,355,256
   Data.w 355,354,256
   Data.w 258,356,257
   Data.w 356,355,257
   Data.w 259,357,258
   Data.w 357,356,258
   Data.w 260,358,259
   Data.w 358,357,259
   Data.w 261,359,260
   Data.w 359,358,260
   Data.w 262,360,261
   Data.w 360,359,261
   Data.w 263,361,262
   Data.w 361,360,262
   Data.w 264,362,263
   Data.w 362,361,263
   Data.w 265,363,264
   Data.w 363,362,264
   Data.w 266,364,265
   Data.w 364,363,265
   Data.w 267,365,266
   Data.w 365,364,266
   Data.w 268,366,267
   Data.w 366,365,267
   Data.w 269,367,268
   Data.w 367,366,268
   Data.w 270,368,269
   Data.w 368,367,269
   Data.w 271,369,270
   Data.w 369,368,270
   Data.w 272,370,271
   Data.w 370,369,271
   Data.w 273,371,272
   Data.w 371,370,272
   Data.w 274,372,273
   Data.w 372,371,273
   Data.w 275,373,274
   Data.w 373,372,274
   Data.w 276,374,275
   Data.w 374,373,275
   Data.w 277,375,276
   Data.w 375,374,276
   Data.w 278,376,277
   Data.w 376,375,277
   Data.w 279,377,278
   Data.w 377,376,278
   Data.w 280,378,279
   Data.w 378,377,279
   Data.w 281,379,280
   Data.w 379,378,280
   Data.w 282,380,281
   Data.w 380,379,281
   Data.w 283,381,282
   Data.w 381,380,282
   Data.w 284,382,283
   Data.w 382,381,283
   Data.w 285,383,284
   Data.w 383,382,284
   Data.w 286,384,285
   Data.w 384,383,285
   Data.w 287,385,286
   Data.w 385,384,286
   Data.w 288,386,287
   Data.w 386,385,287
   Data.w 289,387,288
   Data.w 387,386,288
   Data.w 290,388,289
   Data.w 388,387,289
   Data.w 291,389,290
   Data.w 389,388,290
   Data.w 292,390,291
   Data.w 390,389,291
   Data.w 293,391,292
   Data.w 391,390,292
   Data.w 294,392,293
   Data.w 392,391,293
   Data.w 295,393,294
   Data.w 393,392,294
   Data.w 296,394,295
   Data.w 394,393,295
   Data.w 297,395,296
   Data.w 395,394,296
   Data.w 298,396,297
   Data.w 396,395,297
   Data.w 299,397,298
   Data.w 397,396,298
   Data.w 300,398,299
   Data.w 398,397,299
   Data.w 301,399,300
   Data.w 399,398,300
   Data.w 302,400,301
   Data.w 400,399,301
   Data.w 303,401,302
   Data.w 401,400,302
   Data.w 304,402,303
   Data.w 402,401,303
   Data.w 305,403,304
   Data.w 403,402,304
   Data.w 306,404,305
   Data.w 404,403,305
   Data.w 307,405,306
   Data.w 405,404,306
   Data.w 308,406,307
   Data.w 406,405,307
   Data.w 309,407,308
   Data.w 407,406,308
   Data.w 310,408,309
   Data.w 408,407,309
   Data.w 311,409,310
   Data.w 409,408,310
   Data.w 312,410,311
   Data.w 410,409,311
   Data.w 313,411,312
   Data.w 411,410,312
   Data.w 314,412,313
   Data.w 412,411,313
   Data.w 315,413,314
   Data.w 413,412,314
   Data.w 316,414,315
   Data.w 414,413,315
   Data.w 317,415,316
   Data.w 415,414,316
   Data.w 318,416,317
   Data.w 416,415,317
   Data.w 319,417,318
   Data.w 417,416,318
   Data.w 320,418,319
   Data.w 418,417,319
   Data.w 321,419,320
   Data.w 419,418,320
   Data.w 322,420,321
   Data.w 420,419,321
   Data.w 323,421,322
   Data.w 421,420,322
   Data.w 324,422,323
   Data.w 422,421,323
   Data.w 325,423,324
   Data.w 423,422,324
   Data.w 328,424,327
   Data.w 424,425,327
   Data.w 329,426,328
   Data.w 426,424,328
   Data.w 330,427,329
   Data.w 427,426,329
   Data.w 331,428,330
   Data.w 428,427,330
   Data.w 332,429,331
   Data.w 429,428,331
   Data.w 333,430,332
   Data.w 430,429,332
   Data.w 334,431,333
   Data.w 431,430,333
   Data.w 335,432,334
   Data.w 432,431,334
   Data.w 336,433,335
   Data.w 433,432,335
   Data.w 337,434,336
   Data.w 434,433,336
   Data.w 338,435,337
   Data.w 435,434,337
   Data.w 339,436,338
   Data.w 436,435,338
   Data.w 243,341,339
   Data.w 341,436,339
   Data.w 340,437,341
   Data.w 437,438,341
   Data.w 342,439,340
   Data.w 439,437,340
   Data.w 343,440,342
   Data.w 440,439,342
   Data.w 344,441,343
   Data.w 441,440,343
   Data.w 345,442,344
   Data.w 442,441,344
   Data.w 346,443,345
   Data.w 443,442,345
   Data.w 347,444,346
   Data.w 444,443,346
   Data.w 348,445,347
   Data.w 445,444,347
   Data.w 349,446,348
   Data.w 446,445,348
   Data.w 350,447,349
   Data.w 447,446,349
   Data.w 351,448,350
   Data.w 448,447,350
   Data.w 352,449,351
   Data.w 449,448,351
   Data.w 353,450,352
   Data.w 450,449,352
   Data.w 354,451,353
   Data.w 451,450,353
   Data.w 355,452,354
   Data.w 452,451,354
   Data.w 356,453,355
   Data.w 453,452,355
   Data.w 357,454,356
   Data.w 454,453,356
   Data.w 358,455,357
   Data.w 455,454,357
   Data.w 359,456,358
   Data.w 456,455,358
   Data.w 360,457,359
   Data.w 457,456,359
   Data.w 361,458,360
   Data.w 458,457,360
   Data.w 362,459,361
   Data.w 459,458,361
   Data.w 363,460,362
   Data.w 460,459,362
   Data.w 364,461,363
   Data.w 461,460,363
   Data.w 365,462,364
   Data.w 462,461,364
   Data.w 366,463,365
   Data.w 463,462,365
   Data.w 367,464,366
   Data.w 464,463,366
   Data.w 368,465,367
   Data.w 465,464,367
   Data.w 369,466,368
   Data.w 466,465,368
   Data.w 370,467,369
   Data.w 467,466,369
   Data.w 371,468,370
   Data.w 468,467,370
   Data.w 372,469,371
   Data.w 469,468,371
   Data.w 373,470,372
   Data.w 470,469,372
   Data.w 374,471,373
   Data.w 471,470,373
   Data.w 375,472,374
   Data.w 472,471,374
   Data.w 376,473,375
   Data.w 473,472,375
   Data.w 377,474,376
   Data.w 474,473,376
   Data.w 378,475,377
   Data.w 475,474,377
   Data.w 379,476,378
   Data.w 476,475,378
   Data.w 380,477,379
   Data.w 477,476,379
   Data.w 381,478,380
   Data.w 478,477,380
   Data.w 382,479,381
   Data.w 479,478,381
   Data.w 383,480,382
   Data.w 480,479,382
   Data.w 384,481,383
   Data.w 481,480,383
   Data.w 385,482,384
   Data.w 482,481,384
   Data.w 386,483,385
   Data.w 483,482,385
   Data.w 387,484,386
   Data.w 484,483,386
   Data.w 388,485,387
   Data.w 485,484,387
   Data.w 389,486,388
   Data.w 486,485,388
   Data.w 390,487,389
   Data.w 487,486,389
   Data.w 391,488,390
   Data.w 488,487,390
   Data.w 392,489,391
   Data.w 489,488,391
   Data.w 393,490,392
   Data.w 490,489,392
   Data.w 394,491,393
   Data.w 491,490,393
   Data.w 395,492,394
   Data.w 492,491,394
   Data.w 396,493,395
   Data.w 493,492,395
   Data.w 397,494,396
   Data.w 494,493,396
   Data.w 398,495,397
   Data.w 495,494,397
   Data.w 399,496,398
   Data.w 496,495,398
   Data.w 400,497,399
   Data.w 497,496,399
   Data.w 401,498,400
   Data.w 498,497,400
   Data.w 402,499,401
   Data.w 499,498,401
   Data.w 403,500,402
   Data.w 500,499,402
   Data.w 404,501,403
   Data.w 501,500,403
   Data.w 405,502,404
   Data.w 502,501,404
   Data.w 406,503,405
   Data.w 503,502,405
   Data.w 407,504,406
   Data.w 504,503,406
   Data.w 408,505,407
   Data.w 505,504,407
   Data.w 409,506,408
   Data.w 506,505,408
   Data.w 410,507,409
   Data.w 507,506,409
   Data.w 411,508,410
   Data.w 508,507,410
   Data.w 412,509,411
   Data.w 509,508,411
   Data.w 413,510,412
   Data.w 510,509,412
   Data.w 414,511,413
   Data.w 511,510,413
   Data.w 415,512,414
   Data.w 512,511,414
   Data.w 416,513,415
   Data.w 513,512,415
   Data.w 417,514,416
   Data.w 514,513,416
   Data.w 418,515,417
   Data.w 515,514,417
   Data.w 419,516,418
   Data.w 516,515,418
   Data.w 420,517,419
   Data.w 517,516,419
   Data.w 421,518,420
   Data.w 518,517,420
   Data.w 422,519,421
   Data.w 519,518,421
   Data.w 423,520,422
   Data.w 520,519,422
   Data.w 424,521,425
   Data.w 521,522,425
   Data.w 426,523,424
   Data.w 523,521,424
   Data.w 427,524,426
   Data.w 524,523,426
   Data.w 428,525,427
   Data.w 525,524,427
   Data.w 429,526,428
   Data.w 526,525,428
   Data.w 430,527,429
   Data.w 527,526,429
   Data.w 431,528,430
   Data.w 528,527,430
   Data.w 432,529,431
   Data.w 529,528,431
   Data.w 433,530,432
   Data.w 530,529,432
   Data.w 434,531,433
   Data.w 531,530,433
   Data.w 435,532,434
   Data.w 532,531,434
   Data.w 436,533,435
   Data.w 533,532,435
   Data.w 341,438,436
   Data.w 438,533,436
   Data.w 437,534,438
   Data.w 534,535,438
   Data.w 439,536,437
   Data.w 536,534,437
   Data.w 440,537,439
   Data.w 537,536,439
   Data.w 441,538,440
   Data.w 538,537,440
   Data.w 442,539,441
   Data.w 539,538,441
   Data.w 443,540,442
   Data.w 540,539,442
   Data.w 444,541,443
   Data.w 541,540,443
   Data.w 445,542,444
   Data.w 542,541,444
   Data.w 446,543,445
   Data.w 543,542,445
   Data.w 447,544,446
   Data.w 544,543,446
   Data.w 448,545,447
   Data.w 545,544,447
   Data.w 449,546,448
   Data.w 546,545,448
   Data.w 450,547,449
   Data.w 547,546,449
   Data.w 451,548,450
   Data.w 548,547,450
   Data.w 452,549,451
   Data.w 549,548,451
   Data.w 453,550,452
   Data.w 550,549,452
   Data.w 454,551,453
   Data.w 551,550,453
   Data.w 455,552,454
   Data.w 552,551,454
   Data.w 456,553,455
   Data.w 553,552,455
   Data.w 457,554,456
   Data.w 554,553,456
   Data.w 458,555,457
   Data.w 555,554,457
   Data.w 459,556,458
   Data.w 556,555,458
   Data.w 460,557,459
   Data.w 557,556,459
   Data.w 461,558,460
   Data.w 558,557,460
   Data.w 462,559,461
   Data.w 559,558,461
   Data.w 463,560,462
   Data.w 560,559,462
   Data.w 464,561,463
   Data.w 561,560,463
   Data.w 465,562,464
   Data.w 562,561,464
   Data.w 466,563,465
   Data.w 563,562,465
   Data.w 467,564,466
   Data.w 564,563,466
   Data.w 468,565,467
   Data.w 565,564,467
   Data.w 469,566,468
   Data.w 566,565,468
   Data.w 470,567,469
   Data.w 567,566,469
   Data.w 471,568,470
   Data.w 568,567,470
   Data.w 472,569,471
   Data.w 569,568,471
   Data.w 473,570,472
   Data.w 570,569,472
   Data.w 474,571,473
   Data.w 571,570,473
   Data.w 475,572,474
   Data.w 572,571,474
   Data.w 476,573,475
   Data.w 573,572,475
   Data.w 477,574,476
   Data.w 574,573,476
   Data.w 478,575,477
   Data.w 575,574,477
   Data.w 479,576,478
   Data.w 576,575,478
   Data.w 480,577,479
   Data.w 577,576,479
   Data.w 481,578,480
   Data.w 578,577,480
   Data.w 482,579,481
   Data.w 579,578,481
   Data.w 483,580,482
   Data.w 580,579,482
   Data.w 484,581,483
   Data.w 581,580,483
   Data.w 485,582,484
   Data.w 582,581,484
   Data.w 486,583,485
   Data.w 583,582,485
   Data.w 487,584,486
   Data.w 584,583,486
   Data.w 488,585,487
   Data.w 585,584,487
   Data.w 489,586,488
   Data.w 586,585,488
   Data.w 490,587,489
   Data.w 587,586,489
   Data.w 491,588,490
   Data.w 588,587,490
   Data.w 492,589,491
   Data.w 589,588,491
   Data.w 493,590,492
   Data.w 590,589,492
   Data.w 494,591,493
   Data.w 591,590,493
   Data.w 495,592,494
   Data.w 592,591,494
   Data.w 496,593,495
   Data.w 593,592,495
   Data.w 497,594,496
   Data.w 594,593,496
   Data.w 498,595,497
   Data.w 595,594,497
   Data.w 499,596,498
   Data.w 596,595,498
   Data.w 500,597,499
   Data.w 597,596,499
   Data.w 501,598,500
   Data.w 598,597,500
   Data.w 502,599,501
   Data.w 599,598,501
   Data.w 503,600,502
   Data.w 600,599,502
   Data.w 504,601,503
   Data.w 601,600,503
   Data.w 505,602,504
   Data.w 602,601,504
   Data.w 506,603,505
   Data.w 603,602,505
   Data.w 507,604,506
   Data.w 604,603,506
   Data.w 508,605,507
   Data.w 605,604,507
   Data.w 509,606,508
   Data.w 606,605,508
   Data.w 510,607,509
   Data.w 607,606,509
   Data.w 511,608,510
   Data.w 608,607,510
   Data.w 512,609,511
   Data.w 609,608,511
   Data.w 513,610,512
   Data.w 610,609,512
   Data.w 514,611,513
   Data.w 611,610,513
   Data.w 515,612,514
   Data.w 612,611,514
   Data.w 516,613,515
   Data.w 613,612,515
   Data.w 517,614,516
   Data.w 614,613,516
   Data.w 518,615,517
   Data.w 615,614,517
   Data.w 519,616,518
   Data.w 616,615,518
   Data.w 520,617,519
   Data.w 617,616,519
   Data.w 618,617,520
   Data.w 522,619,620
   Data.w 619,621,620
   Data.w 521,622,522
   Data.w 622,619,522
   Data.w 523,623,521
   Data.w 623,622,521
   Data.w 524,624,523
   Data.w 624,623,523
   Data.w 525,625,524
   Data.w 625,624,524
   Data.w 526,626,525
   Data.w 626,625,525
   Data.w 527,627,526
   Data.w 627,626,526
   Data.w 528,628,527
   Data.w 628,627,527
   Data.w 529,629,528
   Data.w 629,628,528
   Data.w 530,630,529
   Data.w 630,629,529
   Data.w 531,631,530
   Data.w 631,630,530
   Data.w 532,632,531
   Data.w 632,631,531
   Data.w 533,633,532
   Data.w 633,632,532
   Data.w 438,535,533
   Data.w 535,633,533
   Data.w 534,634,535
   Data.w 634,635,535
   Data.w 536,636,534
   Data.w 636,634,534
   Data.w 537,637,536
   Data.w 637,636,536
   Data.w 538,638,537
   Data.w 638,637,537
   Data.w 539,639,538
   Data.w 639,638,538
   Data.w 540,640,539
   Data.w 640,639,539
   Data.w 541,641,540
   Data.w 641,640,540
   Data.w 542,642,541
   Data.w 642,641,541
   Data.w 543,643,542
   Data.w 643,642,542
   Data.w 544,644,543
   Data.w 644,643,543
   Data.w 545,645,544
   Data.w 645,644,544
   Data.w 546,646,545
   Data.w 646,645,545
   Data.w 547,647,546
   Data.w 647,646,546
   Data.w 548,648,547
   Data.w 648,647,547
   Data.w 549,649,548
   Data.w 649,648,548
   Data.w 550,650,549
   Data.w 650,649,549
   Data.w 551,651,550
   Data.w 651,650,550
   Data.w 552,652,551
   Data.w 652,651,551
   Data.w 553,653,552
   Data.w 653,652,552
   Data.w 554,654,553
   Data.w 654,653,553
   Data.w 555,655,554
   Data.w 655,654,554
   Data.w 556,656,555
   Data.w 656,655,555
   Data.w 557,657,556
   Data.w 657,656,556
   Data.w 558,658,557
   Data.w 658,657,557
   Data.w 559,659,558
   Data.w 659,658,558
   Data.w 560,660,559
   Data.w 660,659,559
   Data.w 561,661,560
   Data.w 661,660,560
   Data.w 562,662,561
   Data.w 662,661,561
   Data.w 563,663,562
   Data.w 663,662,562
   Data.w 564,664,563
   Data.w 664,663,563
   Data.w 565,665,564
   Data.w 665,664,564
   Data.w 566,666,565
   Data.w 666,665,565
   Data.w 567,667,566
   Data.w 667,666,566
   Data.w 568,668,567
   Data.w 668,667,567
   Data.w 569,669,568
   Data.w 669,668,568
   Data.w 570,670,569
   Data.w 670,669,569
   Data.w 571,671,570
   Data.w 671,670,570
   Data.w 572,672,571
   Data.w 672,671,571
   Data.w 573,673,572
   Data.w 673,672,572
   Data.w 574,674,573
   Data.w 674,673,573
   Data.w 575,675,574
   Data.w 675,674,574
   Data.w 576,676,575
   Data.w 676,675,575
   Data.w 577,677,576
   Data.w 677,676,576
   Data.w 578,678,577
   Data.w 678,677,577
   Data.w 579,679,578
   Data.w 679,678,578
   Data.w 580,680,579
   Data.w 680,679,579
   Data.w 581,681,580
   Data.w 681,680,580
   Data.w 582,682,581
   Data.w 682,681,581
   Data.w 583,683,582
   Data.w 683,682,582
   Data.w 584,684,583
   Data.w 684,683,583
   Data.w 585,685,584
   Data.w 685,684,584
   Data.w 586,686,585
   Data.w 686,685,585
   Data.w 587,687,586
   Data.w 687,686,586
   Data.w 588,688,587
   Data.w 688,687,587
   Data.w 589,689,588
   Data.w 689,688,588
   Data.w 590,690,589
   Data.w 690,689,589
   Data.w 591,691,590
   Data.w 691,690,590
   Data.w 592,692,591
   Data.w 692,691,591
   Data.w 593,693,592
   Data.w 693,692,592
   Data.w 594,694,593
   Data.w 694,693,593
   Data.w 595,695,594
   Data.w 695,694,594
   Data.w 596,696,595
   Data.w 696,695,595
   Data.w 597,697,596
   Data.w 697,696,596
   Data.w 598,698,597
   Data.w 698,697,597
   Data.w 599,699,598
   Data.w 699,698,598
   Data.w 600,700,599
   Data.w 700,699,599
   Data.w 601,701,600
   Data.w 701,700,600
   Data.w 602,702,601
   Data.w 702,701,601
   Data.w 603,703,602
   Data.w 703,702,602
   Data.w 604,704,603
   Data.w 704,703,603
   Data.w 605,705,604
   Data.w 705,704,604
   Data.w 606,706,605
   Data.w 706,705,605
   Data.w 607,707,606
   Data.w 707,706,606
   Data.w 608,708,607
   Data.w 708,707,607
   Data.w 609,709,608
   Data.w 709,708,608
   Data.w 610,710,609
   Data.w 710,709,609
   Data.w 611,711,610
   Data.w 711,710,610
   Data.w 612,712,611
   Data.w 712,711,611
   Data.w 613,713,612
   Data.w 713,712,612
   Data.w 614,714,613
   Data.w 714,713,613
   Data.w 615,715,614
   Data.w 715,714,614
   Data.w 616,716,615
   Data.w 716,715,615
   Data.w 617,717,616
   Data.w 717,716,616
   Data.w 618,718,617
   Data.w 718,717,617
   Data.w 720,719,618
   Data.w 719,718,618
   Data.w 722,721,720
   Data.w 721,719,720
   Data.w 724,723,722
   Data.w 723,721,722
   Data.w 726,725,724
   Data.w 725,723,724
   Data.w 728,727,726
   Data.w 727,725,726
   Data.w 730,729,728
   Data.w 729,727,728
   Data.w 732,731,730
   Data.w 731,729,730
   Data.w 734,733,732
   Data.w 733,731,732
   Data.w 736,735,734
   Data.w 735,733,734
   Data.w 738,737,736
   Data.w 737,735,736
   Data.w 740,739,738
   Data.w 739,737,738
   Data.w 742,741,740
   Data.w 741,739,740
   Data.w 743,741,742
   Data.w 745,744,746
   Data.w 744,747,746
   Data.w 749,748,745
   Data.w 748,744,745
   Data.w 751,750,749
   Data.w 750,748,749
   Data.w 753,752,751
   Data.w 752,750,751
   Data.w 755,754,753
   Data.w 754,752,753
   Data.w 757,756,755
   Data.w 756,754,755
   Data.w 759,758,757
   Data.w 758,756,757
   Data.w 621,760,759
   Data.w 760,758,759
   Data.w 619,761,621
   Data.w 761,760,621
   Data.w 622,762,619
   Data.w 762,761,619
   Data.w 623,763,622
   Data.w 763,762,622
   Data.w 624,764,623
   Data.w 764,763,623
   Data.w 625,765,624
   Data.w 765,764,624
   Data.w 626,766,625
   Data.w 766,765,625
   Data.w 627,767,626
   Data.w 767,766,626
   Data.w 628,768,627
   Data.w 768,767,627
   Data.w 629,769,628
   Data.w 769,768,628
   Data.w 630,770,629
   Data.w 770,769,629
   Data.w 631,771,630
   Data.w 771,770,630
   Data.w 632,772,631
   Data.w 772,771,631
   Data.w 633,773,632
   Data.w 773,772,632
   Data.w 535,635,633
   Data.w 635,773,633
   Data.w 693,694,692
   Data.w 694,695,692
   Data.w 646,647,645
   Data.w 695,696,692
   Data.w 645,647,644
   Data.w 644,647,643
   Data.w 773,635,772
   Data.w 772,635,771
   Data.w 643,647,642
   Data.w 771,635,770
   Data.w 696,697,692
   Data.w 697,698,692
   Data.w 698,699,692
   Data.w 699,700,692
   Data.w 642,647,641
   Data.w 700,701,692
   Data.w 770,635,769
   Data.w 635,634,769
   Data.w 634,636,769
   Data.w 636,637,769
   Data.w 637,638,769
   Data.w 638,639,769
   Data.w 639,640,769
   Data.w 691,692,690
   Data.w 690,692,689
   Data.w 689,692,688
   Data.w 688,692,687
   Data.w 687,692,686
   Data.w 686,692,685
   Data.w 685,692,684
   Data.w 684,692,683
   Data.w 683,692,682
   Data.w 692,701,682
   Data.w 682,701,681
   Data.w 681,701,680
   Data.w 701,702,680
   Data.w 680,702,679
   Data.w 679,702,678
   Data.w 702,703,678
   Data.w 703,704,678
   Data.w 678,704,677
   Data.w 704,705,677
   Data.w 677,705,676
   Data.w 705,706,676
   Data.w 676,706,675
   Data.w 675,706,674
   Data.w 706,707,674
   Data.w 674,707,673
   Data.w 673,707,672
   Data.w 672,707,671
   Data.w 671,707,670
   Data.w 670,707,669
   Data.w 669,707,668
   Data.w 668,707,667
   Data.w 707,708,667
   Data.w 708,709,667
   Data.w 709,710,667
   Data.w 710,711,667
   Data.w 711,712,667
   Data.w 712,713,667
   Data.w 713,714,667
   Data.w 714,715,667
   Data.w 715,716,667
   Data.w 716,717,667
   Data.w 717,718,667
   Data.w 743,774,741
   Data.w 774,747,741
   Data.w 741,747,739
   Data.w 747,744,739
   Data.w 744,748,739
   Data.w 739,748,737
   Data.w 748,750,737
   Data.w 737,750,735
   Data.w 750,752,735
   Data.w 735,752,733
   Data.w 733,752,731
   Data.w 752,754,731
   Data.w 731,754,729
   Data.w 754,756,729
   Data.w 729,756,727
   Data.w 727,756,725
   Data.w 756,758,725
   Data.w 725,758,723
   Data.w 758,760,723
   Data.w 723,760,721
   Data.w 721,760,719
   Data.w 719,760,718
   Data.w 718,760,667
   Data.w 760,761,667
   Data.w 761,762,667
   Data.w 762,763,667
   Data.w 763,764,667
   Data.w 764,765,667
   Data.w 765,766,667
   Data.w 766,767,667
   Data.w 667,767,666
   Data.w 767,768,666
   Data.w 768,769,666
   Data.w 769,640,666
   Data.w 666,640,665
   Data.w 665,640,664
   Data.w 664,640,663
   Data.w 663,640,662
   Data.w 662,640,661
   Data.w 661,640,660
   Data.w 660,640,659
   Data.w 640,641,659
   Data.w 641,647,659
   Data.w 647,648,659
   Data.w 659,648,658
   Data.w 658,648,657
   Data.w 657,648,656
   Data.w 656,648,655
   Data.w 655,648,654
   Data.w 648,649,654
   Data.w 649,650,654
   Data.w 650,651,654
   Data.w 651,652,654
   Data.w 654,652,653
   Data.w 775,204,205
   Data.w 204,775,776
   Data.w 776,325,204
   Data.w 777,205,206
   Data.w 777,775,205
   Data.w 778,206,207
   Data.w 778,777,206
   Data.w 779,207,208
   Data.w 779,778,207
   Data.w 780,208,209
   Data.w 780,779,208
   Data.w 781,209,210
   Data.w 781,780,209
   Data.w 782,210,211
   Data.w 782,781,210
   Data.w 783,211,212
   Data.w 211,783,782
   Data.w 784,212,213
   Data.w 783,212,784
   Data.w 785,213,214
   Data.w 213,785,784
   Data.w 786,214,215
   Data.w 786,785,214
   Data.w 787,215,216
   Data.w 215,787,786
   Data.w 788,216,217
   Data.w 788,787,216
   Data.w 789,217,218
   Data.w 217,789,788
   Data.w 790,218,219
   Data.w 218,790,789
   Data.w 220,790,219
   Data.w 791,790,220
   Data.w 221,791,220
   Data.w 792,791,221
   Data.w 222,792,221
   Data.w 793,792,222
   Data.w 223,794,222
   Data.w 222,794,793
   Data.w 224,795,223
   Data.w 795,796,223
   Data.w 796,797,223
   Data.w 797,794,223
   Data.w 798,224,225
   Data.w 224,798,795
   Data.w 798,225,226
   Data.w 799,226,227
   Data.w 227,326,799
   Data.w 226,799,798
   Data.w 800,799,326
   Data.w 325,776,801
   Data.w 801,423,325
   Data.w 327,802,326
   Data.w 802,800,326
   Data.w 425,802,327
   Data.w 425,522,802
   Data.w 801,520,423
   Data.w 803,522,620
   Data.w 620,621,803
   Data.w 802,522,804
   Data.w 803,804,522
   Data.w 520,801,618
   Data.w 618,801,805
   Data.w 805,720,618
   Data.w 720,805,806
   Data.w 806,722,720
   Data.w 722,806,807
   Data.w 807,724,722
   Data.w 724,807,808
   Data.w 808,726,724
   Data.w 726,808,809
   Data.w 809,728,726
   Data.w 728,809,810
   Data.w 810,730,728
   Data.w 730,810,811
   Data.w 811,732,730
   Data.w 732,811,812
   Data.w 812,734,732
   Data.w 813,736,734
   Data.w 813,734,812
   Data.w 736,813,814
   Data.w 814,738,736
   Data.w 738,814,815
   Data.w 815,740,738
   Data.w 740,815,816
   Data.w 816,742,740
   Data.w 742,816,817
   Data.w 742,817,818
   Data.w 818,743,742
   Data.w 819,745,746
   Data.w 746,747,819
   Data.w 745,819,820
   Data.w 820,749,745
   Data.w 749,820,821
   Data.w 821,751,749
   Data.w 822,753,751
   Data.w 822,751,821
   Data.w 822,823,753
   Data.w 823,755,753
   Data.w 755,823,824
   Data.w 824,757,755
   Data.w 757,824,825
   Data.w 825,759,757
   Data.w 825,621,759
   Data.w 621,825,803
   Data.w 818,774,743
   Data.w 774,826,827
   Data.w 827,747,774
   Data.w 774,818,826
   Data.w 747,827,819
   Data.w 790,788,789
   Data.w 790,791,788
   Data.w 787,792,786
   Data.w 791,792,787
   Data.w 787,788,791
   Data.w 785,793,784
   Data.w 792,793,785
   Data.w 785,786,792
   Data.w 783,794,782
   Data.w 783,784,794
   Data.w 784,793,794
   Data.w 775,777,795
   Data.w 796,795,777
   Data.w 797,796,777
   Data.w 777,778,797
   Data.w 794,797,778
   Data.w 778,779,794
   Data.w 779,780,794
   Data.w 780,781,794
   Data.w 781,782,794
   Data.w 798,775,795
   Data.w 799,775,798
   Data.w 799,800,775
   Data.w 800,802,775
   Data.w 802,776,775
   Data.w 801,776,804
   Data.w 802,804,776
   Data.w 804,803,801
   Data.w 803,805,801
   Data.w 817,819,818
   Data.w 815,820,816
   Data.w 816,820,819
   Data.w 819,817,816
   Data.w 813,821,814
   Data.w 814,821,820
   Data.w 820,815,814
   Data.w 811,822,812
   Data.w 822,813,812
   Data.w 822,821,813
   Data.w 807,806,822
   Data.w 822,808,807
   Data.w 823,822,806
   Data.w 822,809,808
   Data.w 823,806,805
   Data.w 822,810,809
   Data.w 822,811,810
   Data.w 805,824,823
   Data.w 805,825,824
   Data.w 825,805,803
   Data.w 818,827,826
   Data.w 827,818,819
EndDataSection


    



; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 355
; FirstLine = 353
; Folding = -
; EnableXP
; Executable = C:\temp\demos\MP_Schachdemo.exe
; SubSystem = dx9